local __exports = LibStub:NewLibrary("ovale/scripts/ovale_druid", 90103)
if not __exports then return end
__exports.registerDruid = function(scripts)
    do
        local name = "sc_t26_druid_balance"
        local desc = "[9.0] Simulationcraft: T26_Druid_Balance"
        local code = [[
# Based on SimulationCraft profile "T26_Druid_Balance".
#	class=druid
#	spec=balance
#	talents=3000231

Include(ovale_common)
Include(ovale_druid_spells)


AddFunction cd_condition
{
 not hasequippeditem(empyreal_ordnance_item) or spellcooldown(empyreal_ordnance) < 160 and not spellcooldown(empyreal_ordnance) <= 0 or iscovenant("kyrian")
}

AddFunction convoke_desync
{
 { fightremains() - 15 - spellcooldown(celestial_alignment) } / 180 == { fightremains() - 15 - 120 - spellcooldown(convoke_the_spirits) } / 180 or spellcooldown(celestial_alignment) > fightremains() or spellcooldown(convoke_the_spirits) > fightremains() or not iscovenant("night_fae")
}

AddFunction is_cleave
{
 enemies(tagged=1) > 1
}

AddFunction is_aoe
{
 enemies(tagged=1) > 1 and { not hastalent(starlord_talent) or hastalent(stellar_drift_talent) } or enemies(tagged=1) > 2
}

AddFunction starfire_in_solar
{
 enemies(tagged=1) > 4 + masteryeffect() / 100 * 100 / 20 + buffstacks(starsurge_empowerment_solar_buff) / 4
}

AddFunction starfall_wont_fall_off
{
 astralpower() > 80 - 10 * buffstacks(timeworn_dreambinder_buff) - buffremaining(starfall) * 3 / { 100 / { 100 + spellcastspeedpercent() } } - target.debuffremaining(fury_of_elune) * 5 and buffpresent(starfall)
}

AddFunction ignore_starsurge
{
 buffpresent(eclipse_lunar_buff) and { enemies(tagged=1) > 4 and hastalent(soul_of_the_forest_talent) or enemies(tagged=1) > 6 }
}

AddFunction dream_will_fall_off
{
 { buffremaining(timeworn_dreambinder_buff) < gcd() + 0.1 or buffremaining(timeworn_dreambinder_buff) < executetime(starfire) + 0.1 and { buffpresent(eclipse_lunar_buff) or counter(solar) == 1 or counter(lunar) + counter(solar) == 1 } } and buffpresent(timeworn_dreambinder_buff) and equippedruneforge(timeworn_dreambinder_runeforge)
}

AddFunction aspPerSec
{
 buffpresent(eclipse_lunar_buff) * 8 / executetime(starfire) + { not buffpresent(eclipse_lunar_buff) * 6 / executetime(wrath_balance) + 0.2 / { 100 / { 100 + spellcastspeedpercent() } } }
}

AddFunction critnotup
{
 not buffpresent(balance_of_all_things_nature_buff) and not buffpresent(balance_of_all_things_arcane_buff)
}

AddFunction safe_to_use_spell
{
 buffremaining(timeworn_dreambinder_buff) > gcd() + 0.1 and { buffpresent(eclipse_solar_buff) and buffpresent(eclipse_lunar_buff) or buffpresent(eclipse_solar_buff) or counter(lunar) == 1 } or buffremaining(timeworn_dreambinder_buff) > executetime(starfire) + 0.1 and { buffpresent(eclipse_lunar_buff) or counter(solar) == 1 or counter(lunar) + counter(solar) == 1 } or not buffpresent(timeworn_dreambinder_buff)
}

AddFunction save_for_ca_inc
{
 not spellcooldown(celestial_alignment) <= 0 or not convoke_desync() and iscovenant("night_fae") or checkboxon("no_cds")
 not spellcooldown(celestial_alignment) <= 0 or not convoke_desync() and iscovenant("night_fae") or checkboxon("no_cds")
}

AddFunction dot_requirements
{
 { buffremaining(celestial_alignment) > 5 and { buffremaining(ravenous_frenzy) > 5 or not buffpresent(ravenous_frenzy) } or not buffpresent(celestial_alignment) or astralpower() < 30 } and { not buffpresent(kindred_empowerment_energize) or astralpower() < 30 } and { buffremaining(eclipse_solar_buff) > gcd() or buffremaining(eclipse_lunar_buff) > gcd() }
 { buffremaining(celestial_alignment) > 5 and { buffremaining(ravenous_frenzy) > 5 or not buffpresent(ravenous_frenzy) } or not buffpresent(celestial_alignment) } and not buffpresent(kindred_empowerment_energize) and { buffremaining(eclipse_solar_buff) > gcd() or buffremaining(eclipse_lunar_buff) > gcd() }
}

AddCheckBox(opt_interrupt l(interrupt) default enabled=(specialization(balance)))
AddCheckBox(opt_use_consumables l(opt_use_consumables) default enabled=(specialization(balance)))
AddCheckBox(no_cds l(no_cds) default enabled=(specialization(balance)))

AddFunction balanceinterruptactions
{
 if checkboxon(opt_interrupt) and not target.isfriend() and target.casting()
 {
  if target.inrange(solar_beam) and target.isinterruptible() spell(solar_beam)
  if target.inrange(mighty_bash) and not target.classification(worldboss) spell(mighty_bash)
  if target.distance() < 5 and not target.classification(worldboss) spell(war_stomp)
  if target.distance() < 15 and not target.classification(worldboss) spell(typhoon)
 }
}

AddFunction balanceuseitemactions
{
 item(trinket0slot text=13 usable=1)
 item(trinket1slot text=14 usable=1)
}

### actions.st

AddFunction balancestmainactions
{
 #adaptive_swarm,target_if=!dot.adaptive_swarm_damage.ticking&!action.adaptive_swarm_damage.in_flight&(!dot.adaptive_swarm_heal.ticking|dot.adaptive_swarm_heal.remains>5)|dot.adaptive_swarm_damage.stack<3&dot.adaptive_swarm_damage.remains<3&dot.adaptive_swarm_damage.ticking
 if not target.debuffpresent(adaptive_swarm_damage) and not inflighttotarget(adaptive_swarm_damage) and { not target.debuffpresent(adaptive_swarm) or target.debuffremaining(adaptive_swarm) > 5 } or target.debuffstacks(adaptive_swarm_damage) < 3 and target.debuffremaining(adaptive_swarm_damage) < 3 and target.debuffpresent(adaptive_swarm_damage) spell(adaptive_swarm)
 #variable,name=dot_requirements,value=(buff.ca_inc.remains>5&(buff.ravenous_frenzy.remains>5|!buff.ravenous_frenzy.up)|!buff.ca_inc.up|astral_power<30)&(!buff.kindred_empowerment_energize.up|astral_power<30)&(buff.eclipse_solar.remains>gcd.max|buff.eclipse_lunar.remains>gcd.max)
 #moonfire,target_if=refreshable&target.time_to_die>12,if=ap_check&variable.dot_requirements
 if target.refreshable(moonfire_debuff) and target.timetodie() > 12 and { astralpower() >= astralpowercost(moonfire) and dot_requirements() } spell(moonfire)
 #sunfire,target_if=refreshable&target.time_to_die>12,if=ap_check&variable.dot_requirements
 if target.refreshable(sunfire_debuff) and target.timetodie() > 12 and { astralpower() >= astralpowercost(sunfire) and dot_requirements() } spell(sunfire)
 #stellar_flare,target_if=refreshable&target.time_to_die>16,if=ap_check&variable.dot_requirements
 if target.refreshable(stellar_flare) and target.timetodie() > 16 and { astralpower() >= astralpowercost(stellar_flare) and dot_requirements() } spell(stellar_flare)
 #kindred_spirits,if=((buff.eclipse_solar.remains>10|buff.eclipse_lunar.remains>10)&cooldown.ca_inc.remains>30&(buff.primordial_arcanic_pulsar.value<240|!runeforge.primordial_arcanic_pulsar.equipped))|buff.primordial_arcanic_pulsar.value>=270|cooldown.ca_inc.ready&(astral_power>90|variable.is_aoe)
 if { buffremaining(eclipse_solar_buff) > 10 or buffremaining(eclipse_lunar_buff) > 10 } and spellcooldown(celestial_alignment) > 30 and { buffamount(primordial_arcanic_pulsar_buff) < 240 or not equippedruneforge(primordial_arcanic_pulsar_runeforge) } or buffamount(primordial_arcanic_pulsar_buff) >= 270 or spellcooldown(celestial_alignment) <= 0 and { astralpower() > 90 or is_aoe() } spell(kindred_spirits)
 #incarnation,if=!druid.no_cds&variable.cd_condition&(astral_power>90&(buff.kindred_empowerment_energize.up|!covenant.kyrian)|covenant.night_fae|variable.is_aoe|buff.bloodlust.up&buff.bloodlust.remains<30+((9*runeforge.primordial_arcanic_pulsar.equipped)+(conduit.precise_alignment.time_value)))&!buff.ca_inc.up&(!covenant.night_fae|cooldown.convoke_the_spirits.up|interpolated_fight_remains<cooldown.convoke_the_spirits.remains+6|interpolated_fight_remains%%180<30+(conduit.precise_alignment.time_value))
 if not checkboxon("no_cds") and cd_condition() and { astralpower() > 90 and { buffpresent(kindred_empowerment_energize) or not iscovenant("kyrian") } or iscovenant("night_fae") or is_aoe() or buffpresent(bloodlust) and buffremaining(bloodlust) < 30 + 9 * equippedruneforge(primordial_arcanic_pulsar_runeforge) + conduitvalue(precise_alignment_conduit) } and not buffpresent(celestial_alignment) and { not iscovenant("night_fae") or not spellcooldown(convoke_the_spirits) > 0 or fightremains() < spellcooldown(convoke_the_spirits) + 6 or fightremains() % 180 < 30 + conduitvalue(precise_alignment_conduit) } spell(incarnation)
 #starfall,if=buff.oneths_perception.up&buff.starfall.refreshable
 if buffpresent(oneths_perception_buff) and buffrefreshable(starfall) spell(starfall)
 #cancel_buff,name=starlord,if=buff.starlord.remains<5&(buff.eclipse_solar.remains>5|buff.eclipse_lunar.remains>5)&astral_power>90
 if buffremaining(starlord_buff) < 5 and { buffremaining(eclipse_solar_buff) > 5 or buffremaining(eclipse_lunar_buff) > 5 } and astralpower() > 90 and buffpresent(starlord_buff) texture(starlord_buff text=cancel)
 #starsurge,if=covenant.night_fae&variable.convoke_desync&cooldown.convoke_the_spirits.remains<5&!druid.no_cds
 if iscovenant("night_fae") and convoke_desync() and spellcooldown(convoke_the_spirits) < 5 and not checkboxon("no_cds") spell(starsurge)
 #starfall,if=talent.stellar_drift.enabled&!talent.starlord.enabled&buff.starfall.refreshable&(buff.eclipse_lunar.remains>6&eclipse.in_lunar&buff.primordial_arcanic_pulsar.value<250|buff.primordial_arcanic_pulsar.value>=250&astral_power>90|dot.adaptive_swarm_damage.remains>8|action.adaptive_swarm_damage.in_flight)&!cooldown.ca_inc.ready
 if hastalent(stellar_drift_talent) and not hastalent(starlord_talent) and buffrefreshable(starfall) and { buffremaining(eclipse_lunar_buff) > 6 and buffpresent(eclipse_lunar_buff) and buffamount(primordial_arcanic_pulsar_buff) < 250 or buffamount(primordial_arcanic_pulsar_buff) >= 250 and astralpower() > 90 or target.debuffremaining(adaptive_swarm_damage) > 8 or inflighttotarget(adaptive_swarm_damage) } and not spellcooldown(celestial_alignment) <= 0 spell(starfall)
 #starsurge,if=buff.oneths_clear_vision.up|buff.kindred_empowerment_energize.up|buff.ca_inc.up&(buff.ravenous_frenzy.remains<gcd.max*ceil(astral_power%30)&buff.ravenous_frenzy.up|!buff.ravenous_frenzy.up&!cooldown.ravenous_frenzy.ready|!covenant.venthyr)|astral_power>90&eclipse.in_any
 if buffpresent(oneths_clear_vision_buff) or buffpresent(kindred_empowerment_energize) or buffpresent(celestial_alignment) and { buffremaining(ravenous_frenzy) < gcd() * { astralpower() / 30 } and buffpresent(ravenous_frenzy) or not buffpresent(ravenous_frenzy) and not spellcooldown(ravenous_frenzy) <= 0 or not iscovenant("venthyr") } or astralpower() > 90 and buffpresent(eclipse_any) spell(starsurge)
 #starsurge,if=talent.starlord.enabled&(buff.starlord.up|astral_power>90)&buff.starlord.stack<3&(buff.eclipse_solar.up|buff.eclipse_lunar.up)&buff.primordial_arcanic_pulsar.value<270&(cooldown.ca_inc.remains>10|!variable.convoke_desync&covenant.night_fae)
 if hastalent(starlord_talent) and { buffpresent(starlord_buff) or astralpower() > 90 } and buffstacks(starlord_buff) < 3 and { buffpresent(eclipse_solar_buff) or buffpresent(eclipse_lunar_buff) } and buffamount(primordial_arcanic_pulsar_buff) < 270 and { spellcooldown(celestial_alignment) > 10 or not convoke_desync() and iscovenant("night_fae") } spell(starsurge)
 #starsurge,if=(buff.primordial_arcanic_pulsar.value<270|buff.primordial_arcanic_pulsar.value<250&talent.stellar_drift.enabled)&buff.eclipse_solar.remains>7&eclipse.in_solar&!buff.oneths_perception.up&!talent.starlord.enabled&cooldown.ca_inc.remains>7&(cooldown.kindred_spirits.remains>7|!covenant.kyrian)
 if { buffamount(primordial_arcanic_pulsar_buff) < 270 or buffamount(primordial_arcanic_pulsar_buff) < 250 and hastalent(stellar_drift_talent) } and buffremaining(eclipse_solar_buff) > 7 and buffpresent(eclipse_solar_buff) and not buffpresent(oneths_perception_buff) and not hastalent(starlord_talent) and spellcooldown(celestial_alignment) > 7 and { spellcooldown(kindred_spirits) > 7 or not iscovenant("kyrian") } spell(starsurge)
 #new_moon,if=(buff.eclipse_lunar.up|(charges=2&recharge_time<5)|charges=3)&ap_check&variable.save_for_ca_inc
 if { buffpresent(eclipse_lunar_buff) or charges(new_moon) == 2 and spellchargecooldown(new_moon) < 5 or charges(new_moon) == 3 } and astralpower() >= astralpowercost(new_moon) and save_for_ca_inc() and { not spellknown(half_moon) and not spellknown(full_moon) } spell(new_moon)
 #half_moon,if=(buff.eclipse_lunar.up&!covenant.kyrian|(buff.kindred_empowerment_energize.up&covenant.kyrian)|(charges=2&recharge_time<5)|charges=3|buff.ca_inc.up)&ap_check&variable.save_for_ca_inc
 if { buffpresent(eclipse_lunar_buff) and not iscovenant("kyrian") or buffpresent(kindred_empowerment_energize) and iscovenant("kyrian") or charges(half_moon) == 2 and spellchargecooldown(half_moon) < 5 or charges(half_moon) == 3 or buffpresent(celestial_alignment) } and astralpower() >= astralpowercost(half_moon) and save_for_ca_inc() and spellknown(half_moon) spell(half_moon)
 #full_moon,if=(buff.eclipse_lunar.up&!covenant.kyrian|(buff.kindred_empowerment_energize.up&covenant.kyrian)|(charges=2&recharge_time<5)|charges=3|buff.ca_inc.up)&ap_check&variable.save_for_ca_inc
 if { buffpresent(eclipse_lunar_buff) and not iscovenant("kyrian") or buffpresent(kindred_empowerment_energize) and iscovenant("kyrian") or charges(full_moon) == 2 and spellchargecooldown(full_moon) < 5 or charges(full_moon) == 3 or buffpresent(celestial_alignment) } and astralpower() >= astralpowercost(full_moon) and save_for_ca_inc() and spellknown(full_moon) spell(full_moon)
 #starfire,if=eclipse.in_lunar|eclipse.solar_next|eclipse.any_next|buff.warrior_of_elune.up&buff.eclipse_lunar.up|(buff.ca_inc.remains<action.wrath.execute_time&buff.ca_inc.up)
 if buffpresent(eclipse_lunar_buff) or counter(solar) == 1 or counter(lunar) + counter(solar) == 1 or buffpresent(warrior_of_elune) and buffpresent(eclipse_lunar_buff) or buffremaining(celestial_alignment) < executetime(wrath_balance) and buffpresent(celestial_alignment) spell(starfire)
 #wrath
 spell(wrath_balance)
 #run_action_list,name=fallthru
 balancefallthrumainactions()
}

AddFunction balancestmainpostconditions
{
 balancefallthrumainpostconditions()
}

AddFunction balancestshortcdactions
{
 unless { not target.debuffpresent(adaptive_swarm_damage) and not inflighttotarget(adaptive_swarm_damage) and { not target.debuffpresent(adaptive_swarm) or target.debuffremaining(adaptive_swarm) > 5 } or target.debuffstacks(adaptive_swarm_damage) < 3 and target.debuffremaining(adaptive_swarm_damage) < 3 and target.debuffpresent(adaptive_swarm_damage) } and spell(adaptive_swarm) or target.refreshable(moonfire_debuff) and target.timetodie() > 12 and { astralpower() >= astralpowercost(moonfire) and dot_requirements() } and spell(moonfire) or target.refreshable(sunfire_debuff) and target.timetodie() > 12 and { astralpower() >= astralpowercost(sunfire) and dot_requirements() } and spell(sunfire) or target.refreshable(stellar_flare) and target.timetodie() > 16 and { astralpower() >= astralpowercost(stellar_flare) and dot_requirements() } and spell(stellar_flare)
 {
  #force_of_nature,if=ap_check
  if astralpower() >= astralpowercost(force_of_nature) spell(force_of_nature)

  unless { { buffremaining(eclipse_solar_buff) > 10 or buffremaining(eclipse_lunar_buff) > 10 } and spellcooldown(celestial_alignment) > 30 and { buffamount(primordial_arcanic_pulsar_buff) < 240 or not equippedruneforge(primordial_arcanic_pulsar_runeforge) } or buffamount(primordial_arcanic_pulsar_buff) >= 270 or spellcooldown(celestial_alignment) <= 0 and { astralpower() > 90 or is_aoe() } } and spell(kindred_spirits) or not checkboxon("no_cds") and cd_condition() and { astralpower() > 90 and { buffpresent(kindred_empowerment_energize) or not iscovenant("kyrian") } or iscovenant("night_fae") or is_aoe() or buffpresent(bloodlust) and buffremaining(bloodlust) < 30 + 9 * equippedruneforge(primordial_arcanic_pulsar_runeforge) + conduitvalue(precise_alignment_conduit) } and not buffpresent(celestial_alignment) and { not iscovenant("night_fae") or not spellcooldown(convoke_the_spirits) > 0 or fightremains() < spellcooldown(convoke_the_spirits) + 6 or fightremains() % 180 < 30 + conduitvalue(precise_alignment_conduit) } and spell(incarnation)
  {
   #variable,name=save_for_ca_inc,value=!cooldown.ca_inc.ready|!variable.convoke_desync&covenant.night_fae|druid.no_cds
   #fury_of_elune,if=eclipse.in_any&ap_check&buff.primordial_arcanic_pulsar.value<240&(dot.adaptive_swarm_damage.ticking|!covenant.necrolord)&variable.save_for_ca_inc
   if buffpresent(eclipse_any) and astralpower() >= astralpowercost(fury_of_elune) and buffamount(primordial_arcanic_pulsar_buff) < 240 and { target.debuffpresent(adaptive_swarm_damage) or not iscovenant("necrolord") } and save_for_ca_inc() spell(fury_of_elune)

   unless buffpresent(oneths_perception_buff) and buffrefreshable(starfall) and spell(starfall) or buffremaining(starlord_buff) < 5 and { buffremaining(eclipse_solar_buff) > 5 or buffremaining(eclipse_lunar_buff) > 5 } and astralpower() > 90 and buffpresent(starlord_buff) and texture(starlord_buff text=cancel) or iscovenant("night_fae") and convoke_desync() and spellcooldown(convoke_the_spirits) < 5 and not checkboxon("no_cds") and spell(starsurge) or hastalent(stellar_drift_talent) and not hastalent(starlord_talent) and buffrefreshable(starfall) and { buffremaining(eclipse_lunar_buff) > 6 and buffpresent(eclipse_lunar_buff) and buffamount(primordial_arcanic_pulsar_buff) < 250 or buffamount(primordial_arcanic_pulsar_buff) >= 250 and astralpower() > 90 or target.debuffremaining(adaptive_swarm_damage) > 8 or inflighttotarget(adaptive_swarm_damage) } and not spellcooldown(celestial_alignment) <= 0 and spell(starfall) or { buffpresent(oneths_clear_vision_buff) or buffpresent(kindred_empowerment_energize) or buffpresent(celestial_alignment) and { buffremaining(ravenous_frenzy) < gcd() * { astralpower() / 30 } and buffpresent(ravenous_frenzy) or not buffpresent(ravenous_frenzy) and not spellcooldown(ravenous_frenzy) <= 0 or not iscovenant("venthyr") } or astralpower() > 90 and buffpresent(eclipse_any) } and spell(starsurge) or hastalent(starlord_talent) and { buffpresent(starlord_buff) or astralpower() > 90 } and buffstacks(starlord_buff) < 3 and { buffpresent(eclipse_solar_buff) or buffpresent(eclipse_lunar_buff) } and buffamount(primordial_arcanic_pulsar_buff) < 270 and { spellcooldown(celestial_alignment) > 10 or not convoke_desync() and iscovenant("night_fae") } and spell(starsurge) or { buffamount(primordial_arcanic_pulsar_buff) < 270 or buffamount(primordial_arcanic_pulsar_buff) < 250 and hastalent(stellar_drift_talent) } and buffremaining(eclipse_solar_buff) > 7 and buffpresent(eclipse_solar_buff) and not buffpresent(oneths_perception_buff) and not hastalent(starlord_talent) and spellcooldown(celestial_alignment) > 7 and { spellcooldown(kindred_spirits) > 7 or not iscovenant("kyrian") } and spell(starsurge) or { buffpresent(eclipse_lunar_buff) or charges(new_moon) == 2 and spellchargecooldown(new_moon) < 5 or charges(new_moon) == 3 } and astralpower() >= astralpowercost(new_moon) and save_for_ca_inc() and { not spellknown(half_moon) and not spellknown(full_moon) } and spell(new_moon) or { buffpresent(eclipse_lunar_buff) and not iscovenant("kyrian") or buffpresent(kindred_empowerment_energize) and iscovenant("kyrian") or charges(half_moon) == 2 and spellchargecooldown(half_moon) < 5 or charges(half_moon) == 3 or buffpresent(celestial_alignment) } and astralpower() >= astralpowercost(half_moon) and save_for_ca_inc() and spellknown(half_moon) and spell(half_moon) or { buffpresent(eclipse_lunar_buff) and not iscovenant("kyrian") or buffpresent(kindred_empowerment_energize) and iscovenant("kyrian") or charges(full_moon) == 2 and spellchargecooldown(full_moon) < 5 or charges(full_moon) == 3 or buffpresent(celestial_alignment) } and astralpower() >= astralpowercost(full_moon) and save_for_ca_inc() and spellknown(full_moon) and spell(full_moon)
   {
    #warrior_of_elune
    spell(warrior_of_elune)

    unless { buffpresent(eclipse_lunar_buff) or counter(solar) == 1 or counter(lunar) + counter(solar) == 1 or buffpresent(warrior_of_elune) and buffpresent(eclipse_lunar_buff) or buffremaining(celestial_alignment) < executetime(wrath_balance) and buffpresent(celestial_alignment) } and spell(starfire) or spell(wrath_balance)
    {
     #run_action_list,name=fallthru
     balancefallthrushortcdactions()
    }
   }
  }
 }
}

AddFunction balancestshortcdpostconditions
{
 { not target.debuffpresent(adaptive_swarm_damage) and not inflighttotarget(adaptive_swarm_damage) and { not target.debuffpresent(adaptive_swarm) or target.debuffremaining(adaptive_swarm) > 5 } or target.debuffstacks(adaptive_swarm_damage) < 3 and target.debuffremaining(adaptive_swarm_damage) < 3 and target.debuffpresent(adaptive_swarm_damage) } and spell(adaptive_swarm) or target.refreshable(moonfire_debuff) and target.timetodie() > 12 and { astralpower() >= astralpowercost(moonfire) and dot_requirements() } and spell(moonfire) or target.refreshable(sunfire_debuff) and target.timetodie() > 12 and { astralpower() >= astralpowercost(sunfire) and dot_requirements() } and spell(sunfire) or target.refreshable(stellar_flare) and target.timetodie() > 16 and { astralpower() >= astralpowercost(stellar_flare) and dot_requirements() } and spell(stellar_flare) or { { buffremaining(eclipse_solar_buff) > 10 or buffremaining(eclipse_lunar_buff) > 10 } and spellcooldown(celestial_alignment) > 30 and { buffamount(primordial_arcanic_pulsar_buff) < 240 or not equippedruneforge(primordial_arcanic_pulsar_runeforge) } or buffamount(primordial_arcanic_pulsar_buff) >= 270 or spellcooldown(celestial_alignment) <= 0 and { astralpower() > 90 or is_aoe() } } and spell(kindred_spirits) or not checkboxon("no_cds") and cd_condition() and { astralpower() > 90 and { buffpresent(kindred_empowerment_energize) or not iscovenant("kyrian") } or iscovenant("night_fae") or is_aoe() or buffpresent(bloodlust) and buffremaining(bloodlust) < 30 + 9 * equippedruneforge(primordial_arcanic_pulsar_runeforge) + conduitvalue(precise_alignment_conduit) } and not buffpresent(celestial_alignment) and { not iscovenant("night_fae") or not spellcooldown(convoke_the_spirits) > 0 or fightremains() < spellcooldown(convoke_the_spirits) + 6 or fightremains() % 180 < 30 + conduitvalue(precise_alignment_conduit) } and spell(incarnation) or buffpresent(oneths_perception_buff) and buffrefreshable(starfall) and spell(starfall) or buffremaining(starlord_buff) < 5 and { buffremaining(eclipse_solar_buff) > 5 or buffremaining(eclipse_lunar_buff) > 5 } and astralpower() > 90 and buffpresent(starlord_buff) and texture(starlord_buff text=cancel) or iscovenant("night_fae") and convoke_desync() and spellcooldown(convoke_the_spirits) < 5 and not checkboxon("no_cds") and spell(starsurge) or hastalent(stellar_drift_talent) and not hastalent(starlord_talent) and buffrefreshable(starfall) and { buffremaining(eclipse_lunar_buff) > 6 and buffpresent(eclipse_lunar_buff) and buffamount(primordial_arcanic_pulsar_buff) < 250 or buffamount(primordial_arcanic_pulsar_buff) >= 250 and astralpower() > 90 or target.debuffremaining(adaptive_swarm_damage) > 8 or inflighttotarget(adaptive_swarm_damage) } and not spellcooldown(celestial_alignment) <= 0 and spell(starfall) or { buffpresent(oneths_clear_vision_buff) or buffpresent(kindred_empowerment_energize) or buffpresent(celestial_alignment) and { buffremaining(ravenous_frenzy) < gcd() * { astralpower() / 30 } and buffpresent(ravenous_frenzy) or not buffpresent(ravenous_frenzy) and not spellcooldown(ravenous_frenzy) <= 0 or not iscovenant("venthyr") } or astralpower() > 90 and buffpresent(eclipse_any) } and spell(starsurge) or hastalent(starlord_talent) and { buffpresent(starlord_buff) or astralpower() > 90 } and buffstacks(starlord_buff) < 3 and { buffpresent(eclipse_solar_buff) or buffpresent(eclipse_lunar_buff) } and buffamount(primordial_arcanic_pulsar_buff) < 270 and { spellcooldown(celestial_alignment) > 10 or not convoke_desync() and iscovenant("night_fae") } and spell(starsurge) or { buffamount(primordial_arcanic_pulsar_buff) < 270 or buffamount(primordial_arcanic_pulsar_buff) < 250 and hastalent(stellar_drift_talent) } and buffremaining(eclipse_solar_buff) > 7 and buffpresent(eclipse_solar_buff) and not buffpresent(oneths_perception_buff) and not hastalent(starlord_talent) and spellcooldown(celestial_alignment) > 7 and { spellcooldown(kindred_spirits) > 7 or not iscovenant("kyrian") } and spell(starsurge) or { buffpresent(eclipse_lunar_buff) or charges(new_moon) == 2 and spellchargecooldown(new_moon) < 5 or charges(new_moon) == 3 } and astralpower() >= astralpowercost(new_moon) and save_for_ca_inc() and { not spellknown(half_moon) and not spellknown(full_moon) } and spell(new_moon) or { buffpresent(eclipse_lunar_buff) and not iscovenant("kyrian") or buffpresent(kindred_empowerment_energize) and iscovenant("kyrian") or charges(half_moon) == 2 and spellchargecooldown(half_moon) < 5 or charges(half_moon) == 3 or buffpresent(celestial_alignment) } and astralpower() >= astralpowercost(half_moon) and save_for_ca_inc() and spellknown(half_moon) and spell(half_moon) or { buffpresent(eclipse_lunar_buff) and not iscovenant("kyrian") or buffpresent(kindred_empowerment_energize) and iscovenant("kyrian") or charges(full_moon) == 2 and spellchargecooldown(full_moon) < 5 or charges(full_moon) == 3 or buffpresent(celestial_alignment) } and astralpower() >= astralpowercost(full_moon) and save_for_ca_inc() and spellknown(full_moon) and spell(full_moon) or { buffpresent(eclipse_lunar_buff) or counter(solar) == 1 or counter(lunar) + counter(solar) == 1 or buffpresent(warrior_of_elune) and buffpresent(eclipse_lunar_buff) or buffremaining(celestial_alignment) < executetime(wrath_balance) and buffpresent(celestial_alignment) } and spell(starfire) or spell(wrath_balance) or balancefallthrushortcdpostconditions()
}

AddFunction balancestcdactions
{
 unless { not target.debuffpresent(adaptive_swarm_damage) and not inflighttotarget(adaptive_swarm_damage) and { not target.debuffpresent(adaptive_swarm) or target.debuffremaining(adaptive_swarm) > 5 } or target.debuffstacks(adaptive_swarm_damage) < 3 and target.debuffremaining(adaptive_swarm_damage) < 3 and target.debuffpresent(adaptive_swarm_damage) } and spell(adaptive_swarm)
 {
  #convoke_the_spirits,if=!druid.no_cds&((variable.convoke_desync&!cooldown.ca_inc.ready|buff.ca_inc.up)&astral_power<40&(buff.eclipse_lunar.remains>10|buff.eclipse_solar.remains>10)|fight_remains<10)
  if not checkboxon("no_cds") and { { convoke_desync() and not spellcooldown(celestial_alignment) <= 0 or buffpresent(celestial_alignment) } and astralpower() < 40 and { buffremaining(eclipse_lunar_buff) > 10 or buffremaining(eclipse_solar_buff) > 10 } or fightremains() < 10 } spell(convoke_the_spirits)

  unless target.refreshable(moonfire_debuff) and target.timetodie() > 12 and { astralpower() >= astralpowercost(moonfire) and dot_requirements() } and spell(moonfire) or target.refreshable(sunfire_debuff) and target.timetodie() > 12 and { astralpower() >= astralpowercost(sunfire) and dot_requirements() } and spell(sunfire) or target.refreshable(stellar_flare) and target.timetodie() > 16 and { astralpower() >= astralpowercost(stellar_flare) and dot_requirements() } and spell(stellar_flare) or astralpower() >= astralpowercost(force_of_nature) and spell(force_of_nature)
  {
   #ravenous_frenzy,if=buff.ca_inc.up
   if buffpresent(celestial_alignment) spell(ravenous_frenzy)

   unless { { buffremaining(eclipse_solar_buff) > 10 or buffremaining(eclipse_lunar_buff) > 10 } and spellcooldown(celestial_alignment) > 30 and { buffamount(primordial_arcanic_pulsar_buff) < 240 or not equippedruneforge(primordial_arcanic_pulsar_runeforge) } or buffamount(primordial_arcanic_pulsar_buff) >= 270 or spellcooldown(celestial_alignment) <= 0 and { astralpower() > 90 or is_aoe() } } and spell(kindred_spirits)
   {
    #celestial_alignment,if=!druid.no_cds&variable.cd_condition&(astral_power>90&(buff.kindred_empowerment_energize.up|!covenant.kyrian)|covenant.night_fae|variable.is_aoe|buff.bloodlust.up&buff.bloodlust.remains<20+((9*runeforge.primordial_arcanic_pulsar.equipped)+(conduit.precise_alignment.time_value)))&!buff.ca_inc.up&(!covenant.night_fae|cooldown.convoke_the_spirits.up|interpolated_fight_remains<cooldown.convoke_the_spirits.remains+6|interpolated_fight_remains%%180<20+(conduit.precise_alignment.time_value))
    if not checkboxon("no_cds") and cd_condition() and { astralpower() > 90 and { buffpresent(kindred_empowerment_energize) or not iscovenant("kyrian") } or iscovenant("night_fae") or is_aoe() or buffpresent(bloodlust) and buffremaining(bloodlust) < 20 + 9 * equippedruneforge(primordial_arcanic_pulsar_runeforge) + conduitvalue(precise_alignment_conduit) } and not buffpresent(celestial_alignment) and { not iscovenant("night_fae") or not spellcooldown(convoke_the_spirits) > 0 or fightremains() < spellcooldown(convoke_the_spirits) + 6 or fightremains() % 180 < 20 + conduitvalue(precise_alignment_conduit) } spell(celestial_alignment)

    unless not checkboxon("no_cds") and cd_condition() and { astralpower() > 90 and { buffpresent(kindred_empowerment_energize) or not iscovenant("kyrian") } or iscovenant("night_fae") or is_aoe() or buffpresent(bloodlust) and buffremaining(bloodlust) < 30 + 9 * equippedruneforge(primordial_arcanic_pulsar_runeforge) + conduitvalue(precise_alignment_conduit) } and not buffpresent(celestial_alignment) and { not iscovenant("night_fae") or not spellcooldown(convoke_the_spirits) > 0 or fightremains() < spellcooldown(convoke_the_spirits) + 6 or fightremains() % 180 < 30 + conduitvalue(precise_alignment_conduit) } and spell(incarnation) or buffpresent(eclipse_any) and astralpower() >= astralpowercost(fury_of_elune) and buffamount(primordial_arcanic_pulsar_buff) < 240 and { target.debuffpresent(adaptive_swarm_damage) or not iscovenant("necrolord") } and save_for_ca_inc() and spell(fury_of_elune) or buffpresent(oneths_perception_buff) and buffrefreshable(starfall) and spell(starfall) or buffremaining(starlord_buff) < 5 and { buffremaining(eclipse_solar_buff) > 5 or buffremaining(eclipse_lunar_buff) > 5 } and astralpower() > 90 and buffpresent(starlord_buff) and texture(starlord_buff text=cancel) or iscovenant("night_fae") and convoke_desync() and spellcooldown(convoke_the_spirits) < 5 and not checkboxon("no_cds") and spell(starsurge) or hastalent(stellar_drift_talent) and not hastalent(starlord_talent) and buffrefreshable(starfall) and { buffremaining(eclipse_lunar_buff) > 6 and buffpresent(eclipse_lunar_buff) and buffamount(primordial_arcanic_pulsar_buff) < 250 or buffamount(primordial_arcanic_pulsar_buff) >= 250 and astralpower() > 90 or target.debuffremaining(adaptive_swarm_damage) > 8 or inflighttotarget(adaptive_swarm_damage) } and not spellcooldown(celestial_alignment) <= 0 and spell(starfall) or { buffpresent(oneths_clear_vision_buff) or buffpresent(kindred_empowerment_energize) or buffpresent(celestial_alignment) and { buffremaining(ravenous_frenzy) < gcd() * { astralpower() / 30 } and buffpresent(ravenous_frenzy) or not buffpresent(ravenous_frenzy) and not spellcooldown(ravenous_frenzy) <= 0 or not iscovenant("venthyr") } or astralpower() > 90 and buffpresent(eclipse_any) } and spell(starsurge) or hastalent(starlord_talent) and { buffpresent(starlord_buff) or astralpower() > 90 } and buffstacks(starlord_buff) < 3 and { buffpresent(eclipse_solar_buff) or buffpresent(eclipse_lunar_buff) } and buffamount(primordial_arcanic_pulsar_buff) < 270 and { spellcooldown(celestial_alignment) > 10 or not convoke_desync() and iscovenant("night_fae") } and spell(starsurge) or { buffamount(primordial_arcanic_pulsar_buff) < 270 or buffamount(primordial_arcanic_pulsar_buff) < 250 and hastalent(stellar_drift_talent) } and buffremaining(eclipse_solar_buff) > 7 and buffpresent(eclipse_solar_buff) and not buffpresent(oneths_perception_buff) and not hastalent(starlord_talent) and spellcooldown(celestial_alignment) > 7 and { spellcooldown(kindred_spirits) > 7 or not iscovenant("kyrian") } and spell(starsurge) or { buffpresent(eclipse_lunar_buff) or charges(new_moon) == 2 and spellchargecooldown(new_moon) < 5 or charges(new_moon) == 3 } and astralpower() >= astralpowercost(new_moon) and save_for_ca_inc() and { not spellknown(half_moon) and not spellknown(full_moon) } and spell(new_moon) or { buffpresent(eclipse_lunar_buff) and not iscovenant("kyrian") or buffpresent(kindred_empowerment_energize) and iscovenant("kyrian") or charges(half_moon) == 2 and spellchargecooldown(half_moon) < 5 or charges(half_moon) == 3 or buffpresent(celestial_alignment) } and astralpower() >= astralpowercost(half_moon) and save_for_ca_inc() and spellknown(half_moon) and spell(half_moon) or { buffpresent(eclipse_lunar_buff) and not iscovenant("kyrian") or buffpresent(kindred_empowerment_energize) and iscovenant("kyrian") or charges(full_moon) == 2 and spellchargecooldown(full_moon) < 5 or charges(full_moon) == 3 or buffpresent(celestial_alignment) } and astralpower() >= astralpowercost(full_moon) and save_for_ca_inc() and spellknown(full_moon) and spell(full_moon) or spell(warrior_of_elune) or { buffpresent(eclipse_lunar_buff) or counter(solar) == 1 or counter(lunar) + counter(solar) == 1 or buffpresent(warrior_of_elune) and buffpresent(eclipse_lunar_buff) or buffremaining(celestial_alignment) < executetime(wrath_balance) and buffpresent(celestial_alignment) } and spell(starfire) or spell(wrath_balance)
    {
     #run_action_list,name=fallthru
     balancefallthrucdactions()
    }
   }
  }
 }
}

AddFunction balancestcdpostconditions
{
 { not target.debuffpresent(adaptive_swarm_damage) and not inflighttotarget(adaptive_swarm_damage) and { not target.debuffpresent(adaptive_swarm) or target.debuffremaining(adaptive_swarm) > 5 } or target.debuffstacks(adaptive_swarm_damage) < 3 and target.debuffremaining(adaptive_swarm_damage) < 3 and target.debuffpresent(adaptive_swarm_damage) } and spell(adaptive_swarm) or target.refreshable(moonfire_debuff) and target.timetodie() > 12 and { astralpower() >= astralpowercost(moonfire) and dot_requirements() } and spell(moonfire) or target.refreshable(sunfire_debuff) and target.timetodie() > 12 and { astralpower() >= astralpowercost(sunfire) and dot_requirements() } and spell(sunfire) or target.refreshable(stellar_flare) and target.timetodie() > 16 and { astralpower() >= astralpowercost(stellar_flare) and dot_requirements() } and spell(stellar_flare) or astralpower() >= astralpowercost(force_of_nature) and spell(force_of_nature) or { { buffremaining(eclipse_solar_buff) > 10 or buffremaining(eclipse_lunar_buff) > 10 } and spellcooldown(celestial_alignment) > 30 and { buffamount(primordial_arcanic_pulsar_buff) < 240 or not equippedruneforge(primordial_arcanic_pulsar_runeforge) } or buffamount(primordial_arcanic_pulsar_buff) >= 270 or spellcooldown(celestial_alignment) <= 0 and { astralpower() > 90 or is_aoe() } } and spell(kindred_spirits) or not checkboxon("no_cds") and cd_condition() and { astralpower() > 90 and { buffpresent(kindred_empowerment_energize) or not iscovenant("kyrian") } or iscovenant("night_fae") or is_aoe() or buffpresent(bloodlust) and buffremaining(bloodlust) < 30 + 9 * equippedruneforge(primordial_arcanic_pulsar_runeforge) + conduitvalue(precise_alignment_conduit) } and not buffpresent(celestial_alignment) and { not iscovenant("night_fae") or not spellcooldown(convoke_the_spirits) > 0 or fightremains() < spellcooldown(convoke_the_spirits) + 6 or fightremains() % 180 < 30 + conduitvalue(precise_alignment_conduit) } and spell(incarnation) or buffpresent(eclipse_any) and astralpower() >= astralpowercost(fury_of_elune) and buffamount(primordial_arcanic_pulsar_buff) < 240 and { target.debuffpresent(adaptive_swarm_damage) or not iscovenant("necrolord") } and save_for_ca_inc() and spell(fury_of_elune) or buffpresent(oneths_perception_buff) and buffrefreshable(starfall) and spell(starfall) or buffremaining(starlord_buff) < 5 and { buffremaining(eclipse_solar_buff) > 5 or buffremaining(eclipse_lunar_buff) > 5 } and astralpower() > 90 and buffpresent(starlord_buff) and texture(starlord_buff text=cancel) or iscovenant("night_fae") and convoke_desync() and spellcooldown(convoke_the_spirits) < 5 and not checkboxon("no_cds") and spell(starsurge) or hastalent(stellar_drift_talent) and not hastalent(starlord_talent) and buffrefreshable(starfall) and { buffremaining(eclipse_lunar_buff) > 6 and buffpresent(eclipse_lunar_buff) and buffamount(primordial_arcanic_pulsar_buff) < 250 or buffamount(primordial_arcanic_pulsar_buff) >= 250 and astralpower() > 90 or target.debuffremaining(adaptive_swarm_damage) > 8 or inflighttotarget(adaptive_swarm_damage) } and not spellcooldown(celestial_alignment) <= 0 and spell(starfall) or { buffpresent(oneths_clear_vision_buff) or buffpresent(kindred_empowerment_energize) or buffpresent(celestial_alignment) and { buffremaining(ravenous_frenzy) < gcd() * { astralpower() / 30 } and buffpresent(ravenous_frenzy) or not buffpresent(ravenous_frenzy) and not spellcooldown(ravenous_frenzy) <= 0 or not iscovenant("venthyr") } or astralpower() > 90 and buffpresent(eclipse_any) } and spell(starsurge) or hastalent(starlord_talent) and { buffpresent(starlord_buff) or astralpower() > 90 } and buffstacks(starlord_buff) < 3 and { buffpresent(eclipse_solar_buff) or buffpresent(eclipse_lunar_buff) } and buffamount(primordial_arcanic_pulsar_buff) < 270 and { spellcooldown(celestial_alignment) > 10 or not convoke_desync() and iscovenant("night_fae") } and spell(starsurge) or { buffamount(primordial_arcanic_pulsar_buff) < 270 or buffamount(primordial_arcanic_pulsar_buff) < 250 and hastalent(stellar_drift_talent) } and buffremaining(eclipse_solar_buff) > 7 and buffpresent(eclipse_solar_buff) and not buffpresent(oneths_perception_buff) and not hastalent(starlord_talent) and spellcooldown(celestial_alignment) > 7 and { spellcooldown(kindred_spirits) > 7 or not iscovenant("kyrian") } and spell(starsurge) or { buffpresent(eclipse_lunar_buff) or charges(new_moon) == 2 and spellchargecooldown(new_moon) < 5 or charges(new_moon) == 3 } and astralpower() >= astralpowercost(new_moon) and save_for_ca_inc() and { not spellknown(half_moon) and not spellknown(full_moon) } and spell(new_moon) or { buffpresent(eclipse_lunar_buff) and not iscovenant("kyrian") or buffpresent(kindred_empowerment_energize) and iscovenant("kyrian") or charges(half_moon) == 2 and spellchargecooldown(half_moon) < 5 or charges(half_moon) == 3 or buffpresent(celestial_alignment) } and astralpower() >= astralpowercost(half_moon) and save_for_ca_inc() and spellknown(half_moon) and spell(half_moon) or { buffpresent(eclipse_lunar_buff) and not iscovenant("kyrian") or buffpresent(kindred_empowerment_energize) and iscovenant("kyrian") or charges(full_moon) == 2 and spellchargecooldown(full_moon) < 5 or charges(full_moon) == 3 or buffpresent(celestial_alignment) } and astralpower() >= astralpowercost(full_moon) and save_for_ca_inc() and spellknown(full_moon) and spell(full_moon) or spell(warrior_of_elune) or { buffpresent(eclipse_lunar_buff) or counter(solar) == 1 or counter(lunar) + counter(solar) == 1 or buffpresent(warrior_of_elune) and buffpresent(eclipse_lunar_buff) or buffremaining(celestial_alignment) < executetime(wrath_balance) and buffpresent(celestial_alignment) } and spell(starfire) or spell(wrath_balance) or balancefallthrucdpostconditions()
}

### actions.precombat

AddFunction balanceprecombatmainactions
{
 #flask
 #food
 #augmentation
 #snapshot_stats
 #moonkin_form
 if buffexpires(moonkin_form) spell(moonkin_form)
 #wrath
 spell(wrath_balance)
 #wrath
 spell(wrath_balance)
 #starfire,if=!runeforge.balance_of_all_things|!covenant.night_fae|!spell_targets.starfall=1|!talent.natures_balance.enabled
 if not runeforge(balance_of_all_things_runeforge) or not iscovenant("night_fae") or not enemies(tagged=1) == 1 or not hastalent(natures_balance_talent) spell(starfire)
 #starsurge,if=runeforge.balance_of_all_things&covenant.night_fae&spell_targets.starfall=1
 if runeforge(balance_of_all_things_runeforge) and iscovenant("night_fae") and enemies(tagged=1) == 1 and buffexpires(starsurge_empowerment_lunar_buff) spell(starsurge)
}

AddFunction balanceprecombatmainpostconditions
{
}

AddFunction balanceprecombatshortcdactions
{
}

AddFunction balanceprecombatshortcdpostconditions
{
 buffexpires(moonkin_form) and spell(moonkin_form) or spell(wrath_balance) or spell(wrath_balance) or { not runeforge(balance_of_all_things_runeforge) or not iscovenant("night_fae") or not enemies(tagged=1) == 1 or not hastalent(natures_balance_talent) } and spell(starfire) or runeforge(balance_of_all_things_runeforge) and iscovenant("night_fae") and enemies(tagged=1) == 1 and buffexpires(starsurge_empowerment_lunar_buff) and spell(starsurge)
}

AddFunction balanceprecombatcdactions
{
}

AddFunction balanceprecombatcdpostconditions
{
 buffexpires(moonkin_form) and spell(moonkin_form) or spell(wrath_balance) or spell(wrath_balance) or { not runeforge(balance_of_all_things_runeforge) or not iscovenant("night_fae") or not enemies(tagged=1) == 1 or not hastalent(natures_balance_talent) } and spell(starfire) or runeforge(balance_of_all_things_runeforge) and iscovenant("night_fae") and enemies(tagged=1) == 1 and buffexpires(starsurge_empowerment_lunar_buff) and spell(starsurge)
}

### actions.fallthru

AddFunction balancefallthrumainactions
{
 #starsurge,if=!runeforge.balance_of_all_things.equipped
 if not equippedruneforge(balance_of_all_things_runeforge) spell(starsurge)
 #sunfire,target_if=dot.moonfire.remains>remains
 if target.debuffremaining(moonfire_debuff) > target.debuffremaining(sunfire_debuff) spell(sunfire)
 #moonfire
 spell(moonfire)
}

AddFunction balancefallthrumainpostconditions
{
}

AddFunction balancefallthrushortcdactions
{
}

AddFunction balancefallthrushortcdpostconditions
{
 not equippedruneforge(balance_of_all_things_runeforge) and spell(starsurge) or target.debuffremaining(moonfire_debuff) > target.debuffremaining(sunfire_debuff) and spell(sunfire) or spell(moonfire)
}

AddFunction balancefallthrucdactions
{
}

AddFunction balancefallthrucdpostconditions
{
 not equippedruneforge(balance_of_all_things_runeforge) and spell(starsurge) or target.debuffremaining(moonfire_debuff) > target.debuffremaining(sunfire_debuff) and spell(sunfire) or spell(moonfire)
}

### actions.dreambinder

AddFunction balancedreambindermainactions
{
 #variable,name=safe_to_use_spell,value=(buff.timeworn_dreambinder.remains>gcd.max+0.1&(eclipse.in_both|eclipse.in_solar|eclipse.lunar_next)|buff.timeworn_dreambinder.remains>action.starfire.execute_time+0.1&(eclipse.in_lunar|eclipse.solar_next|eclipse.any_next))|!buff.timeworn_dreambinder.up
 #starsurge,if=(!variable.safe_to_use_spell|(buff.ravenous_frenzy.remains<gcd.max*ceil(astral_power%30)&buff.ravenous_frenzy.up))|astral_power>90
 if not safe_to_use_spell() or buffremaining(ravenous_frenzy) < gcd() * { astralpower() / 30 } and buffpresent(ravenous_frenzy) or astralpower() > 90 spell(starsurge)
 #adaptive_swarm,target_if=!dot.adaptive_swarm_damage.ticking&!action.adaptive_swarm_damage.in_flight&(!dot.adaptive_swarm_heal.ticking|dot.adaptive_swarm_heal.remains>5)|dot.adaptive_swarm_damage.stack<3&dot.adaptive_swarm_damage.remains<3&dot.adaptive_swarm_damage.ticking
 if not target.debuffpresent(adaptive_swarm_damage) and not inflighttotarget(adaptive_swarm_damage) and { not target.debuffpresent(adaptive_swarm) or target.debuffremaining(adaptive_swarm) > 5 } or target.debuffstacks(adaptive_swarm_damage) < 3 and target.debuffremaining(adaptive_swarm_damage) < 3 and target.debuffpresent(adaptive_swarm_damage) spell(adaptive_swarm)
 #moonfire,target_if=refreshable&target.time_to_die>12,if=(buff.ca_inc.remains>5&(buff.ravenous_frenzy.remains>5|!buff.ravenous_frenzy.up)|!buff.ca_inc.up|astral_power<30)&(!buff.kindred_empowerment_energize.up|astral_power<30)&ap_check
 if target.refreshable(moonfire_debuff) and target.timetodie() > 12 and { { buffremaining(celestial_alignment) > 5 and { buffremaining(ravenous_frenzy) > 5 or not buffpresent(ravenous_frenzy) } or not buffpresent(celestial_alignment) or astralpower() < 30 } and { not buffpresent(kindred_empowerment_energize) or astralpower() < 30 } and astralpower() >= astralpowercost(moonfire) } spell(moonfire)
 #sunfire,target_if=refreshable&target.time_to_die>12,if=(buff.ca_inc.remains>5&(buff.ravenous_frenzy.remains>5|!buff.ravenous_frenzy.up)|!buff.ca_inc.up|astral_power<30)&(!buff.kindred_empowerment_energize.up|astral_power<30)&ap_check
 if target.refreshable(sunfire_debuff) and target.timetodie() > 12 and { { buffremaining(celestial_alignment) > 5 and { buffremaining(ravenous_frenzy) > 5 or not buffpresent(ravenous_frenzy) } or not buffpresent(celestial_alignment) or astralpower() < 30 } and { not buffpresent(kindred_empowerment_energize) or astralpower() < 30 } and astralpower() >= astralpowercost(sunfire) } spell(sunfire)
 #stellar_flare,target_if=refreshable&target.time_to_die>16,if=(buff.ca_inc.remains>5&(buff.ravenous_frenzy.remains>5|!buff.ravenous_frenzy.up)|!buff.ca_inc.up|astral_power<30)&(!buff.kindred_empowerment_energize.up|astral_power<30)&ap_check
 if target.refreshable(stellar_flare) and target.timetodie() > 16 and { { buffremaining(celestial_alignment) > 5 and { buffremaining(ravenous_frenzy) > 5 or not buffpresent(ravenous_frenzy) } or not buffpresent(celestial_alignment) or astralpower() < 30 } and { not buffpresent(kindred_empowerment_energize) or astralpower() < 30 } and astralpower() >= astralpowercost(stellar_flare) } spell(stellar_flare)
 #kindred_spirits,if=((buff.eclipse_solar.remains>10|buff.eclipse_lunar.remains>10)&cooldown.ca_inc.remains>30)|cooldown.ca_inc.ready
 if { buffremaining(eclipse_solar_buff) > 10 or buffremaining(eclipse_lunar_buff) > 10 } and spellcooldown(celestial_alignment) > 30 or spellcooldown(celestial_alignment) <= 0 spell(kindred_spirits)
 #incarnation,if=!druid.no_cds&variable.cd_condition&((buff.kindred_empowerment_energize.up|!covenant.kyrian)|covenant.night_fae|variable.is_aoe|buff.bloodlust.up&buff.bloodlust.remains<30+(conduit.precise_alignment.time_value))&!buff.ca_inc.up&(!covenant.night_fae|cooldown.convoke_the_spirits.up|interpolated_fight_remains<cooldown.convoke_the_spirits.remains+6|interpolated_fight_remains%%180<30+(conduit.precise_alignment.time_value))
 if not checkboxon("no_cds") and cd_condition() and { buffpresent(kindred_empowerment_energize) or not iscovenant("kyrian") or iscovenant("night_fae") or is_aoe() or buffpresent(bloodlust) and buffremaining(bloodlust) < 30 + conduitvalue(precise_alignment_conduit) } and not buffpresent(celestial_alignment) and { not iscovenant("night_fae") or not spellcooldown(convoke_the_spirits) > 0 or fightremains() < spellcooldown(convoke_the_spirits) + 6 or fightremains() % 180 < 30 + conduitvalue(precise_alignment_conduit) } spell(incarnation)
 #starsurge,if=covenant.night_fae&variable.convoke_desync&astral_power>=40&cooldown.convoke_the_spirits.remains<gcd.max*ceil(astral_power%30)&!druid.no_cds
 if iscovenant("night_fae") and convoke_desync() and astralpower() >= 40 and spellcooldown(convoke_the_spirits) < gcd() * { astralpower() / 30 } and not checkboxon("no_cds") spell(starsurge)
 #new_moon,if=(buff.eclipse_lunar.up|(charges=2&recharge_time<5)|charges=3)&ap_check&variable.save_for_ca_inc
 if { buffpresent(eclipse_lunar_buff) or charges(new_moon) == 2 and spellchargecooldown(new_moon) < 5 or charges(new_moon) == 3 } and astralpower() >= astralpowercost(new_moon) and save_for_ca_inc() and { not spellknown(half_moon) and not spellknown(full_moon) } spell(new_moon)
 #half_moon,if=(buff.eclipse_lunar.up&!covenant.kyrian|(buff.kindred_empowerment_energize.up&covenant.kyrian)|(charges=2&recharge_time<5)|charges=3|buff.ca_inc.up)&ap_check&variable.save_for_ca_inc
 if { buffpresent(eclipse_lunar_buff) and not iscovenant("kyrian") or buffpresent(kindred_empowerment_energize) and iscovenant("kyrian") or charges(half_moon) == 2 and spellchargecooldown(half_moon) < 5 or charges(half_moon) == 3 or buffpresent(celestial_alignment) } and astralpower() >= astralpowercost(half_moon) and save_for_ca_inc() and spellknown(half_moon) spell(half_moon)
 #full_moon,if=(buff.eclipse_lunar.up&!covenant.kyrian|(buff.kindred_empowerment_energize.up&covenant.kyrian)|(charges=2&recharge_time<5)|charges=3|buff.ca_inc.up)&ap_check&variable.save_for_ca_inc
 if { buffpresent(eclipse_lunar_buff) and not iscovenant("kyrian") or buffpresent(kindred_empowerment_energize) and iscovenant("kyrian") or charges(full_moon) == 2 and spellchargecooldown(full_moon) < 5 or charges(full_moon) == 3 or buffpresent(celestial_alignment) } and astralpower() >= astralpowercost(full_moon) and save_for_ca_inc() and spellknown(full_moon) spell(full_moon)
 #starfire,if=eclipse.in_lunar|eclipse.solar_next|eclipse.any_next|buff.warrior_of_elune.up&buff.eclipse_lunar.up|(buff.ca_inc.remains<action.wrath.execute_time&buff.ca_inc.up)
 if buffpresent(eclipse_lunar_buff) or counter(solar) == 1 or counter(lunar) + counter(solar) == 1 or buffpresent(warrior_of_elune) and buffpresent(eclipse_lunar_buff) or buffremaining(celestial_alignment) < executetime(wrath_balance) and buffpresent(celestial_alignment) spell(starfire)
 #wrath
 spell(wrath_balance)
 #run_action_list,name=fallthru
 balancefallthrumainactions()
}

AddFunction balancedreambindermainpostconditions
{
 balancefallthrumainpostconditions()
}

AddFunction balancedreambindershortcdactions
{
 unless { not safe_to_use_spell() or buffremaining(ravenous_frenzy) < gcd() * { astralpower() / 30 } and buffpresent(ravenous_frenzy) or astralpower() > 90 } and spell(starsurge) or { not target.debuffpresent(adaptive_swarm_damage) and not inflighttotarget(adaptive_swarm_damage) and { not target.debuffpresent(adaptive_swarm) or target.debuffremaining(adaptive_swarm) > 5 } or target.debuffstacks(adaptive_swarm_damage) < 3 and target.debuffremaining(adaptive_swarm_damage) < 3 and target.debuffpresent(adaptive_swarm_damage) } and spell(adaptive_swarm) or target.refreshable(moonfire_debuff) and target.timetodie() > 12 and { { buffremaining(celestial_alignment) > 5 and { buffremaining(ravenous_frenzy) > 5 or not buffpresent(ravenous_frenzy) } or not buffpresent(celestial_alignment) or astralpower() < 30 } and { not buffpresent(kindred_empowerment_energize) or astralpower() < 30 } and astralpower() >= astralpowercost(moonfire) } and spell(moonfire) or target.refreshable(sunfire_debuff) and target.timetodie() > 12 and { { buffremaining(celestial_alignment) > 5 and { buffremaining(ravenous_frenzy) > 5 or not buffpresent(ravenous_frenzy) } or not buffpresent(celestial_alignment) or astralpower() < 30 } and { not buffpresent(kindred_empowerment_energize) or astralpower() < 30 } and astralpower() >= astralpowercost(sunfire) } and spell(sunfire) or target.refreshable(stellar_flare) and target.timetodie() > 16 and { { buffremaining(celestial_alignment) > 5 and { buffremaining(ravenous_frenzy) > 5 or not buffpresent(ravenous_frenzy) } or not buffpresent(celestial_alignment) or astralpower() < 30 } and { not buffpresent(kindred_empowerment_energize) or astralpower() < 30 } and astralpower() >= astralpowercost(stellar_flare) } and spell(stellar_flare)
 {
  #force_of_nature,if=ap_check
  if astralpower() >= astralpowercost(force_of_nature) spell(force_of_nature)

  unless { { buffremaining(eclipse_solar_buff) > 10 or buffremaining(eclipse_lunar_buff) > 10 } and spellcooldown(celestial_alignment) > 30 or spellcooldown(celestial_alignment) <= 0 } and spell(kindred_spirits) or not checkboxon("no_cds") and cd_condition() and { buffpresent(kindred_empowerment_energize) or not iscovenant("kyrian") or iscovenant("night_fae") or is_aoe() or buffpresent(bloodlust) and buffremaining(bloodlust) < 30 + conduitvalue(precise_alignment_conduit) } and not buffpresent(celestial_alignment) and { not iscovenant("night_fae") or not spellcooldown(convoke_the_spirits) > 0 or fightremains() < spellcooldown(convoke_the_spirits) + 6 or fightremains() % 180 < 30 + conduitvalue(precise_alignment_conduit) } and spell(incarnation)
  {
   #variable,name=save_for_ca_inc,value=!cooldown.ca_inc.ready|!variable.convoke_desync&covenant.night_fae|druid.no_cds
   #fury_of_elune,if=eclipse.in_any&ap_check&(dot.adaptive_swarm_damage.ticking|!covenant.necrolord)&variable.save_for_ca_inc
   if buffpresent(eclipse_any) and astralpower() >= astralpowercost(fury_of_elune) and { target.debuffpresent(adaptive_swarm_damage) or not iscovenant("necrolord") } and save_for_ca_inc() spell(fury_of_elune)

   unless iscovenant("night_fae") and convoke_desync() and astralpower() >= 40 and spellcooldown(convoke_the_spirits) < gcd() * { astralpower() / 30 } and not checkboxon("no_cds") and spell(starsurge) or { buffpresent(eclipse_lunar_buff) or charges(new_moon) == 2 and spellchargecooldown(new_moon) < 5 or charges(new_moon) == 3 } and astralpower() >= astralpowercost(new_moon) and save_for_ca_inc() and { not spellknown(half_moon) and not spellknown(full_moon) } and spell(new_moon) or { buffpresent(eclipse_lunar_buff) and not iscovenant("kyrian") or buffpresent(kindred_empowerment_energize) and iscovenant("kyrian") or charges(half_moon) == 2 and spellchargecooldown(half_moon) < 5 or charges(half_moon) == 3 or buffpresent(celestial_alignment) } and astralpower() >= astralpowercost(half_moon) and save_for_ca_inc() and spellknown(half_moon) and spell(half_moon) or { buffpresent(eclipse_lunar_buff) and not iscovenant("kyrian") or buffpresent(kindred_empowerment_energize) and iscovenant("kyrian") or charges(full_moon) == 2 and spellchargecooldown(full_moon) < 5 or charges(full_moon) == 3 or buffpresent(celestial_alignment) } and astralpower() >= astralpowercost(full_moon) and save_for_ca_inc() and spellknown(full_moon) and spell(full_moon)
   {
    #warrior_of_elune
    spell(warrior_of_elune)

    unless { buffpresent(eclipse_lunar_buff) or counter(solar) == 1 or counter(lunar) + counter(solar) == 1 or buffpresent(warrior_of_elune) and buffpresent(eclipse_lunar_buff) or buffremaining(celestial_alignment) < executetime(wrath_balance) and buffpresent(celestial_alignment) } and spell(starfire) or spell(wrath_balance)
    {
     #run_action_list,name=fallthru
     balancefallthrushortcdactions()
    }
   }
  }
 }
}

AddFunction balancedreambindershortcdpostconditions
{
 { not safe_to_use_spell() or buffremaining(ravenous_frenzy) < gcd() * { astralpower() / 30 } and buffpresent(ravenous_frenzy) or astralpower() > 90 } and spell(starsurge) or { not target.debuffpresent(adaptive_swarm_damage) and not inflighttotarget(adaptive_swarm_damage) and { not target.debuffpresent(adaptive_swarm) or target.debuffremaining(adaptive_swarm) > 5 } or target.debuffstacks(adaptive_swarm_damage) < 3 and target.debuffremaining(adaptive_swarm_damage) < 3 and target.debuffpresent(adaptive_swarm_damage) } and spell(adaptive_swarm) or target.refreshable(moonfire_debuff) and target.timetodie() > 12 and { { buffremaining(celestial_alignment) > 5 and { buffremaining(ravenous_frenzy) > 5 or not buffpresent(ravenous_frenzy) } or not buffpresent(celestial_alignment) or astralpower() < 30 } and { not buffpresent(kindred_empowerment_energize) or astralpower() < 30 } and astralpower() >= astralpowercost(moonfire) } and spell(moonfire) or target.refreshable(sunfire_debuff) and target.timetodie() > 12 and { { buffremaining(celestial_alignment) > 5 and { buffremaining(ravenous_frenzy) > 5 or not buffpresent(ravenous_frenzy) } or not buffpresent(celestial_alignment) or astralpower() < 30 } and { not buffpresent(kindred_empowerment_energize) or astralpower() < 30 } and astralpower() >= astralpowercost(sunfire) } and spell(sunfire) or target.refreshable(stellar_flare) and target.timetodie() > 16 and { { buffremaining(celestial_alignment) > 5 and { buffremaining(ravenous_frenzy) > 5 or not buffpresent(ravenous_frenzy) } or not buffpresent(celestial_alignment) or astralpower() < 30 } and { not buffpresent(kindred_empowerment_energize) or astralpower() < 30 } and astralpower() >= astralpowercost(stellar_flare) } and spell(stellar_flare) or { { buffremaining(eclipse_solar_buff) > 10 or buffremaining(eclipse_lunar_buff) > 10 } and spellcooldown(celestial_alignment) > 30 or spellcooldown(celestial_alignment) <= 0 } and spell(kindred_spirits) or not checkboxon("no_cds") and cd_condition() and { buffpresent(kindred_empowerment_energize) or not iscovenant("kyrian") or iscovenant("night_fae") or is_aoe() or buffpresent(bloodlust) and buffremaining(bloodlust) < 30 + conduitvalue(precise_alignment_conduit) } and not buffpresent(celestial_alignment) and { not iscovenant("night_fae") or not spellcooldown(convoke_the_spirits) > 0 or fightremains() < spellcooldown(convoke_the_spirits) + 6 or fightremains() % 180 < 30 + conduitvalue(precise_alignment_conduit) } and spell(incarnation) or iscovenant("night_fae") and convoke_desync() and astralpower() >= 40 and spellcooldown(convoke_the_spirits) < gcd() * { astralpower() / 30 } and not checkboxon("no_cds") and spell(starsurge) or { buffpresent(eclipse_lunar_buff) or charges(new_moon) == 2 and spellchargecooldown(new_moon) < 5 or charges(new_moon) == 3 } and astralpower() >= astralpowercost(new_moon) and save_for_ca_inc() and { not spellknown(half_moon) and not spellknown(full_moon) } and spell(new_moon) or { buffpresent(eclipse_lunar_buff) and not iscovenant("kyrian") or buffpresent(kindred_empowerment_energize) and iscovenant("kyrian") or charges(half_moon) == 2 and spellchargecooldown(half_moon) < 5 or charges(half_moon) == 3 or buffpresent(celestial_alignment) } and astralpower() >= astralpowercost(half_moon) and save_for_ca_inc() and spellknown(half_moon) and spell(half_moon) or { buffpresent(eclipse_lunar_buff) and not iscovenant("kyrian") or buffpresent(kindred_empowerment_energize) and iscovenant("kyrian") or charges(full_moon) == 2 and spellchargecooldown(full_moon) < 5 or charges(full_moon) == 3 or buffpresent(celestial_alignment) } and astralpower() >= astralpowercost(full_moon) and save_for_ca_inc() and spellknown(full_moon) and spell(full_moon) or { buffpresent(eclipse_lunar_buff) or counter(solar) == 1 or counter(lunar) + counter(solar) == 1 or buffpresent(warrior_of_elune) and buffpresent(eclipse_lunar_buff) or buffremaining(celestial_alignment) < executetime(wrath_balance) and buffpresent(celestial_alignment) } and spell(starfire) or spell(wrath_balance) or balancefallthrushortcdpostconditions()
}

AddFunction balancedreambindercdactions
{
 unless { not safe_to_use_spell() or buffremaining(ravenous_frenzy) < gcd() * { astralpower() / 30 } and buffpresent(ravenous_frenzy) or astralpower() > 90 } and spell(starsurge)
 {
  #convoke_the_spirits,if=!druid.no_cds&((variable.convoke_desync&interpolated_fight_remains>130&!cooldown.ca_inc.ready|buff.ca_inc.up)&astral_power<40&(buff.eclipse_lunar.remains>10|buff.eclipse_solar.remains>10)|fight_remains<10)
  if not checkboxon("no_cds") and { { convoke_desync() and fightremains() > 130 and not spellcooldown(celestial_alignment) <= 0 or buffpresent(celestial_alignment) } and astralpower() < 40 and { buffremaining(eclipse_lunar_buff) > 10 or buffremaining(eclipse_solar_buff) > 10 } or fightremains() < 10 } spell(convoke_the_spirits)

  unless { not target.debuffpresent(adaptive_swarm_damage) and not inflighttotarget(adaptive_swarm_damage) and { not target.debuffpresent(adaptive_swarm) or target.debuffremaining(adaptive_swarm) > 5 } or target.debuffstacks(adaptive_swarm_damage) < 3 and target.debuffremaining(adaptive_swarm_damage) < 3 and target.debuffpresent(adaptive_swarm_damage) } and spell(adaptive_swarm) or target.refreshable(moonfire_debuff) and target.timetodie() > 12 and { { buffremaining(celestial_alignment) > 5 and { buffremaining(ravenous_frenzy) > 5 or not buffpresent(ravenous_frenzy) } or not buffpresent(celestial_alignment) or astralpower() < 30 } and { not buffpresent(kindred_empowerment_energize) or astralpower() < 30 } and astralpower() >= astralpowercost(moonfire) } and spell(moonfire) or target.refreshable(sunfire_debuff) and target.timetodie() > 12 and { { buffremaining(celestial_alignment) > 5 and { buffremaining(ravenous_frenzy) > 5 or not buffpresent(ravenous_frenzy) } or not buffpresent(celestial_alignment) or astralpower() < 30 } and { not buffpresent(kindred_empowerment_energize) or astralpower() < 30 } and astralpower() >= astralpowercost(sunfire) } and spell(sunfire) or target.refreshable(stellar_flare) and target.timetodie() > 16 and { { buffremaining(celestial_alignment) > 5 and { buffremaining(ravenous_frenzy) > 5 or not buffpresent(ravenous_frenzy) } or not buffpresent(celestial_alignment) or astralpower() < 30 } and { not buffpresent(kindred_empowerment_energize) or astralpower() < 30 } and astralpower() >= astralpowercost(stellar_flare) } and spell(stellar_flare) or astralpower() >= astralpowercost(force_of_nature) and spell(force_of_nature)
  {
   #ravenous_frenzy,if=buff.ca_inc.up
   if buffpresent(celestial_alignment) spell(ravenous_frenzy)

   unless { { buffremaining(eclipse_solar_buff) > 10 or buffremaining(eclipse_lunar_buff) > 10 } and spellcooldown(celestial_alignment) > 30 or spellcooldown(celestial_alignment) <= 0 } and spell(kindred_spirits)
   {
    #celestial_alignment,if=!druid.no_cds&variable.cd_condition&((buff.kindred_empowerment_energize.up|!covenant.kyrian)|covenant.night_fae|variable.is_aoe|buff.bloodlust.up&buff.bloodlust.remains<20+(conduit.precise_alignment.time_value))&!buff.ca_inc.up&(!covenant.night_fae|cooldown.convoke_the_spirits.up|interpolated_fight_remains<cooldown.convoke_the_spirits.remains+6|interpolated_fight_remains%%180<20+(conduit.precise_alignment.time_value))
    if not checkboxon("no_cds") and cd_condition() and { buffpresent(kindred_empowerment_energize) or not iscovenant("kyrian") or iscovenant("night_fae") or is_aoe() or buffpresent(bloodlust) and buffremaining(bloodlust) < 20 + conduitvalue(precise_alignment_conduit) } and not buffpresent(celestial_alignment) and { not iscovenant("night_fae") or not spellcooldown(convoke_the_spirits) > 0 or fightremains() < spellcooldown(convoke_the_spirits) + 6 or fightremains() % 180 < 20 + conduitvalue(precise_alignment_conduit) } spell(celestial_alignment)

    unless not checkboxon("no_cds") and cd_condition() and { buffpresent(kindred_empowerment_energize) or not iscovenant("kyrian") or iscovenant("night_fae") or is_aoe() or buffpresent(bloodlust) and buffremaining(bloodlust) < 30 + conduitvalue(precise_alignment_conduit) } and not buffpresent(celestial_alignment) and { not iscovenant("night_fae") or not spellcooldown(convoke_the_spirits) > 0 or fightremains() < spellcooldown(convoke_the_spirits) + 6 or fightremains() % 180 < 30 + conduitvalue(precise_alignment_conduit) } and spell(incarnation) or buffpresent(eclipse_any) and astralpower() >= astralpowercost(fury_of_elune) and { target.debuffpresent(adaptive_swarm_damage) or not iscovenant("necrolord") } and save_for_ca_inc() and spell(fury_of_elune) or iscovenant("night_fae") and convoke_desync() and astralpower() >= 40 and spellcooldown(convoke_the_spirits) < gcd() * { astralpower() / 30 } and not checkboxon("no_cds") and spell(starsurge) or { buffpresent(eclipse_lunar_buff) or charges(new_moon) == 2 and spellchargecooldown(new_moon) < 5 or charges(new_moon) == 3 } and astralpower() >= astralpowercost(new_moon) and save_for_ca_inc() and { not spellknown(half_moon) and not spellknown(full_moon) } and spell(new_moon) or { buffpresent(eclipse_lunar_buff) and not iscovenant("kyrian") or buffpresent(kindred_empowerment_energize) and iscovenant("kyrian") or charges(half_moon) == 2 and spellchargecooldown(half_moon) < 5 or charges(half_moon) == 3 or buffpresent(celestial_alignment) } and astralpower() >= astralpowercost(half_moon) and save_for_ca_inc() and spellknown(half_moon) and spell(half_moon) or { buffpresent(eclipse_lunar_buff) and not iscovenant("kyrian") or buffpresent(kindred_empowerment_energize) and iscovenant("kyrian") or charges(full_moon) == 2 and spellchargecooldown(full_moon) < 5 or charges(full_moon) == 3 or buffpresent(celestial_alignment) } and astralpower() >= astralpowercost(full_moon) and save_for_ca_inc() and spellknown(full_moon) and spell(full_moon) or spell(warrior_of_elune) or { buffpresent(eclipse_lunar_buff) or counter(solar) == 1 or counter(lunar) + counter(solar) == 1 or buffpresent(warrior_of_elune) and buffpresent(eclipse_lunar_buff) or buffremaining(celestial_alignment) < executetime(wrath_balance) and buffpresent(celestial_alignment) } and spell(starfire) or spell(wrath_balance)
    {
     #run_action_list,name=fallthru
     balancefallthrucdactions()
    }
   }
  }
 }
}

AddFunction balancedreambindercdpostconditions
{
 { not safe_to_use_spell() or buffremaining(ravenous_frenzy) < gcd() * { astralpower() / 30 } and buffpresent(ravenous_frenzy) or astralpower() > 90 } and spell(starsurge) or { not target.debuffpresent(adaptive_swarm_damage) and not inflighttotarget(adaptive_swarm_damage) and { not target.debuffpresent(adaptive_swarm) or target.debuffremaining(adaptive_swarm) > 5 } or target.debuffstacks(adaptive_swarm_damage) < 3 and target.debuffremaining(adaptive_swarm_damage) < 3 and target.debuffpresent(adaptive_swarm_damage) } and spell(adaptive_swarm) or target.refreshable(moonfire_debuff) and target.timetodie() > 12 and { { buffremaining(celestial_alignment) > 5 and { buffremaining(ravenous_frenzy) > 5 or not buffpresent(ravenous_frenzy) } or not buffpresent(celestial_alignment) or astralpower() < 30 } and { not buffpresent(kindred_empowerment_energize) or astralpower() < 30 } and astralpower() >= astralpowercost(moonfire) } and spell(moonfire) or target.refreshable(sunfire_debuff) and target.timetodie() > 12 and { { buffremaining(celestial_alignment) > 5 and { buffremaining(ravenous_frenzy) > 5 or not buffpresent(ravenous_frenzy) } or not buffpresent(celestial_alignment) or astralpower() < 30 } and { not buffpresent(kindred_empowerment_energize) or astralpower() < 30 } and astralpower() >= astralpowercost(sunfire) } and spell(sunfire) or target.refreshable(stellar_flare) and target.timetodie() > 16 and { { buffremaining(celestial_alignment) > 5 and { buffremaining(ravenous_frenzy) > 5 or not buffpresent(ravenous_frenzy) } or not buffpresent(celestial_alignment) or astralpower() < 30 } and { not buffpresent(kindred_empowerment_energize) or astralpower() < 30 } and astralpower() >= astralpowercost(stellar_flare) } and spell(stellar_flare) or astralpower() >= astralpowercost(force_of_nature) and spell(force_of_nature) or { { buffremaining(eclipse_solar_buff) > 10 or buffremaining(eclipse_lunar_buff) > 10 } and spellcooldown(celestial_alignment) > 30 or spellcooldown(celestial_alignment) <= 0 } and spell(kindred_spirits) or not checkboxon("no_cds") and cd_condition() and { buffpresent(kindred_empowerment_energize) or not iscovenant("kyrian") or iscovenant("night_fae") or is_aoe() or buffpresent(bloodlust) and buffremaining(bloodlust) < 30 + conduitvalue(precise_alignment_conduit) } and not buffpresent(celestial_alignment) and { not iscovenant("night_fae") or not spellcooldown(convoke_the_spirits) > 0 or fightremains() < spellcooldown(convoke_the_spirits) + 6 or fightremains() % 180 < 30 + conduitvalue(precise_alignment_conduit) } and spell(incarnation) or buffpresent(eclipse_any) and astralpower() >= astralpowercost(fury_of_elune) and { target.debuffpresent(adaptive_swarm_damage) or not iscovenant("necrolord") } and save_for_ca_inc() and spell(fury_of_elune) or iscovenant("night_fae") and convoke_desync() and astralpower() >= 40 and spellcooldown(convoke_the_spirits) < gcd() * { astralpower() / 30 } and not checkboxon("no_cds") and spell(starsurge) or { buffpresent(eclipse_lunar_buff) or charges(new_moon) == 2 and spellchargecooldown(new_moon) < 5 or charges(new_moon) == 3 } and astralpower() >= astralpowercost(new_moon) and save_for_ca_inc() and { not spellknown(half_moon) and not spellknown(full_moon) } and spell(new_moon) or { buffpresent(eclipse_lunar_buff) and not iscovenant("kyrian") or buffpresent(kindred_empowerment_energize) and iscovenant("kyrian") or charges(half_moon) == 2 and spellchargecooldown(half_moon) < 5 or charges(half_moon) == 3 or buffpresent(celestial_alignment) } and astralpower() >= astralpowercost(half_moon) and save_for_ca_inc() and spellknown(half_moon) and spell(half_moon) or { buffpresent(eclipse_lunar_buff) and not iscovenant("kyrian") or buffpresent(kindred_empowerment_energize) and iscovenant("kyrian") or charges(full_moon) == 2 and spellchargecooldown(full_moon) < 5 or charges(full_moon) == 3 or buffpresent(celestial_alignment) } and astralpower() >= astralpowercost(full_moon) and save_for_ca_inc() and spellknown(full_moon) and spell(full_moon) or spell(warrior_of_elune) or { buffpresent(eclipse_lunar_buff) or counter(solar) == 1 or counter(lunar) + counter(solar) == 1 or buffpresent(warrior_of_elune) and buffpresent(eclipse_lunar_buff) or buffremaining(celestial_alignment) < executetime(wrath_balance) and buffpresent(celestial_alignment) } and spell(starfire) or spell(wrath_balance) or balancefallthrucdpostconditions()
}

### actions.boat

AddFunction balanceboatmainactions
{
 #variable,name=critnotup,value=!buff.balance_of_all_things_nature.up&!buff.balance_of_all_things_arcane.up
 #adaptive_swarm,target_if=buff.balance_of_all_things_nature.stack<4&buff.balance_of_all_things_arcane.stack<4&(!dot.adaptive_swarm_damage.ticking&!action.adaptive_swarm_damage.in_flight&(!dot.adaptive_swarm_heal.ticking|dot.adaptive_swarm_heal.remains>3)|dot.adaptive_swarm_damage.stack<3&dot.adaptive_swarm_damage.remains<5&dot.adaptive_swarm_damage.ticking)
 if buffstacks(balance_of_all_things_nature_buff) < 4 and buffstacks(balance_of_all_things_arcane_buff) < 4 and { not target.debuffpresent(adaptive_swarm_damage) and not inflighttotarget(adaptive_swarm_damage) and { not target.debuffpresent(adaptive_swarm) or target.debuffremaining(adaptive_swarm) > 3 } or target.debuffstacks(adaptive_swarm_damage) < 3 and target.debuffremaining(adaptive_swarm_damage) < 5 and target.debuffpresent(adaptive_swarm_damage) } spell(adaptive_swarm)
 #cancel_buff,name=starlord,if=(buff.balance_of_all_things_nature.remains>4.5|buff.balance_of_all_things_arcane.remains>4.5)&(cooldown.ca_inc.remains>7|(cooldown.empower_bond.remains>7&!buff.kindred_empowerment_energize.up&covenant.kyrian))
 if { buffremaining(balance_of_all_things_nature_buff) > 4.5 or buffremaining(balance_of_all_things_arcane_buff) > 4.5 } and { spellcooldown(celestial_alignment) > 7 or spellcooldown(empower_bond) > 7 and not buffpresent(kindred_empowerment_energize) and iscovenant("kyrian") } and buffpresent(starlord_buff) texture(starlord_buff text=cancel)
 #starsurge,if=!variable.critnotup&(covenant.night_fae|cooldown.ca_inc.remains>7|!variable.cd_condition&!covenant.kyrian|(cooldown.empower_bond.remains>7&!buff.kindred_empowerment_energize.up&covenant.kyrian))
 if not critnotup() and { iscovenant("night_fae") or spellcooldown(celestial_alignment) > 7 or not cd_condition() and not iscovenant("kyrian") or spellcooldown(empower_bond) > 7 and not buffpresent(kindred_empowerment_energize) and iscovenant("kyrian") } spell(starsurge)
 #starsurge,if=(cooldown.convoke_the_spirits.remains<5&!druid.no_cds&(variable.convoke_desync|cooldown.ca_inc.remains<5)&variable.cd_condition)&astral_power>40&covenant.night_fae&!druid.no_cds
 if spellcooldown(convoke_the_spirits) < 5 and not checkboxon("no_cds") and { convoke_desync() or spellcooldown(celestial_alignment) < 5 } and cd_condition() and astralpower() > 40 and iscovenant("night_fae") and not checkboxon("no_cds") spell(starsurge)
 #variable,name=dot_requirements,value=(buff.ca_inc.remains>5&(buff.ravenous_frenzy.remains>5|!buff.ravenous_frenzy.up)|!buff.ca_inc.up)&(!buff.kindred_empowerment_energize.up)&(buff.eclipse_solar.remains>gcd.max|buff.eclipse_lunar.remains>gcd.max)
 #sunfire,target_if=refreshable&target.time_to_die>16,if=ap_check&variable.dot_requirements
 if target.refreshable(sunfire_debuff) and target.timetodie() > 16 and { astralpower() >= astralpowercost(sunfire) and dot_requirements() } spell(sunfire)
 #moonfire,target_if=refreshable&target.time_to_die>13.5,if=ap_check&variable.dot_requirements
 if target.refreshable(moonfire_debuff) and target.timetodie() > 13.5 and { astralpower() >= astralpowercost(moonfire) and dot_requirements() } spell(moonfire)
 #stellar_flare,target_if=refreshable&target.time_to_die>16+remains,if=ap_check&variable.dot_requirements
 if target.refreshable(stellar_flare) and target.timetodie() > 16 + target.debuffremaining(stellar_flare) and { astralpower() >= astralpowercost(stellar_flare) and dot_requirements() } spell(stellar_flare)
 #kindred_spirits,if=(eclipse.lunar_next|eclipse.solar_next|eclipse.any_next|buff.balance_of_all_things_nature.remains>4.5|buff.balance_of_all_things_arcane.remains>4.5|astral_power>90&cooldown.ca_inc.ready&!druid.no_cds)&(cooldown.ca_inc.remains>30|cooldown.ca_inc.ready)|interpolated_fight_remains<10
 if { counter(lunar) == 1 or counter(solar) == 1 or counter(lunar) + counter(solar) == 1 or buffremaining(balance_of_all_things_nature_buff) > 4.5 or buffremaining(balance_of_all_things_arcane_buff) > 4.5 or astralpower() > 90 and spellcooldown(celestial_alignment) <= 0 and not checkboxon("no_cds") } and { spellcooldown(celestial_alignment) > 30 or spellcooldown(celestial_alignment) <= 0 } or fightremains() < 10 spell(kindred_spirits)
 #incarnation,if=!druid.no_cds&variable.cd_condition&((astral_power>90&(buff.kindred_empowerment_energize.up|!covenant.kyrian)|buff.bloodlust.up&buff.bloodlust.remains<30+(conduit.precise_alignment.time_value))|interpolated_fight_remains<30+(conduit.precise_alignment.time_value)|covenant.night_fae)&(!covenant.night_fae|variable.convoke_desync|cooldown.convoke_the_spirits.ready)
 if not checkboxon("no_cds") and cd_condition() and { astralpower() > 90 and { buffpresent(kindred_empowerment_energize) or not iscovenant("kyrian") } or buffpresent(bloodlust) and buffremaining(bloodlust) < 30 + conduitvalue(precise_alignment_conduit) or fightremains() < 30 + conduitvalue(precise_alignment_conduit) or iscovenant("night_fae") } and { not iscovenant("night_fae") or convoke_desync() or spellcooldown(convoke_the_spirits) <= 0 } spell(incarnation)
 #variable,name=aspPerSec,value=eclipse.in_lunar*8%action.starfire.execute_time+!eclipse.in_lunar*6%action.wrath.execute_time+0.2%spell_haste
 #starsurge,if=(interpolated_fight_remains<4|(buff.ravenous_frenzy.remains<gcd.max*ceil(astral_power%30)&buff.ravenous_frenzy.up))|(astral_power+variable.aspPerSec*buff.eclipse_solar.remains+dot.fury_of_elune.ticks_remain*2.5>120|astral_power+variable.aspPerSec*buff.eclipse_lunar.remains+dot.fury_of_elune.ticks_remain*2.5>120)&eclipse.in_any&(!buff.ca_inc.up|!talent.starlord.enabled)&((!cooldown.ca_inc.up|covenant.kyrian&!cooldown.empower_bond.up)|covenant.night_fae)&(!covenant.venthyr|!buff.ca_inc.up|astral_power>90)|(talent.starlord.enabled&buff.ca_inc.up&(buff.starlord.stack<3|astral_power>90))|buff.ca_inc.remains>8&!buff.ravenous_frenzy.up&!talent.starlord.enabled
 if fightremains() < 4 or buffremaining(ravenous_frenzy) < gcd() * { astralpower() / 30 } and buffpresent(ravenous_frenzy) or { astralpower() + aspPerSec() * buffremaining(eclipse_solar_buff) + target.ticksremaining(fury_of_elune) * 2.5 > 120 or astralpower() + aspPerSec() * buffremaining(eclipse_lunar_buff) + target.ticksremaining(fury_of_elune) * 2.5 > 120 } and buffpresent(eclipse_any) and { not buffpresent(celestial_alignment) or not hastalent(starlord_talent) } and { not { not spellcooldown(celestial_alignment) > 0 } or iscovenant("kyrian") and not { not spellcooldown(empower_bond) > 0 } or iscovenant("night_fae") } and { not iscovenant("venthyr") or not buffpresent(celestial_alignment) or astralpower() > 90 } or hastalent(starlord_talent) and buffpresent(celestial_alignment) and { buffstacks(starlord_buff) < 3 or astralpower() > 90 } or buffremaining(celestial_alignment) > 8 and not buffpresent(ravenous_frenzy) and not hastalent(starlord_talent) spell(starsurge)
 #new_moon,if=(buff.eclipse_lunar.up|(charges=2&recharge_time<5)|charges=3)&ap_check
 if { buffpresent(eclipse_lunar_buff) or charges(new_moon) == 2 and spellchargecooldown(new_moon) < 5 or charges(new_moon) == 3 } and astralpower() >= astralpowercost(new_moon) and { not spellknown(half_moon) and not spellknown(full_moon) } spell(new_moon)
 #half_moon,if=(buff.eclipse_lunar.up|(charges=2&recharge_time<5)|charges=3)&ap_check
 if { buffpresent(eclipse_lunar_buff) or charges(half_moon) == 2 and spellchargecooldown(half_moon) < 5 or charges(half_moon) == 3 } and astralpower() >= astralpowercost(half_moon) and spellknown(half_moon) spell(half_moon)
 #full_moon,if=(buff.eclipse_lunar.up|(charges=2&recharge_time<5)|charges=3)&ap_check
 if { buffpresent(eclipse_lunar_buff) or charges(full_moon) == 2 and spellchargecooldown(full_moon) < 5 or charges(full_moon) == 3 } and astralpower() >= astralpowercost(full_moon) and spellknown(full_moon) spell(full_moon)
 #starfire,if=eclipse.in_lunar|eclipse.solar_next|eclipse.any_next|buff.warrior_of_elune.up&buff.eclipse_lunar.up|(buff.ca_inc.remains<action.wrath.execute_time&buff.ca_inc.up)
 if buffpresent(eclipse_lunar_buff) or counter(solar) == 1 or counter(lunar) + counter(solar) == 1 or buffpresent(warrior_of_elune) and buffpresent(eclipse_lunar_buff) or buffremaining(celestial_alignment) < executetime(wrath_balance) and buffpresent(celestial_alignment) spell(starfire)
 #wrath
 spell(wrath_balance)
 #run_action_list,name=fallthru
 balancefallthrumainactions()
}

AddFunction balanceboatmainpostconditions
{
 balancefallthrumainpostconditions()
}

AddFunction balanceboatshortcdactions
{
 unless buffstacks(balance_of_all_things_nature_buff) < 4 and buffstacks(balance_of_all_things_arcane_buff) < 4 and { not target.debuffpresent(adaptive_swarm_damage) and not inflighttotarget(adaptive_swarm_damage) and { not target.debuffpresent(adaptive_swarm) or target.debuffremaining(adaptive_swarm) > 3 } or target.debuffstacks(adaptive_swarm_damage) < 3 and target.debuffremaining(adaptive_swarm_damage) < 5 and target.debuffpresent(adaptive_swarm_damage) } and spell(adaptive_swarm) or { buffremaining(balance_of_all_things_nature_buff) > 4.5 or buffremaining(balance_of_all_things_arcane_buff) > 4.5 } and { spellcooldown(celestial_alignment) > 7 or spellcooldown(empower_bond) > 7 and not buffpresent(kindred_empowerment_energize) and iscovenant("kyrian") } and buffpresent(starlord_buff) and texture(starlord_buff text=cancel) or not critnotup() and { iscovenant("night_fae") or spellcooldown(celestial_alignment) > 7 or not cd_condition() and not iscovenant("kyrian") or spellcooldown(empower_bond) > 7 and not buffpresent(kindred_empowerment_energize) and iscovenant("kyrian") } and spell(starsurge) or spellcooldown(convoke_the_spirits) < 5 and not checkboxon("no_cds") and { convoke_desync() or spellcooldown(celestial_alignment) < 5 } and cd_condition() and astralpower() > 40 and iscovenant("night_fae") and not checkboxon("no_cds") and spell(starsurge) or target.refreshable(sunfire_debuff) and target.timetodie() > 16 and { astralpower() >= astralpowercost(sunfire) and dot_requirements() } and spell(sunfire) or target.refreshable(moonfire_debuff) and target.timetodie() > 13.5 and { astralpower() >= astralpowercost(moonfire) and dot_requirements() } and spell(moonfire) or target.refreshable(stellar_flare) and target.timetodie() > 16 + target.debuffremaining(stellar_flare) and { astralpower() >= astralpowercost(stellar_flare) and dot_requirements() } and spell(stellar_flare)
 {
  #force_of_nature,if=ap_check
  if astralpower() >= astralpowercost(force_of_nature) spell(force_of_nature)
  #fury_of_elune,if=(eclipse.in_any|eclipse.solar_in_1|eclipse.lunar_in_1)&(!covenant.night_fae|druid.no_cds|(astral_power<95&(variable.critnotup|astral_power<30|variable.is_aoe)&(variable.convoke_desync&!cooldown.convoke_the_spirits.up|!variable.convoke_desync&!cooldown.ca_inc.up)))&(cooldown.ca_inc.remains>30|druid.no_cds|astral_power>90&cooldown.ca_inc.up&(cooldown.empower_bond.remains<action.starfire.execute_time|!covenant.kyrian)|interpolated_fight_remains<10)&(dot.adaptive_swarm_damage.remains>4|!covenant.necrolord)
  if { buffpresent(eclipse_any) or counter(solar) == 1 or counter(lunar) == 1 } and { not iscovenant("night_fae") or checkboxon("no_cds") or astralpower() < 95 and { critnotup() or astralpower() < 30 or is_aoe() } and { convoke_desync() and not { not spellcooldown(convoke_the_spirits) > 0 } or not convoke_desync() and not { not spellcooldown(celestial_alignment) > 0 } } } and { spellcooldown(celestial_alignment) > 30 or checkboxon("no_cds") or astralpower() > 90 and not spellcooldown(celestial_alignment) > 0 and { spellcooldown(empower_bond) < executetime(starfire) or not iscovenant("kyrian") } or fightremains() < 10 } and { target.debuffremaining(adaptive_swarm_damage) > 4 or not iscovenant("necrolord") } spell(fury_of_elune)

  unless { { counter(lunar) == 1 or counter(solar) == 1 or counter(lunar) + counter(solar) == 1 or buffremaining(balance_of_all_things_nature_buff) > 4.5 or buffremaining(balance_of_all_things_arcane_buff) > 4.5 or astralpower() > 90 and spellcooldown(celestial_alignment) <= 0 and not checkboxon("no_cds") } and { spellcooldown(celestial_alignment) > 30 or spellcooldown(celestial_alignment) <= 0 } or fightremains() < 10 } and spell(kindred_spirits) or not checkboxon("no_cds") and cd_condition() and { astralpower() > 90 and { buffpresent(kindred_empowerment_energize) or not iscovenant("kyrian") } or buffpresent(bloodlust) and buffremaining(bloodlust) < 30 + conduitvalue(precise_alignment_conduit) or fightremains() < 30 + conduitvalue(precise_alignment_conduit) or iscovenant("night_fae") } and { not iscovenant("night_fae") or convoke_desync() or spellcooldown(convoke_the_spirits) <= 0 } and spell(incarnation) or { fightremains() < 4 or buffremaining(ravenous_frenzy) < gcd() * { astralpower() / 30 } and buffpresent(ravenous_frenzy) or { astralpower() + aspPerSec() * buffremaining(eclipse_solar_buff) + target.ticksremaining(fury_of_elune) * 2.5 > 120 or astralpower() + aspPerSec() * buffremaining(eclipse_lunar_buff) + target.ticksremaining(fury_of_elune) * 2.5 > 120 } and buffpresent(eclipse_any) and { not buffpresent(celestial_alignment) or not hastalent(starlord_talent) } and { not { not spellcooldown(celestial_alignment) > 0 } or iscovenant("kyrian") and not { not spellcooldown(empower_bond) > 0 } or iscovenant("night_fae") } and { not iscovenant("venthyr") or not buffpresent(celestial_alignment) or astralpower() > 90 } or hastalent(starlord_talent) and buffpresent(celestial_alignment) and { buffstacks(starlord_buff) < 3 or astralpower() > 90 } or buffremaining(celestial_alignment) > 8 and not buffpresent(ravenous_frenzy) and not hastalent(starlord_talent) } and spell(starsurge) or { buffpresent(eclipse_lunar_buff) or charges(new_moon) == 2 and spellchargecooldown(new_moon) < 5 or charges(new_moon) == 3 } and astralpower() >= astralpowercost(new_moon) and { not spellknown(half_moon) and not spellknown(full_moon) } and spell(new_moon) or { buffpresent(eclipse_lunar_buff) or charges(half_moon) == 2 and spellchargecooldown(half_moon) < 5 or charges(half_moon) == 3 } and astralpower() >= astralpowercost(half_moon) and spellknown(half_moon) and spell(half_moon) or { buffpresent(eclipse_lunar_buff) or charges(full_moon) == 2 and spellchargecooldown(full_moon) < 5 or charges(full_moon) == 3 } and astralpower() >= astralpowercost(full_moon) and spellknown(full_moon) and spell(full_moon)
  {
   #warrior_of_elune
   spell(warrior_of_elune)

   unless { buffpresent(eclipse_lunar_buff) or counter(solar) == 1 or counter(lunar) + counter(solar) == 1 or buffpresent(warrior_of_elune) and buffpresent(eclipse_lunar_buff) or buffremaining(celestial_alignment) < executetime(wrath_balance) and buffpresent(celestial_alignment) } and spell(starfire) or spell(wrath_balance)
   {
    #run_action_list,name=fallthru
    balancefallthrushortcdactions()
   }
  }
 }
}

AddFunction balanceboatshortcdpostconditions
{
 buffstacks(balance_of_all_things_nature_buff) < 4 and buffstacks(balance_of_all_things_arcane_buff) < 4 and { not target.debuffpresent(adaptive_swarm_damage) and not inflighttotarget(adaptive_swarm_damage) and { not target.debuffpresent(adaptive_swarm) or target.debuffremaining(adaptive_swarm) > 3 } or target.debuffstacks(adaptive_swarm_damage) < 3 and target.debuffremaining(adaptive_swarm_damage) < 5 and target.debuffpresent(adaptive_swarm_damage) } and spell(adaptive_swarm) or { buffremaining(balance_of_all_things_nature_buff) > 4.5 or buffremaining(balance_of_all_things_arcane_buff) > 4.5 } and { spellcooldown(celestial_alignment) > 7 or spellcooldown(empower_bond) > 7 and not buffpresent(kindred_empowerment_energize) and iscovenant("kyrian") } and buffpresent(starlord_buff) and texture(starlord_buff text=cancel) or not critnotup() and { iscovenant("night_fae") or spellcooldown(celestial_alignment) > 7 or not cd_condition() and not iscovenant("kyrian") or spellcooldown(empower_bond) > 7 and not buffpresent(kindred_empowerment_energize) and iscovenant("kyrian") } and spell(starsurge) or spellcooldown(convoke_the_spirits) < 5 and not checkboxon("no_cds") and { convoke_desync() or spellcooldown(celestial_alignment) < 5 } and cd_condition() and astralpower() > 40 and iscovenant("night_fae") and not checkboxon("no_cds") and spell(starsurge) or target.refreshable(sunfire_debuff) and target.timetodie() > 16 and { astralpower() >= astralpowercost(sunfire) and dot_requirements() } and spell(sunfire) or target.refreshable(moonfire_debuff) and target.timetodie() > 13.5 and { astralpower() >= astralpowercost(moonfire) and dot_requirements() } and spell(moonfire) or target.refreshable(stellar_flare) and target.timetodie() > 16 + target.debuffremaining(stellar_flare) and { astralpower() >= astralpowercost(stellar_flare) and dot_requirements() } and spell(stellar_flare) or { { counter(lunar) == 1 or counter(solar) == 1 or counter(lunar) + counter(solar) == 1 or buffremaining(balance_of_all_things_nature_buff) > 4.5 or buffremaining(balance_of_all_things_arcane_buff) > 4.5 or astralpower() > 90 and spellcooldown(celestial_alignment) <= 0 and not checkboxon("no_cds") } and { spellcooldown(celestial_alignment) > 30 or spellcooldown(celestial_alignment) <= 0 } or fightremains() < 10 } and spell(kindred_spirits) or not checkboxon("no_cds") and cd_condition() and { astralpower() > 90 and { buffpresent(kindred_empowerment_energize) or not iscovenant("kyrian") } or buffpresent(bloodlust) and buffremaining(bloodlust) < 30 + conduitvalue(precise_alignment_conduit) or fightremains() < 30 + conduitvalue(precise_alignment_conduit) or iscovenant("night_fae") } and { not iscovenant("night_fae") or convoke_desync() or spellcooldown(convoke_the_spirits) <= 0 } and spell(incarnation) or { fightremains() < 4 or buffremaining(ravenous_frenzy) < gcd() * { astralpower() / 30 } and buffpresent(ravenous_frenzy) or { astralpower() + aspPerSec() * buffremaining(eclipse_solar_buff) + target.ticksremaining(fury_of_elune) * 2.5 > 120 or astralpower() + aspPerSec() * buffremaining(eclipse_lunar_buff) + target.ticksremaining(fury_of_elune) * 2.5 > 120 } and buffpresent(eclipse_any) and { not buffpresent(celestial_alignment) or not hastalent(starlord_talent) } and { not { not spellcooldown(celestial_alignment) > 0 } or iscovenant("kyrian") and not { not spellcooldown(empower_bond) > 0 } or iscovenant("night_fae") } and { not iscovenant("venthyr") or not buffpresent(celestial_alignment) or astralpower() > 90 } or hastalent(starlord_talent) and buffpresent(celestial_alignment) and { buffstacks(starlord_buff) < 3 or astralpower() > 90 } or buffremaining(celestial_alignment) > 8 and not buffpresent(ravenous_frenzy) and not hastalent(starlord_talent) } and spell(starsurge) or { buffpresent(eclipse_lunar_buff) or charges(new_moon) == 2 and spellchargecooldown(new_moon) < 5 or charges(new_moon) == 3 } and astralpower() >= astralpowercost(new_moon) and { not spellknown(half_moon) and not spellknown(full_moon) } and spell(new_moon) or { buffpresent(eclipse_lunar_buff) or charges(half_moon) == 2 and spellchargecooldown(half_moon) < 5 or charges(half_moon) == 3 } and astralpower() >= astralpowercost(half_moon) and spellknown(half_moon) and spell(half_moon) or { buffpresent(eclipse_lunar_buff) or charges(full_moon) == 2 and spellchargecooldown(full_moon) < 5 or charges(full_moon) == 3 } and astralpower() >= astralpowercost(full_moon) and spellknown(full_moon) and spell(full_moon) or { buffpresent(eclipse_lunar_buff) or counter(solar) == 1 or counter(lunar) + counter(solar) == 1 or buffpresent(warrior_of_elune) and buffpresent(eclipse_lunar_buff) or buffremaining(celestial_alignment) < executetime(wrath_balance) and buffpresent(celestial_alignment) } and spell(starfire) or spell(wrath_balance) or balancefallthrushortcdpostconditions()
}

AddFunction balanceboatcdactions
{
 #ravenous_frenzy,if=buff.ca_inc.up
 if buffpresent(celestial_alignment) spell(ravenous_frenzy)

 unless buffstacks(balance_of_all_things_nature_buff) < 4 and buffstacks(balance_of_all_things_arcane_buff) < 4 and { not target.debuffpresent(adaptive_swarm_damage) and not inflighttotarget(adaptive_swarm_damage) and { not target.debuffpresent(adaptive_swarm) or target.debuffremaining(adaptive_swarm) > 3 } or target.debuffstacks(adaptive_swarm_damage) < 3 and target.debuffremaining(adaptive_swarm_damage) < 5 and target.debuffpresent(adaptive_swarm_damage) } and spell(adaptive_swarm)
 {
  #convoke_the_spirits,if=!druid.no_cds&((variable.convoke_desync&!cooldown.ca_inc.ready|buff.ca_inc.up)&(buff.balance_of_all_things_nature.stack=5|buff.balance_of_all_things_arcane.stack=5)|fight_remains<10)
  if not checkboxon("no_cds") and { { convoke_desync() and not spellcooldown(celestial_alignment) <= 0 or buffpresent(celestial_alignment) } and { buffstacks(balance_of_all_things_nature_buff) == 5 or buffstacks(balance_of_all_things_arcane_buff) == 5 } or fightremains() < 10 } spell(convoke_the_spirits)

  unless { buffremaining(balance_of_all_things_nature_buff) > 4.5 or buffremaining(balance_of_all_things_arcane_buff) > 4.5 } and { spellcooldown(celestial_alignment) > 7 or spellcooldown(empower_bond) > 7 and not buffpresent(kindred_empowerment_energize) and iscovenant("kyrian") } and buffpresent(starlord_buff) and texture(starlord_buff text=cancel) or not critnotup() and { iscovenant("night_fae") or spellcooldown(celestial_alignment) > 7 or not cd_condition() and not iscovenant("kyrian") or spellcooldown(empower_bond) > 7 and not buffpresent(kindred_empowerment_energize) and iscovenant("kyrian") } and spell(starsurge) or spellcooldown(convoke_the_spirits) < 5 and not checkboxon("no_cds") and { convoke_desync() or spellcooldown(celestial_alignment) < 5 } and cd_condition() and astralpower() > 40 and iscovenant("night_fae") and not checkboxon("no_cds") and spell(starsurge) or target.refreshable(sunfire_debuff) and target.timetodie() > 16 and { astralpower() >= astralpowercost(sunfire) and dot_requirements() } and spell(sunfire) or target.refreshable(moonfire_debuff) and target.timetodie() > 13.5 and { astralpower() >= astralpowercost(moonfire) and dot_requirements() } and spell(moonfire) or target.refreshable(stellar_flare) and target.timetodie() > 16 + target.debuffremaining(stellar_flare) and { astralpower() >= astralpowercost(stellar_flare) and dot_requirements() } and spell(stellar_flare) or astralpower() >= astralpowercost(force_of_nature) and spell(force_of_nature) or { buffpresent(eclipse_any) or counter(solar) == 1 or counter(lunar) == 1 } and { not iscovenant("night_fae") or checkboxon("no_cds") or astralpower() < 95 and { critnotup() or astralpower() < 30 or is_aoe() } and { convoke_desync() and not { not spellcooldown(convoke_the_spirits) > 0 } or not convoke_desync() and not { not spellcooldown(celestial_alignment) > 0 } } } and { spellcooldown(celestial_alignment) > 30 or checkboxon("no_cds") or astralpower() > 90 and not spellcooldown(celestial_alignment) > 0 and { spellcooldown(empower_bond) < executetime(starfire) or not iscovenant("kyrian") } or fightremains() < 10 } and { target.debuffremaining(adaptive_swarm_damage) > 4 or not iscovenant("necrolord") } and spell(fury_of_elune) or { { counter(lunar) == 1 or counter(solar) == 1 or counter(lunar) + counter(solar) == 1 or buffremaining(balance_of_all_things_nature_buff) > 4.5 or buffremaining(balance_of_all_things_arcane_buff) > 4.5 or astralpower() > 90 and spellcooldown(celestial_alignment) <= 0 and not checkboxon("no_cds") } and { spellcooldown(celestial_alignment) > 30 or spellcooldown(celestial_alignment) <= 0 } or fightremains() < 10 } and spell(kindred_spirits)
  {
   #celestial_alignment,if=!druid.no_cds&variable.cd_condition&((astral_power>90&(buff.kindred_empowerment_energize.up|!covenant.kyrian)|buff.bloodlust.up&buff.bloodlust.remains<20+(conduit.precise_alignment.time_value))|interpolated_fight_remains<20+(conduit.precise_alignment.time_value)|covenant.night_fae)&(!covenant.night_fae|variable.convoke_desync|cooldown.convoke_the_spirits.ready)
   if not checkboxon("no_cds") and cd_condition() and { astralpower() > 90 and { buffpresent(kindred_empowerment_energize) or not iscovenant("kyrian") } or buffpresent(bloodlust) and buffremaining(bloodlust) < 20 + conduitvalue(precise_alignment_conduit) or fightremains() < 20 + conduitvalue(precise_alignment_conduit) or iscovenant("night_fae") } and { not iscovenant("night_fae") or convoke_desync() or spellcooldown(convoke_the_spirits) <= 0 } spell(celestial_alignment)

   unless not checkboxon("no_cds") and cd_condition() and { astralpower() > 90 and { buffpresent(kindred_empowerment_energize) or not iscovenant("kyrian") } or buffpresent(bloodlust) and buffremaining(bloodlust) < 30 + conduitvalue(precise_alignment_conduit) or fightremains() < 30 + conduitvalue(precise_alignment_conduit) or iscovenant("night_fae") } and { not iscovenant("night_fae") or convoke_desync() or spellcooldown(convoke_the_spirits) <= 0 } and spell(incarnation) or { fightremains() < 4 or buffremaining(ravenous_frenzy) < gcd() * { astralpower() / 30 } and buffpresent(ravenous_frenzy) or { astralpower() + aspPerSec() * buffremaining(eclipse_solar_buff) + target.ticksremaining(fury_of_elune) * 2.5 > 120 or astralpower() + aspPerSec() * buffremaining(eclipse_lunar_buff) + target.ticksremaining(fury_of_elune) * 2.5 > 120 } and buffpresent(eclipse_any) and { not buffpresent(celestial_alignment) or not hastalent(starlord_talent) } and { not { not spellcooldown(celestial_alignment) > 0 } or iscovenant("kyrian") and not { not spellcooldown(empower_bond) > 0 } or iscovenant("night_fae") } and { not iscovenant("venthyr") or not buffpresent(celestial_alignment) or astralpower() > 90 } or hastalent(starlord_talent) and buffpresent(celestial_alignment) and { buffstacks(starlord_buff) < 3 or astralpower() > 90 } or buffremaining(celestial_alignment) > 8 and not buffpresent(ravenous_frenzy) and not hastalent(starlord_talent) } and spell(starsurge) or { buffpresent(eclipse_lunar_buff) or charges(new_moon) == 2 and spellchargecooldown(new_moon) < 5 or charges(new_moon) == 3 } and astralpower() >= astralpowercost(new_moon) and { not spellknown(half_moon) and not spellknown(full_moon) } and spell(new_moon) or { buffpresent(eclipse_lunar_buff) or charges(half_moon) == 2 and spellchargecooldown(half_moon) < 5 or charges(half_moon) == 3 } and astralpower() >= astralpowercost(half_moon) and spellknown(half_moon) and spell(half_moon) or { buffpresent(eclipse_lunar_buff) or charges(full_moon) == 2 and spellchargecooldown(full_moon) < 5 or charges(full_moon) == 3 } and astralpower() >= astralpowercost(full_moon) and spellknown(full_moon) and spell(full_moon) or spell(warrior_of_elune) or { buffpresent(eclipse_lunar_buff) or counter(solar) == 1 or counter(lunar) + counter(solar) == 1 or buffpresent(warrior_of_elune) and buffpresent(eclipse_lunar_buff) or buffremaining(celestial_alignment) < executetime(wrath_balance) and buffpresent(celestial_alignment) } and spell(starfire) or spell(wrath_balance)
   {
    #run_action_list,name=fallthru
    balancefallthrucdactions()
   }
  }
 }
}

AddFunction balanceboatcdpostconditions
{
 buffstacks(balance_of_all_things_nature_buff) < 4 and buffstacks(balance_of_all_things_arcane_buff) < 4 and { not target.debuffpresent(adaptive_swarm_damage) and not inflighttotarget(adaptive_swarm_damage) and { not target.debuffpresent(adaptive_swarm) or target.debuffremaining(adaptive_swarm) > 3 } or target.debuffstacks(adaptive_swarm_damage) < 3 and target.debuffremaining(adaptive_swarm_damage) < 5 and target.debuffpresent(adaptive_swarm_damage) } and spell(adaptive_swarm) or { buffremaining(balance_of_all_things_nature_buff) > 4.5 or buffremaining(balance_of_all_things_arcane_buff) > 4.5 } and { spellcooldown(celestial_alignment) > 7 or spellcooldown(empower_bond) > 7 and not buffpresent(kindred_empowerment_energize) and iscovenant("kyrian") } and buffpresent(starlord_buff) and texture(starlord_buff text=cancel) or not critnotup() and { iscovenant("night_fae") or spellcooldown(celestial_alignment) > 7 or not cd_condition() and not iscovenant("kyrian") or spellcooldown(empower_bond) > 7 and not buffpresent(kindred_empowerment_energize) and iscovenant("kyrian") } and spell(starsurge) or spellcooldown(convoke_the_spirits) < 5 and not checkboxon("no_cds") and { convoke_desync() or spellcooldown(celestial_alignment) < 5 } and cd_condition() and astralpower() > 40 and iscovenant("night_fae") and not checkboxon("no_cds") and spell(starsurge) or target.refreshable(sunfire_debuff) and target.timetodie() > 16 and { astralpower() >= astralpowercost(sunfire) and dot_requirements() } and spell(sunfire) or target.refreshable(moonfire_debuff) and target.timetodie() > 13.5 and { astralpower() >= astralpowercost(moonfire) and dot_requirements() } and spell(moonfire) or target.refreshable(stellar_flare) and target.timetodie() > 16 + target.debuffremaining(stellar_flare) and { astralpower() >= astralpowercost(stellar_flare) and dot_requirements() } and spell(stellar_flare) or astralpower() >= astralpowercost(force_of_nature) and spell(force_of_nature) or { buffpresent(eclipse_any) or counter(solar) == 1 or counter(lunar) == 1 } and { not iscovenant("night_fae") or checkboxon("no_cds") or astralpower() < 95 and { critnotup() or astralpower() < 30 or is_aoe() } and { convoke_desync() and not { not spellcooldown(convoke_the_spirits) > 0 } or not convoke_desync() and not { not spellcooldown(celestial_alignment) > 0 } } } and { spellcooldown(celestial_alignment) > 30 or checkboxon("no_cds") or astralpower() > 90 and not spellcooldown(celestial_alignment) > 0 and { spellcooldown(empower_bond) < executetime(starfire) or not iscovenant("kyrian") } or fightremains() < 10 } and { target.debuffremaining(adaptive_swarm_damage) > 4 or not iscovenant("necrolord") } and spell(fury_of_elune) or { { counter(lunar) == 1 or counter(solar) == 1 or counter(lunar) + counter(solar) == 1 or buffremaining(balance_of_all_things_nature_buff) > 4.5 or buffremaining(balance_of_all_things_arcane_buff) > 4.5 or astralpower() > 90 and spellcooldown(celestial_alignment) <= 0 and not checkboxon("no_cds") } and { spellcooldown(celestial_alignment) > 30 or spellcooldown(celestial_alignment) <= 0 } or fightremains() < 10 } and spell(kindred_spirits) or not checkboxon("no_cds") and cd_condition() and { astralpower() > 90 and { buffpresent(kindred_empowerment_energize) or not iscovenant("kyrian") } or buffpresent(bloodlust) and buffremaining(bloodlust) < 30 + conduitvalue(precise_alignment_conduit) or fightremains() < 30 + conduitvalue(precise_alignment_conduit) or iscovenant("night_fae") } and { not iscovenant("night_fae") or convoke_desync() or spellcooldown(convoke_the_spirits) <= 0 } and spell(incarnation) or { fightremains() < 4 or buffremaining(ravenous_frenzy) < gcd() * { astralpower() / 30 } and buffpresent(ravenous_frenzy) or { astralpower() + aspPerSec() * buffremaining(eclipse_solar_buff) + target.ticksremaining(fury_of_elune) * 2.5 > 120 or astralpower() + aspPerSec() * buffremaining(eclipse_lunar_buff) + target.ticksremaining(fury_of_elune) * 2.5 > 120 } and buffpresent(eclipse_any) and { not buffpresent(celestial_alignment) or not hastalent(starlord_talent) } and { not { not spellcooldown(celestial_alignment) > 0 } or iscovenant("kyrian") and not { not spellcooldown(empower_bond) > 0 } or iscovenant("night_fae") } and { not iscovenant("venthyr") or not buffpresent(celestial_alignment) or astralpower() > 90 } or hastalent(starlord_talent) and buffpresent(celestial_alignment) and { buffstacks(starlord_buff) < 3 or astralpower() > 90 } or buffremaining(celestial_alignment) > 8 and not buffpresent(ravenous_frenzy) and not hastalent(starlord_talent) } and spell(starsurge) or { buffpresent(eclipse_lunar_buff) or charges(new_moon) == 2 and spellchargecooldown(new_moon) < 5 or charges(new_moon) == 3 } and astralpower() >= astralpowercost(new_moon) and { not spellknown(half_moon) and not spellknown(full_moon) } and spell(new_moon) or { buffpresent(eclipse_lunar_buff) or charges(half_moon) == 2 and spellchargecooldown(half_moon) < 5 or charges(half_moon) == 3 } and astralpower() >= astralpowercost(half_moon) and spellknown(half_moon) and spell(half_moon) or { buffpresent(eclipse_lunar_buff) or charges(full_moon) == 2 and spellchargecooldown(full_moon) < 5 or charges(full_moon) == 3 } and astralpower() >= astralpowercost(full_moon) and spellknown(full_moon) and spell(full_moon) or spell(warrior_of_elune) or { buffpresent(eclipse_lunar_buff) or counter(solar) == 1 or counter(lunar) + counter(solar) == 1 or buffpresent(warrior_of_elune) and buffpresent(eclipse_lunar_buff) or buffremaining(celestial_alignment) < executetime(wrath_balance) and buffpresent(celestial_alignment) } and spell(starfire) or spell(wrath_balance) or balancefallthrucdpostconditions()
}

### actions.aoe

AddFunction balanceaoemainactions
{
 #sunfire,target_if=refreshable&target.time_to_die>14-spell_targets+remains&(eclipse.in_any|remains<gcd.max)
 if target.refreshable(sunfire_debuff) and target.timetodie() > 14 - enemies(tagged=1) + target.debuffremaining(sunfire_debuff) and { buffpresent(eclipse_any) or target.debuffremaining(sunfire_debuff) < gcd() } spell(sunfire)
 #starfall,if=(buff.starfall.refreshable&(spell_targets.starfall<3|!runeforge.timeworn_dreambinder.equipped)|talent.soul_of_the_forest.enabled&buff.eclipse_solar.remains<3&eclipse.in_solar&buff.starfall.remains<7&spell_targets.starfall>=4)&(!runeforge.lycaras_fleeting_glimpse.equipped|time%%45>buff.starfall.remains+2)&target.time_to_die>5
 if { buffrefreshable(starfall) and { enemies(tagged=1) < 3 or not equippedruneforge(timeworn_dreambinder_runeforge) } or hastalent(soul_of_the_forest_talent) and buffremaining(eclipse_solar_buff) < 3 and buffpresent(eclipse_solar_buff) and buffremaining(starfall) < 7 and enemies(tagged=1) >= 4 } and { not equippedruneforge(lycaras_fleeting_glimpse_runeforge) or timeincombat() % 45 > buffremaining(starfall) + 2 } and target.timetodie() > 5 spell(starfall)
 #starfall,if=runeforge.timeworn_dreambinder.equipped&spell_targets.starfall>=3&(!buff.timeworn_dreambinder.up&buff.starfall.refreshable|(variable.dream_will_fall_off&(buff.starfall.remains<3|spell_targets.starfall>2&talent.stellar_drift.enabled&buff.starfall.remains<5)))
 if equippedruneforge(timeworn_dreambinder_runeforge) and enemies(tagged=1) >= 3 and { not buffpresent(timeworn_dreambinder_buff) and buffrefreshable(starfall) or dream_will_fall_off() and { buffremaining(starfall) < 3 or enemies(tagged=1) > 2 and hastalent(stellar_drift_talent) and buffremaining(starfall) < 5 } } spell(starfall)
 #variable,name=starfall_wont_fall_off,value=astral_power>80-(10*buff.timeworn_dreambinder.stack)-(buff.starfall.remains*3%spell_haste)-(dot.fury_of_elune.remains*5)&buff.starfall.up
 #starsurge,if=variable.dream_will_fall_off&variable.starfall_wont_fall_off&!variable.ignore_starsurge|(buff.balance_of_all_things_nature.stack>3|buff.balance_of_all_things_arcane.stack>3)&spell_targets.starfall<4
 if dream_will_fall_off() and starfall_wont_fall_off() and not ignore_starsurge() or { buffstacks(balance_of_all_things_nature_buff) > 3 or buffstacks(balance_of_all_things_arcane_buff) > 3 } and enemies(tagged=1) < 4 spell(starsurge)
 #adaptive_swarm,target_if=!ticking&!action.adaptive_swarm_damage.in_flight|dot.adaptive_swarm_damage.stack<3&dot.adaptive_swarm_damage.remains<3
 if not buffpresent(adaptive_swarm) and not inflighttotarget(adaptive_swarm_damage) or target.debuffstacks(adaptive_swarm_damage) < 3 and target.debuffremaining(adaptive_swarm_damage) < 3 spell(adaptive_swarm)
 #moonfire,target_if=refreshable&target.time_to_die>(14+(spell_targets.starfire*1.5))%spell_targets+remains,if=(cooldown.ca_inc.ready&!druid.no_cds&(variable.convoke_desync|cooldown.convoke_the_spirits.ready|!covenant.night_fae)|spell_targets.starfire<(5*(1+talent.twin_moons.enabled))|(eclipse.in_solar|(eclipse.in_both|eclipse.in_lunar)&!talent.soul_of_the_forest.enabled|buff.primordial_arcanic_pulsar.value>=250)&(spell_targets.starfire<10*(1+talent.twin_moons.enabled))&astral_power>50-buff.starfall.remains*6)&(!buff.kindred_empowerment_energize.up|eclipse.in_solar|!covenant.kyrian)&ap_check
 if target.refreshable(moonfire_debuff) and target.timetodie() > { 14 + enemies(tagged=1) * 1.5 } / enemies(tagged=1) + target.debuffremaining(moonfire_debuff) and { { spellcooldown(celestial_alignment) <= 0 and not checkboxon("no_cds") and { convoke_desync() or spellcooldown(convoke_the_spirits) <= 0 or not iscovenant("night_fae") } or enemies(tagged=1) < 5 * { 1 + talentpoints(twin_moons_talent) } or { buffpresent(eclipse_solar_buff) or { buffpresent(eclipse_solar_buff) and buffpresent(eclipse_lunar_buff) or buffpresent(eclipse_lunar_buff) } and not hastalent(soul_of_the_forest_talent) or buffamount(primordial_arcanic_pulsar_buff) >= 250 } and enemies(tagged=1) < 10 * { 1 + talentpoints(twin_moons_talent) } and astralpower() > 50 - buffremaining(starfall) * 6 } and { not buffpresent(kindred_empowerment_energize) or buffpresent(eclipse_solar_buff) or not iscovenant("kyrian") } and astralpower() >= astralpowercost(moonfire) } spell(moonfire)
 #incarnation,if=!druid.no_cds&variable.cd_condition&(buff.starfall.up|astral_power>50)&!buff.solstice.up&!buff.ca_inc.up&(!covenant.night_fae|variable.convoke_desync|cooldown.convoke_the_spirits.up|interpolated_fight_remains<cooldown.convoke_the_spirits.remains+6|interpolated_fight_remains%%180<30+(conduit.precise_alignment.time_value))
 if not checkboxon("no_cds") and cd_condition() and { buffpresent(starfall) or astralpower() > 50 } and not buffpresent(solstice_buff) and not buffpresent(celestial_alignment) and { not iscovenant("night_fae") or convoke_desync() or not spellcooldown(convoke_the_spirits) > 0 or fightremains() < spellcooldown(convoke_the_spirits) + 6 or fightremains() % 180 < 30 + conduitvalue(precise_alignment_conduit) } spell(incarnation)
 #kindred_spirits,if=interpolated_fight_remains<15|(buff.primordial_arcanic_pulsar.value<250|buff.primordial_arcanic_pulsar.value>=250)&buff.starfall.up&(cooldown.ca_inc.remains>50|druid.no_cds)
 if fightremains() < 15 or { buffamount(primordial_arcanic_pulsar_buff) < 250 or buffamount(primordial_arcanic_pulsar_buff) >= 250 } and buffpresent(starfall) and { spellcooldown(celestial_alignment) > 50 or checkboxon("no_cds") } spell(kindred_spirits)
 #stellar_flare,target_if=refreshable&time_to_die>15,if=spell_targets.starfire<4&ap_check&(buff.ca_inc.remains>10|!buff.ca_inc.up)
 if target.refreshable(stellar_flare) and target.timetodie() > 15 and { enemies(tagged=1) < 4 and astralpower() >= astralpowercost(stellar_flare) and { buffremaining(celestial_alignment) > 10 or not buffpresent(celestial_alignment) } } spell(stellar_flare)
 #starfall,if=buff.oneths_perception.up&(buff.starfall.refreshable|astral_power>90)
 if buffpresent(oneths_perception_buff) and { buffrefreshable(starfall) or astralpower() > 90 } spell(starfall)
 #starfall,if=covenant.night_fae&(variable.convoke_desync|cooldown.ca_inc.up|buff.ca_inc.up)&cooldown.convoke_the_spirits.remains<gcd.max*ceil(astral_power%50)&buff.starfall.remains<4&!druid.no_cds
 if iscovenant("night_fae") and { convoke_desync() or not spellcooldown(celestial_alignment) > 0 or buffpresent(celestial_alignment) } and spellcooldown(convoke_the_spirits) < gcd() * { astralpower() / 50 } and buffremaining(starfall) < 4 and not checkboxon("no_cds") spell(starfall)
 #starsurge,if=covenant.night_fae&(variable.convoke_desync|cooldown.ca_inc.up|buff.ca_inc.up)&cooldown.convoke_the_spirits.remains<6&buff.starfall.up&eclipse.in_any&!variable.ignore_starsurge&!druid.no_cds
 if iscovenant("night_fae") and { convoke_desync() or not spellcooldown(celestial_alignment) > 0 or buffpresent(celestial_alignment) } and spellcooldown(convoke_the_spirits) < 6 and buffpresent(starfall) and buffpresent(eclipse_any) and not ignore_starsurge() and not checkboxon("no_cds") spell(starsurge)
 #starsurge,if=buff.oneths_clear_vision.up|(!starfire.ap_check|(buff.ca_inc.remains<5&buff.ca_inc.up|(buff.ravenous_frenzy.remains<gcd.max*ceil(astral_power%30)&buff.ravenous_frenzy.up))&variable.starfall_wont_fall_off&spell_targets.starfall<3)&(!runeforge.timeworn_dreambinder.equipped|spell_targets.starfall<3)
 if buffpresent(oneths_clear_vision_buff) or { not astralpower() >= astralpowercost(starfire) or { buffremaining(celestial_alignment) < 5 and buffpresent(celestial_alignment) or buffremaining(ravenous_frenzy) < gcd() * { astralpower() / 30 } and buffpresent(ravenous_frenzy) } and starfall_wont_fall_off() and enemies(tagged=1) < 3 } and { not equippedruneforge(timeworn_dreambinder_runeforge) or enemies(tagged=1) < 3 } spell(starsurge)
 #new_moon,if=(eclipse.in_any&cooldown.ca_inc.remains>50|(charges=2&recharge_time<5)|charges=3)&ap_check
 if { buffpresent(eclipse_any) and spellcooldown(celestial_alignment) > 50 or charges(new_moon) == 2 and spellchargecooldown(new_moon) < 5 or charges(new_moon) == 3 } and astralpower() >= astralpowercost(new_moon) and { not spellknown(half_moon) and not spellknown(full_moon) } spell(new_moon)
 #half_moon,if=(eclipse.in_any&cooldown.ca_inc.remains>50|(charges=2&recharge_time<5)|charges=3)&ap_check
 if { buffpresent(eclipse_any) and spellcooldown(celestial_alignment) > 50 or charges(half_moon) == 2 and spellchargecooldown(half_moon) < 5 or charges(half_moon) == 3 } and astralpower() >= astralpowercost(half_moon) and spellknown(half_moon) spell(half_moon)
 #full_moon,if=(eclipse.in_any&cooldown.ca_inc.remains>50|(charges=2&recharge_time<5)|charges=3)&ap_check
 if { buffpresent(eclipse_any) and spellcooldown(celestial_alignment) > 50 or charges(full_moon) == 2 and spellchargecooldown(full_moon) < 5 or charges(full_moon) == 3 } and astralpower() >= astralpowercost(full_moon) and spellknown(full_moon) spell(full_moon)
 #variable,name=starfire_in_solar,value=spell_targets.starfire>4+floor(mastery_value*100%20)+floor(buff.starsurge_empowerment_solar.stack%4)
 #wrath,if=eclipse.lunar_next|eclipse.any_next&variable.is_cleave|buff.eclipse_solar.remains<action.starfire.execute_time&buff.eclipse_solar.up|eclipse.in_solar&!variable.starfire_in_solar|buff.ca_inc.remains<action.starfire.execute_time&!variable.is_cleave&buff.ca_inc.remains<execute_time&buff.ca_inc.up|buff.ravenous_frenzy.up&spell_haste>0.6&(spell_targets<=3|!talent.soul_of_the_forest.enabled)|!variable.is_cleave&buff.ca_inc.remains>execute_time
 if counter(lunar) == 1 or counter(lunar) + counter(solar) == 1 and is_cleave() or buffremaining(eclipse_solar_buff) < executetime(starfire) and buffpresent(eclipse_solar_buff) or buffpresent(eclipse_solar_buff) and not starfire_in_solar() or buffremaining(celestial_alignment) < executetime(starfire) and not is_cleave() and buffremaining(celestial_alignment) < executetime(wrath_balance) and buffpresent(celestial_alignment) or buffpresent(ravenous_frenzy) and 100 / { 100 + spellcastspeedpercent() } > 0.6 and { enemies(tagged=1) <= 3 or not hastalent(soul_of_the_forest_talent) } or not is_cleave() and buffremaining(celestial_alignment) > executetime(wrath_balance) spell(wrath_balance)
 #starfire
 spell(starfire)
 #run_action_list,name=fallthru
 balancefallthrumainactions()
}

AddFunction balanceaoemainpostconditions
{
 balancefallthrumainpostconditions()
}

AddFunction balanceaoeshortcdactions
{
 unless target.refreshable(sunfire_debuff) and target.timetodie() > 14 - enemies(tagged=1) + target.debuffremaining(sunfire_debuff) and { buffpresent(eclipse_any) or target.debuffremaining(sunfire_debuff) < gcd() } and spell(sunfire) or { buffrefreshable(starfall) and { enemies(tagged=1) < 3 or not equippedruneforge(timeworn_dreambinder_runeforge) } or hastalent(soul_of_the_forest_talent) and buffremaining(eclipse_solar_buff) < 3 and buffpresent(eclipse_solar_buff) and buffremaining(starfall) < 7 and enemies(tagged=1) >= 4 } and { not equippedruneforge(lycaras_fleeting_glimpse_runeforge) or timeincombat() % 45 > buffremaining(starfall) + 2 } and target.timetodie() > 5 and spell(starfall) or equippedruneforge(timeworn_dreambinder_runeforge) and enemies(tagged=1) >= 3 and { not buffpresent(timeworn_dreambinder_buff) and buffrefreshable(starfall) or dream_will_fall_off() and { buffremaining(starfall) < 3 or enemies(tagged=1) > 2 and hastalent(stellar_drift_talent) and buffremaining(starfall) < 5 } } and spell(starfall) or { dream_will_fall_off() and starfall_wont_fall_off() and not ignore_starsurge() or { buffstacks(balance_of_all_things_nature_buff) > 3 or buffstacks(balance_of_all_things_arcane_buff) > 3 } and enemies(tagged=1) < 4 } and spell(starsurge) or { not buffpresent(adaptive_swarm) and not inflighttotarget(adaptive_swarm_damage) or target.debuffstacks(adaptive_swarm_damage) < 3 and target.debuffremaining(adaptive_swarm_damage) < 3 } and spell(adaptive_swarm) or target.refreshable(moonfire_debuff) and target.timetodie() > { 14 + enemies(tagged=1) * 1.5 } / enemies(tagged=1) + target.debuffremaining(moonfire_debuff) and { { spellcooldown(celestial_alignment) <= 0 and not checkboxon("no_cds") and { convoke_desync() or spellcooldown(convoke_the_spirits) <= 0 or not iscovenant("night_fae") } or enemies(tagged=1) < 5 * { 1 + talentpoints(twin_moons_talent) } or { buffpresent(eclipse_solar_buff) or { buffpresent(eclipse_solar_buff) and buffpresent(eclipse_lunar_buff) or buffpresent(eclipse_lunar_buff) } and not hastalent(soul_of_the_forest_talent) or buffamount(primordial_arcanic_pulsar_buff) >= 250 } and enemies(tagged=1) < 10 * { 1 + talentpoints(twin_moons_talent) } and astralpower() > 50 - buffremaining(starfall) * 6 } and { not buffpresent(kindred_empowerment_energize) or buffpresent(eclipse_solar_buff) or not iscovenant("kyrian") } and astralpower() >= astralpowercost(moonfire) } and spell(moonfire)
 {
  #force_of_nature,if=ap_check
  if astralpower() >= astralpowercost(force_of_nature) spell(force_of_nature)

  unless not checkboxon("no_cds") and cd_condition() and { buffpresent(starfall) or astralpower() > 50 } and not buffpresent(solstice_buff) and not buffpresent(celestial_alignment) and { not iscovenant("night_fae") or convoke_desync() or not spellcooldown(convoke_the_spirits) > 0 or fightremains() < spellcooldown(convoke_the_spirits) + 6 or fightremains() % 180 < 30 + conduitvalue(precise_alignment_conduit) } and spell(incarnation) or { fightremains() < 15 or { buffamount(primordial_arcanic_pulsar_buff) < 250 or buffamount(primordial_arcanic_pulsar_buff) >= 250 } and buffpresent(starfall) and { spellcooldown(celestial_alignment) > 50 or checkboxon("no_cds") } } and spell(kindred_spirits) or target.refreshable(stellar_flare) and target.timetodie() > 15 and { enemies(tagged=1) < 4 and astralpower() >= astralpowercost(stellar_flare) and { buffremaining(celestial_alignment) > 10 or not buffpresent(celestial_alignment) } } and spell(stellar_flare)
  {
   #fury_of_elune,if=eclipse.in_any&ap_check&buff.primordial_arcanic_pulsar.value<250&(dot.adaptive_swarm_damage.ticking|!covenant.necrolord|spell_targets>2)
   if buffpresent(eclipse_any) and astralpower() >= astralpowercost(fury_of_elune) and buffamount(primordial_arcanic_pulsar_buff) < 250 and { target.debuffpresent(adaptive_swarm_damage) or not iscovenant("necrolord") or enemies(tagged=1) > 2 } spell(fury_of_elune)

   unless buffpresent(oneths_perception_buff) and { buffrefreshable(starfall) or astralpower() > 90 } and spell(starfall) or iscovenant("night_fae") and { convoke_desync() or not spellcooldown(celestial_alignment) > 0 or buffpresent(celestial_alignment) } and spellcooldown(convoke_the_spirits) < gcd() * { astralpower() / 50 } and buffremaining(starfall) < 4 and not checkboxon("no_cds") and spell(starfall) or iscovenant("night_fae") and { convoke_desync() or not spellcooldown(celestial_alignment) > 0 or buffpresent(celestial_alignment) } and spellcooldown(convoke_the_spirits) < 6 and buffpresent(starfall) and buffpresent(eclipse_any) and not ignore_starsurge() and not checkboxon("no_cds") and spell(starsurge) or { buffpresent(oneths_clear_vision_buff) or { not astralpower() >= astralpowercost(starfire) or { buffremaining(celestial_alignment) < 5 and buffpresent(celestial_alignment) or buffremaining(ravenous_frenzy) < gcd() * { astralpower() / 30 } and buffpresent(ravenous_frenzy) } and starfall_wont_fall_off() and enemies(tagged=1) < 3 } and { not equippedruneforge(timeworn_dreambinder_runeforge) or enemies(tagged=1) < 3 } } and spell(starsurge) or { buffpresent(eclipse_any) and spellcooldown(celestial_alignment) > 50 or charges(new_moon) == 2 and spellchargecooldown(new_moon) < 5 or charges(new_moon) == 3 } and astralpower() >= astralpowercost(new_moon) and { not spellknown(half_moon) and not spellknown(full_moon) } and spell(new_moon) or { buffpresent(eclipse_any) and spellcooldown(celestial_alignment) > 50 or charges(half_moon) == 2 and spellchargecooldown(half_moon) < 5 or charges(half_moon) == 3 } and astralpower() >= astralpowercost(half_moon) and spellknown(half_moon) and spell(half_moon) or { buffpresent(eclipse_any) and spellcooldown(celestial_alignment) > 50 or charges(full_moon) == 2 and spellchargecooldown(full_moon) < 5 or charges(full_moon) == 3 } and astralpower() >= astralpowercost(full_moon) and spellknown(full_moon) and spell(full_moon)
   {
    #warrior_of_elune
    spell(warrior_of_elune)

    unless { counter(lunar) == 1 or counter(lunar) + counter(solar) == 1 and is_cleave() or buffremaining(eclipse_solar_buff) < executetime(starfire) and buffpresent(eclipse_solar_buff) or buffpresent(eclipse_solar_buff) and not starfire_in_solar() or buffremaining(celestial_alignment) < executetime(starfire) and not is_cleave() and buffremaining(celestial_alignment) < executetime(wrath_balance) and buffpresent(celestial_alignment) or buffpresent(ravenous_frenzy) and 100 / { 100 + spellcastspeedpercent() } > 0.6 and { enemies(tagged=1) <= 3 or not hastalent(soul_of_the_forest_talent) } or not is_cleave() and buffremaining(celestial_alignment) > executetime(wrath_balance) } and spell(wrath_balance) or spell(starfire)
    {
     #run_action_list,name=fallthru
     balancefallthrushortcdactions()
    }
   }
  }
 }
}

AddFunction balanceaoeshortcdpostconditions
{
 target.refreshable(sunfire_debuff) and target.timetodie() > 14 - enemies(tagged=1) + target.debuffremaining(sunfire_debuff) and { buffpresent(eclipse_any) or target.debuffremaining(sunfire_debuff) < gcd() } and spell(sunfire) or { buffrefreshable(starfall) and { enemies(tagged=1) < 3 or not equippedruneforge(timeworn_dreambinder_runeforge) } or hastalent(soul_of_the_forest_talent) and buffremaining(eclipse_solar_buff) < 3 and buffpresent(eclipse_solar_buff) and buffremaining(starfall) < 7 and enemies(tagged=1) >= 4 } and { not equippedruneforge(lycaras_fleeting_glimpse_runeforge) or timeincombat() % 45 > buffremaining(starfall) + 2 } and target.timetodie() > 5 and spell(starfall) or equippedruneforge(timeworn_dreambinder_runeforge) and enemies(tagged=1) >= 3 and { not buffpresent(timeworn_dreambinder_buff) and buffrefreshable(starfall) or dream_will_fall_off() and { buffremaining(starfall) < 3 or enemies(tagged=1) > 2 and hastalent(stellar_drift_talent) and buffremaining(starfall) < 5 } } and spell(starfall) or { dream_will_fall_off() and starfall_wont_fall_off() and not ignore_starsurge() or { buffstacks(balance_of_all_things_nature_buff) > 3 or buffstacks(balance_of_all_things_arcane_buff) > 3 } and enemies(tagged=1) < 4 } and spell(starsurge) or { not buffpresent(adaptive_swarm) and not inflighttotarget(adaptive_swarm_damage) or target.debuffstacks(adaptive_swarm_damage) < 3 and target.debuffremaining(adaptive_swarm_damage) < 3 } and spell(adaptive_swarm) or target.refreshable(moonfire_debuff) and target.timetodie() > { 14 + enemies(tagged=1) * 1.5 } / enemies(tagged=1) + target.debuffremaining(moonfire_debuff) and { { spellcooldown(celestial_alignment) <= 0 and not checkboxon("no_cds") and { convoke_desync() or spellcooldown(convoke_the_spirits) <= 0 or not iscovenant("night_fae") } or enemies(tagged=1) < 5 * { 1 + talentpoints(twin_moons_talent) } or { buffpresent(eclipse_solar_buff) or { buffpresent(eclipse_solar_buff) and buffpresent(eclipse_lunar_buff) or buffpresent(eclipse_lunar_buff) } and not hastalent(soul_of_the_forest_talent) or buffamount(primordial_arcanic_pulsar_buff) >= 250 } and enemies(tagged=1) < 10 * { 1 + talentpoints(twin_moons_talent) } and astralpower() > 50 - buffremaining(starfall) * 6 } and { not buffpresent(kindred_empowerment_energize) or buffpresent(eclipse_solar_buff) or not iscovenant("kyrian") } and astralpower() >= astralpowercost(moonfire) } and spell(moonfire) or not checkboxon("no_cds") and cd_condition() and { buffpresent(starfall) or astralpower() > 50 } and not buffpresent(solstice_buff) and not buffpresent(celestial_alignment) and { not iscovenant("night_fae") or convoke_desync() or not spellcooldown(convoke_the_spirits) > 0 or fightremains() < spellcooldown(convoke_the_spirits) + 6 or fightremains() % 180 < 30 + conduitvalue(precise_alignment_conduit) } and spell(incarnation) or { fightremains() < 15 or { buffamount(primordial_arcanic_pulsar_buff) < 250 or buffamount(primordial_arcanic_pulsar_buff) >= 250 } and buffpresent(starfall) and { spellcooldown(celestial_alignment) > 50 or checkboxon("no_cds") } } and spell(kindred_spirits) or target.refreshable(stellar_flare) and target.timetodie() > 15 and { enemies(tagged=1) < 4 and astralpower() >= astralpowercost(stellar_flare) and { buffremaining(celestial_alignment) > 10 or not buffpresent(celestial_alignment) } } and spell(stellar_flare) or buffpresent(oneths_perception_buff) and { buffrefreshable(starfall) or astralpower() > 90 } and spell(starfall) or iscovenant("night_fae") and { convoke_desync() or not spellcooldown(celestial_alignment) > 0 or buffpresent(celestial_alignment) } and spellcooldown(convoke_the_spirits) < gcd() * { astralpower() / 50 } and buffremaining(starfall) < 4 and not checkboxon("no_cds") and spell(starfall) or iscovenant("night_fae") and { convoke_desync() or not spellcooldown(celestial_alignment) > 0 or buffpresent(celestial_alignment) } and spellcooldown(convoke_the_spirits) < 6 and buffpresent(starfall) and buffpresent(eclipse_any) and not ignore_starsurge() and not checkboxon("no_cds") and spell(starsurge) or { buffpresent(oneths_clear_vision_buff) or { not astralpower() >= astralpowercost(starfire) or { buffremaining(celestial_alignment) < 5 and buffpresent(celestial_alignment) or buffremaining(ravenous_frenzy) < gcd() * { astralpower() / 30 } and buffpresent(ravenous_frenzy) } and starfall_wont_fall_off() and enemies(tagged=1) < 3 } and { not equippedruneforge(timeworn_dreambinder_runeforge) or enemies(tagged=1) < 3 } } and spell(starsurge) or { buffpresent(eclipse_any) and spellcooldown(celestial_alignment) > 50 or charges(new_moon) == 2 and spellchargecooldown(new_moon) < 5 or charges(new_moon) == 3 } and astralpower() >= astralpowercost(new_moon) and { not spellknown(half_moon) and not spellknown(full_moon) } and spell(new_moon) or { buffpresent(eclipse_any) and spellcooldown(celestial_alignment) > 50 or charges(half_moon) == 2 and spellchargecooldown(half_moon) < 5 or charges(half_moon) == 3 } and astralpower() >= astralpowercost(half_moon) and spellknown(half_moon) and spell(half_moon) or { buffpresent(eclipse_any) and spellcooldown(celestial_alignment) > 50 or charges(full_moon) == 2 and spellchargecooldown(full_moon) < 5 or charges(full_moon) == 3 } and astralpower() >= astralpowercost(full_moon) and spellknown(full_moon) and spell(full_moon) or { counter(lunar) == 1 or counter(lunar) + counter(solar) == 1 and is_cleave() or buffremaining(eclipse_solar_buff) < executetime(starfire) and buffpresent(eclipse_solar_buff) or buffpresent(eclipse_solar_buff) and not starfire_in_solar() or buffremaining(celestial_alignment) < executetime(starfire) and not is_cleave() and buffremaining(celestial_alignment) < executetime(wrath_balance) and buffpresent(celestial_alignment) or buffpresent(ravenous_frenzy) and 100 / { 100 + spellcastspeedpercent() } > 0.6 and { enemies(tagged=1) <= 3 or not hastalent(soul_of_the_forest_talent) } or not is_cleave() and buffremaining(celestial_alignment) > executetime(wrath_balance) } and spell(wrath_balance) or spell(starfire) or balancefallthrushortcdpostconditions()
}

AddFunction balanceaoecdactions
{
 #variable,name=dream_will_fall_off,value=(buff.timeworn_dreambinder.remains<gcd.max+0.1|buff.timeworn_dreambinder.remains<action.starfire.execute_time+0.1&(eclipse.in_lunar|eclipse.solar_next|eclipse.any_next))&buff.timeworn_dreambinder.up&runeforge.timeworn_dreambinder.equipped
 #variable,name=ignore_starsurge,value=buff.eclipse_lunar.up&(spell_targets.starfire>4&talent.soul_of_the_forest.enabled|spell_targets.starfire>6)
 #convoke_the_spirits,if=!druid.no_cds&((variable.convoke_desync&!cooldown.ca_inc.ready|buff.ca_inc.up)&(astral_power<50|variable.ignore_starsurge)&(buff.eclipse_lunar.remains>6|buff.eclipse_solar.remains>6)&(!runeforge.balance_of_all_things|buff.balance_of_all_things_nature.stack>3|buff.balance_of_all_things_arcane.stack>3)|fight_remains<10)
 if not checkboxon("no_cds") and { { convoke_desync() and not spellcooldown(celestial_alignment) <= 0 or buffpresent(celestial_alignment) } and { astralpower() < 50 or ignore_starsurge() } and { buffremaining(eclipse_lunar_buff) > 6 or buffremaining(eclipse_solar_buff) > 6 } and { not runeforge(balance_of_all_things_runeforge) or buffstacks(balance_of_all_things_nature_buff) > 3 or buffstacks(balance_of_all_things_arcane_buff) > 3 } or fightremains() < 10 } spell(convoke_the_spirits)

 unless target.refreshable(sunfire_debuff) and target.timetodie() > 14 - enemies(tagged=1) + target.debuffremaining(sunfire_debuff) and { buffpresent(eclipse_any) or target.debuffremaining(sunfire_debuff) < gcd() } and spell(sunfire) or { buffrefreshable(starfall) and { enemies(tagged=1) < 3 or not equippedruneforge(timeworn_dreambinder_runeforge) } or hastalent(soul_of_the_forest_talent) and buffremaining(eclipse_solar_buff) < 3 and buffpresent(eclipse_solar_buff) and buffremaining(starfall) < 7 and enemies(tagged=1) >= 4 } and { not equippedruneforge(lycaras_fleeting_glimpse_runeforge) or timeincombat() % 45 > buffremaining(starfall) + 2 } and target.timetodie() > 5 and spell(starfall) or equippedruneforge(timeworn_dreambinder_runeforge) and enemies(tagged=1) >= 3 and { not buffpresent(timeworn_dreambinder_buff) and buffrefreshable(starfall) or dream_will_fall_off() and { buffremaining(starfall) < 3 or enemies(tagged=1) > 2 and hastalent(stellar_drift_talent) and buffremaining(starfall) < 5 } } and spell(starfall) or { dream_will_fall_off() and starfall_wont_fall_off() and not ignore_starsurge() or { buffstacks(balance_of_all_things_nature_buff) > 3 or buffstacks(balance_of_all_things_arcane_buff) > 3 } and enemies(tagged=1) < 4 } and spell(starsurge) or { not buffpresent(adaptive_swarm) and not inflighttotarget(adaptive_swarm_damage) or target.debuffstacks(adaptive_swarm_damage) < 3 and target.debuffremaining(adaptive_swarm_damage) < 3 } and spell(adaptive_swarm) or target.refreshable(moonfire_debuff) and target.timetodie() > { 14 + enemies(tagged=1) * 1.5 } / enemies(tagged=1) + target.debuffremaining(moonfire_debuff) and { { spellcooldown(celestial_alignment) <= 0 and not checkboxon("no_cds") and { convoke_desync() or spellcooldown(convoke_the_spirits) <= 0 or not iscovenant("night_fae") } or enemies(tagged=1) < 5 * { 1 + talentpoints(twin_moons_talent) } or { buffpresent(eclipse_solar_buff) or { buffpresent(eclipse_solar_buff) and buffpresent(eclipse_lunar_buff) or buffpresent(eclipse_lunar_buff) } and not hastalent(soul_of_the_forest_talent) or buffamount(primordial_arcanic_pulsar_buff) >= 250 } and enemies(tagged=1) < 10 * { 1 + talentpoints(twin_moons_talent) } and astralpower() > 50 - buffremaining(starfall) * 6 } and { not buffpresent(kindred_empowerment_energize) or buffpresent(eclipse_solar_buff) or not iscovenant("kyrian") } and astralpower() >= astralpowercost(moonfire) } and spell(moonfire) or astralpower() >= astralpowercost(force_of_nature) and spell(force_of_nature)
 {
  #ravenous_frenzy,if=buff.ca_inc.up
  if buffpresent(celestial_alignment) spell(ravenous_frenzy)
  #celestial_alignment,if=!druid.no_cds&variable.cd_condition&(buff.starfall.up|astral_power>50)&!buff.solstice.up&!buff.ca_inc.up&(!covenant.night_fae|variable.convoke_desync|cooldown.convoke_the_spirits.up|interpolated_fight_remains<20+(conduit.precise_alignment.time_value))
  if not checkboxon("no_cds") and cd_condition() and { buffpresent(starfall) or astralpower() > 50 } and not buffpresent(solstice_buff) and not buffpresent(celestial_alignment) and { not iscovenant("night_fae") or convoke_desync() or not spellcooldown(convoke_the_spirits) > 0 or fightremains() < 20 + conduitvalue(precise_alignment_conduit) } spell(celestial_alignment)

  unless not checkboxon("no_cds") and cd_condition() and { buffpresent(starfall) or astralpower() > 50 } and not buffpresent(solstice_buff) and not buffpresent(celestial_alignment) and { not iscovenant("night_fae") or convoke_desync() or not spellcooldown(convoke_the_spirits) > 0 or fightremains() < spellcooldown(convoke_the_spirits) + 6 or fightremains() % 180 < 30 + conduitvalue(precise_alignment_conduit) } and spell(incarnation) or { fightremains() < 15 or { buffamount(primordial_arcanic_pulsar_buff) < 250 or buffamount(primordial_arcanic_pulsar_buff) >= 250 } and buffpresent(starfall) and { spellcooldown(celestial_alignment) > 50 or checkboxon("no_cds") } } and spell(kindred_spirits) or target.refreshable(stellar_flare) and target.timetodie() > 15 and { enemies(tagged=1) < 4 and astralpower() >= astralpowercost(stellar_flare) and { buffremaining(celestial_alignment) > 10 or not buffpresent(celestial_alignment) } } and spell(stellar_flare) or buffpresent(eclipse_any) and astralpower() >= astralpowercost(fury_of_elune) and buffamount(primordial_arcanic_pulsar_buff) < 250 and { target.debuffpresent(adaptive_swarm_damage) or not iscovenant("necrolord") or enemies(tagged=1) > 2 } and spell(fury_of_elune) or buffpresent(oneths_perception_buff) and { buffrefreshable(starfall) or astralpower() > 90 } and spell(starfall) or iscovenant("night_fae") and { convoke_desync() or not spellcooldown(celestial_alignment) > 0 or buffpresent(celestial_alignment) } and spellcooldown(convoke_the_spirits) < gcd() * { astralpower() / 50 } and buffremaining(starfall) < 4 and not checkboxon("no_cds") and spell(starfall) or iscovenant("night_fae") and { convoke_desync() or not spellcooldown(celestial_alignment) > 0 or buffpresent(celestial_alignment) } and spellcooldown(convoke_the_spirits) < 6 and buffpresent(starfall) and buffpresent(eclipse_any) and not ignore_starsurge() and not checkboxon("no_cds") and spell(starsurge) or { buffpresent(oneths_clear_vision_buff) or { not astralpower() >= astralpowercost(starfire) or { buffremaining(celestial_alignment) < 5 and buffpresent(celestial_alignment) or buffremaining(ravenous_frenzy) < gcd() * { astralpower() / 30 } and buffpresent(ravenous_frenzy) } and starfall_wont_fall_off() and enemies(tagged=1) < 3 } and { not equippedruneforge(timeworn_dreambinder_runeforge) or enemies(tagged=1) < 3 } } and spell(starsurge) or { buffpresent(eclipse_any) and spellcooldown(celestial_alignment) > 50 or charges(new_moon) == 2 and spellchargecooldown(new_moon) < 5 or charges(new_moon) == 3 } and astralpower() >= astralpowercost(new_moon) and { not spellknown(half_moon) and not spellknown(full_moon) } and spell(new_moon) or { buffpresent(eclipse_any) and spellcooldown(celestial_alignment) > 50 or charges(half_moon) == 2 and spellchargecooldown(half_moon) < 5 or charges(half_moon) == 3 } and astralpower() >= astralpowercost(half_moon) and spellknown(half_moon) and spell(half_moon) or { buffpresent(eclipse_any) and spellcooldown(celestial_alignment) > 50 or charges(full_moon) == 2 and spellchargecooldown(full_moon) < 5 or charges(full_moon) == 3 } and astralpower() >= astralpowercost(full_moon) and spellknown(full_moon) and spell(full_moon) or spell(warrior_of_elune) or { counter(lunar) == 1 or counter(lunar) + counter(solar) == 1 and is_cleave() or buffremaining(eclipse_solar_buff) < executetime(starfire) and buffpresent(eclipse_solar_buff) or buffpresent(eclipse_solar_buff) and not starfire_in_solar() or buffremaining(celestial_alignment) < executetime(starfire) and not is_cleave() and buffremaining(celestial_alignment) < executetime(wrath_balance) and buffpresent(celestial_alignment) or buffpresent(ravenous_frenzy) and 100 / { 100 + spellcastspeedpercent() } > 0.6 and { enemies(tagged=1) <= 3 or not hastalent(soul_of_the_forest_talent) } or not is_cleave() and buffremaining(celestial_alignment) > executetime(wrath_balance) } and spell(wrath_balance) or spell(starfire)
  {
   #run_action_list,name=fallthru
   balancefallthrucdactions()
  }
 }
}

AddFunction balanceaoecdpostconditions
{
 target.refreshable(sunfire_debuff) and target.timetodie() > 14 - enemies(tagged=1) + target.debuffremaining(sunfire_debuff) and { buffpresent(eclipse_any) or target.debuffremaining(sunfire_debuff) < gcd() } and spell(sunfire) or { buffrefreshable(starfall) and { enemies(tagged=1) < 3 or not equippedruneforge(timeworn_dreambinder_runeforge) } or hastalent(soul_of_the_forest_talent) and buffremaining(eclipse_solar_buff) < 3 and buffpresent(eclipse_solar_buff) and buffremaining(starfall) < 7 and enemies(tagged=1) >= 4 } and { not equippedruneforge(lycaras_fleeting_glimpse_runeforge) or timeincombat() % 45 > buffremaining(starfall) + 2 } and target.timetodie() > 5 and spell(starfall) or equippedruneforge(timeworn_dreambinder_runeforge) and enemies(tagged=1) >= 3 and { not buffpresent(timeworn_dreambinder_buff) and buffrefreshable(starfall) or dream_will_fall_off() and { buffremaining(starfall) < 3 or enemies(tagged=1) > 2 and hastalent(stellar_drift_talent) and buffremaining(starfall) < 5 } } and spell(starfall) or { dream_will_fall_off() and starfall_wont_fall_off() and not ignore_starsurge() or { buffstacks(balance_of_all_things_nature_buff) > 3 or buffstacks(balance_of_all_things_arcane_buff) > 3 } and enemies(tagged=1) < 4 } and spell(starsurge) or { not buffpresent(adaptive_swarm) and not inflighttotarget(adaptive_swarm_damage) or target.debuffstacks(adaptive_swarm_damage) < 3 and target.debuffremaining(adaptive_swarm_damage) < 3 } and spell(adaptive_swarm) or target.refreshable(moonfire_debuff) and target.timetodie() > { 14 + enemies(tagged=1) * 1.5 } / enemies(tagged=1) + target.debuffremaining(moonfire_debuff) and { { spellcooldown(celestial_alignment) <= 0 and not checkboxon("no_cds") and { convoke_desync() or spellcooldown(convoke_the_spirits) <= 0 or not iscovenant("night_fae") } or enemies(tagged=1) < 5 * { 1 + talentpoints(twin_moons_talent) } or { buffpresent(eclipse_solar_buff) or { buffpresent(eclipse_solar_buff) and buffpresent(eclipse_lunar_buff) or buffpresent(eclipse_lunar_buff) } and not hastalent(soul_of_the_forest_talent) or buffamount(primordial_arcanic_pulsar_buff) >= 250 } and enemies(tagged=1) < 10 * { 1 + talentpoints(twin_moons_talent) } and astralpower() > 50 - buffremaining(starfall) * 6 } and { not buffpresent(kindred_empowerment_energize) or buffpresent(eclipse_solar_buff) or not iscovenant("kyrian") } and astralpower() >= astralpowercost(moonfire) } and spell(moonfire) or astralpower() >= astralpowercost(force_of_nature) and spell(force_of_nature) or not checkboxon("no_cds") and cd_condition() and { buffpresent(starfall) or astralpower() > 50 } and not buffpresent(solstice_buff) and not buffpresent(celestial_alignment) and { not iscovenant("night_fae") or convoke_desync() or not spellcooldown(convoke_the_spirits) > 0 or fightremains() < spellcooldown(convoke_the_spirits) + 6 or fightremains() % 180 < 30 + conduitvalue(precise_alignment_conduit) } and spell(incarnation) or { fightremains() < 15 or { buffamount(primordial_arcanic_pulsar_buff) < 250 or buffamount(primordial_arcanic_pulsar_buff) >= 250 } and buffpresent(starfall) and { spellcooldown(celestial_alignment) > 50 or checkboxon("no_cds") } } and spell(kindred_spirits) or target.refreshable(stellar_flare) and target.timetodie() > 15 and { enemies(tagged=1) < 4 and astralpower() >= astralpowercost(stellar_flare) and { buffremaining(celestial_alignment) > 10 or not buffpresent(celestial_alignment) } } and spell(stellar_flare) or buffpresent(eclipse_any) and astralpower() >= astralpowercost(fury_of_elune) and buffamount(primordial_arcanic_pulsar_buff) < 250 and { target.debuffpresent(adaptive_swarm_damage) or not iscovenant("necrolord") or enemies(tagged=1) > 2 } and spell(fury_of_elune) or buffpresent(oneths_perception_buff) and { buffrefreshable(starfall) or astralpower() > 90 } and spell(starfall) or iscovenant("night_fae") and { convoke_desync() or not spellcooldown(celestial_alignment) > 0 or buffpresent(celestial_alignment) } and spellcooldown(convoke_the_spirits) < gcd() * { astralpower() / 50 } and buffremaining(starfall) < 4 and not checkboxon("no_cds") and spell(starfall) or iscovenant("night_fae") and { convoke_desync() or not spellcooldown(celestial_alignment) > 0 or buffpresent(celestial_alignment) } and spellcooldown(convoke_the_spirits) < 6 and buffpresent(starfall) and buffpresent(eclipse_any) and not ignore_starsurge() and not checkboxon("no_cds") and spell(starsurge) or { buffpresent(oneths_clear_vision_buff) or { not astralpower() >= astralpowercost(starfire) or { buffremaining(celestial_alignment) < 5 and buffpresent(celestial_alignment) or buffremaining(ravenous_frenzy) < gcd() * { astralpower() / 30 } and buffpresent(ravenous_frenzy) } and starfall_wont_fall_off() and enemies(tagged=1) < 3 } and { not equippedruneforge(timeworn_dreambinder_runeforge) or enemies(tagged=1) < 3 } } and spell(starsurge) or { buffpresent(eclipse_any) and spellcooldown(celestial_alignment) > 50 or charges(new_moon) == 2 and spellchargecooldown(new_moon) < 5 or charges(new_moon) == 3 } and astralpower() >= astralpowercost(new_moon) and { not spellknown(half_moon) and not spellknown(full_moon) } and spell(new_moon) or { buffpresent(eclipse_any) and spellcooldown(celestial_alignment) > 50 or charges(half_moon) == 2 and spellchargecooldown(half_moon) < 5 or charges(half_moon) == 3 } and astralpower() >= astralpowercost(half_moon) and spellknown(half_moon) and spell(half_moon) or { buffpresent(eclipse_any) and spellcooldown(celestial_alignment) > 50 or charges(full_moon) == 2 and spellchargecooldown(full_moon) < 5 or charges(full_moon) == 3 } and astralpower() >= astralpowercost(full_moon) and spellknown(full_moon) and spell(full_moon) or spell(warrior_of_elune) or { counter(lunar) == 1 or counter(lunar) + counter(solar) == 1 and is_cleave() or buffremaining(eclipse_solar_buff) < executetime(starfire) and buffpresent(eclipse_solar_buff) or buffpresent(eclipse_solar_buff) and not starfire_in_solar() or buffremaining(celestial_alignment) < executetime(starfire) and not is_cleave() and buffremaining(celestial_alignment) < executetime(wrath_balance) and buffpresent(celestial_alignment) or buffpresent(ravenous_frenzy) and 100 / { 100 + spellcastspeedpercent() } > 0.6 and { enemies(tagged=1) <= 3 or not hastalent(soul_of_the_forest_talent) } or not is_cleave() and buffremaining(celestial_alignment) > executetime(wrath_balance) } and spell(wrath_balance) or spell(starfire) or balancefallthrucdpostconditions()
}

### actions.default

AddFunction balance_defaultmainactions
{
 #run_action_list,name=aoe,if=variable.is_aoe
 if is_aoe() balanceaoemainactions()

 unless is_aoe() and balanceaoemainpostconditions()
 {
  #run_action_list,name=dreambinder,if=runeforge.timeworn_dreambinder.equipped
  if equippedruneforge(timeworn_dreambinder_runeforge) balancedreambindermainactions()

  unless equippedruneforge(timeworn_dreambinder_runeforge) and balancedreambindermainpostconditions()
  {
   #run_action_list,name=boat,if=runeforge.balance_of_all_things.equipped
   if equippedruneforge(balance_of_all_things_runeforge) balanceboatmainactions()

   unless equippedruneforge(balance_of_all_things_runeforge) and balanceboatmainpostconditions()
   {
    #run_action_list,name=st
    balancestmainactions()
   }
  }
 }
}

AddFunction balance_defaultmainpostconditions
{
 is_aoe() and balanceaoemainpostconditions() or equippedruneforge(timeworn_dreambinder_runeforge) and balancedreambindermainpostconditions() or equippedruneforge(balance_of_all_things_runeforge) and balanceboatmainpostconditions() or balancestmainpostconditions()
}

AddFunction balance_defaultshortcdactions
{
 #run_action_list,name=aoe,if=variable.is_aoe
 if is_aoe() balanceaoeshortcdactions()

 unless is_aoe() and balanceaoeshortcdpostconditions()
 {
  #run_action_list,name=dreambinder,if=runeforge.timeworn_dreambinder.equipped
  if equippedruneforge(timeworn_dreambinder_runeforge) balancedreambindershortcdactions()

  unless equippedruneforge(timeworn_dreambinder_runeforge) and balancedreambindershortcdpostconditions()
  {
   #run_action_list,name=boat,if=runeforge.balance_of_all_things.equipped
   if equippedruneforge(balance_of_all_things_runeforge) balanceboatshortcdactions()

   unless equippedruneforge(balance_of_all_things_runeforge) and balanceboatshortcdpostconditions()
   {
    #run_action_list,name=st
    balancestshortcdactions()
   }
  }
 }
}

AddFunction balance_defaultshortcdpostconditions
{
 is_aoe() and balanceaoeshortcdpostconditions() or equippedruneforge(timeworn_dreambinder_runeforge) and balancedreambindershortcdpostconditions() or equippedruneforge(balance_of_all_things_runeforge) and balanceboatshortcdpostconditions() or balancestshortcdpostconditions()
}

AddFunction balance_defaultcdactions
{
 balanceinterruptactions()
 #variable,name=is_aoe,value=spell_targets.starfall>1&(!talent.starlord.enabled|talent.stellar_drift.enabled)|spell_targets.starfall>2
 #variable,name=is_cleave,value=spell_targets.starfire>1
 #berserking,if=(!covenant.night_fae|!cooldown.convoke_the_spirits.up)&buff.ca_inc.up
 if { not iscovenant("night_fae") or not { not spellcooldown(convoke_the_spirits) > 0 } } and buffpresent(celestial_alignment) spell(berserking)
 #potion,if=buff.ca_inc.up
 if buffpresent(celestial_alignment) and { checkboxon(opt_use_consumables) and target.classification(worldboss) } item(potion_of_spectral_intellect_item usable=1)
 #variable,name=convoke_desync,value=ceil((interpolated_fight_remains-15-cooldown.ca_inc.remains)%180)=ceil((interpolated_fight_remains-15-120-cooldown.convoke_the_spirits.remains)%180)|cooldown.ca_inc.remains>interpolated_fight_remains|cooldown.convoke_the_spirits.remains>interpolated_fight_remains|!covenant.night_fae
 #variable,name=cd_condition,value=(!equipped.empyreal_ordnance|cooldown.empyreal_ordnance.remains<160&!cooldown.empyreal_ordnance.ready)|covenant.kyrian
 #use_item,name=empyreal_ordnance,if=cooldown.ca_inc.remains<20&cooldown.convoke_the_spirits.remains<20|fight_remains<37
 if spellcooldown(celestial_alignment) < 20 and spellcooldown(convoke_the_spirits) < 20 or fightremains() < 37 balanceuseitemactions()
 #use_item,name=soulletting_ruby,if=cooldown.ca_inc.remains<6&!variable.convoke_desync|cooldown.convoke_the_spirits.remains<6&variable.convoke_desync|fight_remains<25
 if spellcooldown(celestial_alignment) < 6 and not convoke_desync() or spellcooldown(convoke_the_spirits) < 6 and convoke_desync() or fightremains() < 25 balanceuseitemactions()
 #use_item,name=inscrutable_quantum_device,if=buff.ca_inc.up
 if buffpresent(celestial_alignment) balanceuseitemactions()
 #use_items,slots=trinket1,if=!trinket.1.has_proc.any&(!trinket.2.has_proc.any|!trinket.2.ready_cooldown|!trinket.2.cooldown.duration)|(!trinket.1.has_proc.any&!trinket.2.has_proc.any&!trinket.2.cooldown.duration|trinket.1.has_proc.any)&(buff.ca_inc.up|cooldown.ca_inc.remains-10>trinket.1.cooldown.duration&!covenant.kyrian|covenant.night_fae&variable.convoke_desync&cooldown.convoke_the_spirits.up&!cooldown.ca_inc.up&((buff.eclipse_lunar.remains>10|buff.eclipse_solar.remains>10)&!runeforge.balance_of_all_things|runeforge.balance_of_all_things&(buff.balance_of_all_things_nature.stack>3|buff.balance_of_all_things_arcane.stack>3))|buff.kindred_empowerment_energize.up)|fight_remains<20
 if not itemrppm(slot="trinket0slot") > 0 and { not itemrppm(slot="trinket1slot") > 0 or not 0 or not itemcooldownduration(slot="trinket1slot") } or { not itemrppm(slot="trinket0slot") > 0 and not itemrppm(slot="trinket1slot") > 0 and not itemcooldownduration(slot="trinket1slot") or itemrppm(slot="trinket0slot") > 0 } and { buffpresent(celestial_alignment) or spellcooldown(celestial_alignment) - 10 > itemcooldownduration(slot="trinket0slot") and not iscovenant("kyrian") or iscovenant("night_fae") and convoke_desync() and not spellcooldown(convoke_the_spirits) > 0 and not { not spellcooldown(celestial_alignment) > 0 } and { { buffremaining(eclipse_lunar_buff) > 10 or buffremaining(eclipse_solar_buff) > 10 } and not runeforge(balance_of_all_things_runeforge) or runeforge(balance_of_all_things_runeforge) and { buffstacks(balance_of_all_things_nature_buff) > 3 or buffstacks(balance_of_all_things_arcane_buff) > 3 } } or buffpresent(kindred_empowerment_energize) } or fightremains() < 20 balanceuseitemactions()
 #use_items,slots=trinket2,if=!trinket.2.has_proc.any&(!trinket.1.has_proc.any|!trinket.1.ready_cooldown|!trinket.1.cooldown.duration)|trinket.1.has_proc.any&trinket.2.has_proc.any&!trinket.1.ready_cooldown|buff.ca_inc.up|cooldown.ca_inc.remains-10>trinket.2.cooldown.duration&!covenant.kyrian|covenant.night_fae&variable.convoke_desync&cooldown.convoke_the_spirits.up&!cooldown.ca_inc.up&((buff.eclipse_lunar.remains>10|buff.eclipse_solar.remains>10)&!runeforge.balance_of_all_things|runeforge.balance_of_all_things&(buff.balance_of_all_things_nature.stack>3|buff.balance_of_all_things_arcane.stack>3))|buff.kindred_empowerment_energize.up|fight_remains<20
 if not itemrppm(slot="trinket1slot") > 0 and { not itemrppm(slot="trinket0slot") > 0 or not 0 or not itemcooldownduration(slot="trinket0slot") } or itemrppm(slot="trinket0slot") > 0 and itemrppm(slot="trinket1slot") > 0 and not 0 or buffpresent(celestial_alignment) or spellcooldown(celestial_alignment) - 10 > itemcooldownduration(slot="trinket1slot") and not iscovenant("kyrian") or iscovenant("night_fae") and convoke_desync() and not spellcooldown(convoke_the_spirits) > 0 and not { not spellcooldown(celestial_alignment) > 0 } and { { buffremaining(eclipse_lunar_buff) > 10 or buffremaining(eclipse_solar_buff) > 10 } and not runeforge(balance_of_all_things_runeforge) or runeforge(balance_of_all_things_runeforge) and { buffstacks(balance_of_all_things_nature_buff) > 3 or buffstacks(balance_of_all_things_arcane_buff) > 3 } } or buffpresent(kindred_empowerment_energize) or fightremains() < 20 balanceuseitemactions()
 #use_items
 balanceuseitemactions()
 #run_action_list,name=aoe,if=variable.is_aoe
 if is_aoe() balanceaoecdactions()

 unless is_aoe() and balanceaoecdpostconditions()
 {
  #run_action_list,name=dreambinder,if=runeforge.timeworn_dreambinder.equipped
  if equippedruneforge(timeworn_dreambinder_runeforge) balancedreambindercdactions()

  unless equippedruneforge(timeworn_dreambinder_runeforge) and balancedreambindercdpostconditions()
  {
   #run_action_list,name=boat,if=runeforge.balance_of_all_things.equipped
   if equippedruneforge(balance_of_all_things_runeforge) balanceboatcdactions()

   unless equippedruneforge(balance_of_all_things_runeforge) and balanceboatcdpostconditions()
   {
    #run_action_list,name=st
    balancestcdactions()
   }
  }
 }
}

AddFunction balance_defaultcdpostconditions
{
 is_aoe() and balanceaoecdpostconditions() or equippedruneforge(timeworn_dreambinder_runeforge) and balancedreambindercdpostconditions() or equippedruneforge(balance_of_all_things_runeforge) and balanceboatcdpostconditions() or balancestcdpostconditions()
}

### Balance icons.

AddCheckBox(opt_druid_balance_aoe l(aoe) default enabled=(specialization(balance)))

AddIcon enabled=(not checkboxon(opt_druid_balance_aoe) and specialization(balance)) enemies=1 help=shortcd
{
 if not incombat() balanceprecombatshortcdactions()
 balance_defaultshortcdactions()
}

AddIcon enabled=(checkboxon(opt_druid_balance_aoe) and specialization(balance)) help=shortcd
{
 if not incombat() balanceprecombatshortcdactions()
 balance_defaultshortcdactions()
}

AddIcon enabled=(specialization(balance)) enemies=1 help=main
{
 if not incombat() balanceprecombatmainactions()
 balance_defaultmainactions()
}

AddIcon enabled=(checkboxon(opt_druid_balance_aoe) and specialization(balance)) help=aoe
{
 if not incombat() balanceprecombatmainactions()
 balance_defaultmainactions()
}

AddIcon enabled=(not checkboxon(opt_druid_balance_aoe) and specialization(balance)) enemies=1 help=cd
{
 if not incombat() balanceprecombatcdactions()
 balance_defaultcdactions()
}

AddIcon enabled=(checkboxon(opt_druid_balance_aoe) and specialization(balance)) help=cd
{
 if not incombat() balanceprecombatcdactions()
 balance_defaultcdactions()
}

### Required symbols
# adaptive_swarm
# adaptive_swarm_damage
# balance_of_all_things_arcane_buff
# balance_of_all_things_nature_buff
# balance_of_all_things_runeforge
# berserking
# bloodlust
# celestial_alignment
# convoke_the_spirits
# eclipse_any
# eclipse_lunar_buff
# eclipse_solar_buff
# empower_bond
# empyreal_ordnance
# empyreal_ordnance_item
# force_of_nature
# full_moon
# fury_of_elune
# half_moon
# incarnation
# kindred_empowerment_energize
# kindred_spirits
# lycaras_fleeting_glimpse_runeforge
# mighty_bash
# moonfire
# moonfire_debuff
# moonkin_form
# natures_balance_talent
# new_moon
# oneths_clear_vision_buff
# oneths_perception_buff
# potion_of_spectral_intellect_item
# precise_alignment_conduit
# primordial_arcanic_pulsar_buff
# primordial_arcanic_pulsar_runeforge
# ravenous_frenzy
# solar_beam
# solstice_buff
# soul_of_the_forest_talent
# starfall
# starfire
# starlord_buff
# starlord_talent
# starsurge
# starsurge_empowerment_solar_buff
# stellar_drift_talent
# stellar_flare
# sunfire
# sunfire_debuff
# timeworn_dreambinder_buff
# timeworn_dreambinder_runeforge
# twin_moons_talent
# typhoon
# war_stomp
# warrior_of_elune
# wrath_balance
]]
        scripts:registerScript("DRUID", "balance", name, desc, code, "script")
    end
    do
        local name = "sc_t26_druid_feral"
        local desc = "[9.0] Simulationcraft: T26_Druid_Feral"
        local code = [[
# Based on SimulationCraft profile "T26_Druid_Feral".
#	class=druid
#	spec=feral
#	talents=2331122

Include(ovale_common)
Include(ovale_druid_spells)


AddFunction shortest_ttd
{
 if 0 == 0 target.timetodie()
}

AddFunction best_rip
{
 if hastalent(primal_wrath_talent) 0
}

AddFunction owlweave
{
 checkboxon("owlweave_cat")
}

AddFunction thrash_ticks
{
 1
}

AddFunction rip_ticks
{
 7
}

AddFunction filler
{
 0
}

AddFunction _4cp_bite
{
 0
}

AddCheckBox(opt_interrupt l(interrupt) default enabled=(specialization(feral)))
AddCheckBox(opt_melee_range l(not_in_melee_range) enabled=(specialization(feral)))
AddCheckBox(opt_use_consumables l(opt_use_consumables) default enabled=(specialization(feral)))
AddCheckBox(owlweave_cat l(owlweave_cat) default enabled=(specialization(feral)))

AddFunction feralinterruptactions
{
 if checkboxon(opt_interrupt) and not target.isfriend() and target.casting()
 {
  if target.inrange(skull_bash) and target.isinterruptible() spell(skull_bash)
  if target.inrange(mighty_bash) and not target.classification(worldboss) spell(mighty_bash)
  if target.inrange(maim) and not target.classification(worldboss) spell(maim)
  if target.distance() < 5 and not target.classification(worldboss) spell(war_stomp)
  if target.distance() < 15 and not target.classification(worldboss) spell(typhoon)
 }
}

AddFunction feraluseitemactions
{
 item(trinket0slot text=13 usable=1)
 item(trinket1slot text=14 usable=1)
}

AddFunction feralgetinmeleerange
{
 if checkboxon(opt_melee_range)
 {
  if stance(druid_bear_form) and not target.inrange(mangle)
  {
   if target.inrange(wild_charge_bear) spell(wild_charge_bear)
   texture(misc_arrowlup help=(l(not_in_melee_range)))
  }
  if (stance(druid_cat_form) or stance(druid_claws_of_shirvallah)) and not target.inrange(shred)
  {
   if target.inrange(wild_charge_cat) spell(wild_charge_cat)
   texture(misc_arrowlup help=(l(not_in_melee_range)))
  }
 }
}

### actions.stealth

AddFunction feralstealthmainactions
{
 #pool_resource,for_next=1
 #rake,target_if=(dot.rake.pmultiplier<1.5|refreshable)&druid.rake.ticks_gained_on_refresh>2
 if { target.debuffpersistentmultiplier(rake_debuff) < 1.5 or target.refreshable(rake_debuff) } and target.ticksgainedonrefresh(rake_debuff) > 2 spell(rake)
 unless { target.debuffpersistentmultiplier(rake_debuff) < 1.5 or target.refreshable(rake_debuff) } and target.ticksgainedonrefresh(rake_debuff) > 2 and { spellusable(rake) and spellcooldown(rake) < timetoenergyfor(rake) }
 {
  #pool_resource,for_next=1
  #thrash_cat,target_if=refreshable&druid.thrash_cat.ticks_gained_on_refresh>variable.thrash_ticks,if=spell_targets.thrash_cat>3
  if target.refreshable(thrash_cat) and target.ticksgainedonrefresh(thrash_cat) > thrash_ticks() and enemies(tagged=1) > 3 spell(thrash_cat)
  unless target.refreshable(thrash_cat) and target.ticksgainedonrefresh(thrash_cat) > thrash_ticks() and enemies(tagged=1) > 3 and { spellusable(thrash_cat) and spellcooldown(thrash_cat) < timetoenergyfor(thrash_cat) }
  {
   #brutal_slash,if=spell_targets.brutal_slash>2
   if enemies(tagged=1) > 2 spell(brutal_slash)
   #pool_resource,for_next=1
   #shred,if=combo_points<4
   if combopoints() < 4 spell(shred)
  }
 }
}

AddFunction feralstealthmainpostconditions
{
}

AddFunction feralstealthshortcdactions
{
}

AddFunction feralstealthshortcdpostconditions
{
 { target.debuffpersistentmultiplier(rake_debuff) < 1.5 or target.refreshable(rake_debuff) } and target.ticksgainedonrefresh(rake_debuff) > 2 and spell(rake) or not { { target.debuffpersistentmultiplier(rake_debuff) < 1.5 or target.refreshable(rake_debuff) } and target.ticksgainedonrefresh(rake_debuff) > 2 and { spellusable(rake) and spellcooldown(rake) < timetoenergyfor(rake) } } and { target.refreshable(thrash_cat) and target.ticksgainedonrefresh(thrash_cat) > thrash_ticks() and enemies(tagged=1) > 3 and spell(thrash_cat) or not { target.refreshable(thrash_cat) and target.ticksgainedonrefresh(thrash_cat) > thrash_ticks() and enemies(tagged=1) > 3 and { spellusable(thrash_cat) and spellcooldown(thrash_cat) < timetoenergyfor(thrash_cat) } } and { enemies(tagged=1) > 2 and spell(brutal_slash) or combopoints() < 4 and spell(shred) } }
}

AddFunction feralstealthcdactions
{
}

AddFunction feralstealthcdpostconditions
{
 { target.debuffpersistentmultiplier(rake_debuff) < 1.5 or target.refreshable(rake_debuff) } and target.ticksgainedonrefresh(rake_debuff) > 2 and spell(rake) or not { { target.debuffpersistentmultiplier(rake_debuff) < 1.5 or target.refreshable(rake_debuff) } and target.ticksgainedonrefresh(rake_debuff) > 2 and { spellusable(rake) and spellcooldown(rake) < timetoenergyfor(rake) } } and { target.refreshable(thrash_cat) and target.ticksgainedonrefresh(thrash_cat) > thrash_ticks() and enemies(tagged=1) > 3 and spell(thrash_cat) or not { target.refreshable(thrash_cat) and target.ticksgainedonrefresh(thrash_cat) > thrash_ticks() and enemies(tagged=1) > 3 and { spellusable(thrash_cat) and spellcooldown(thrash_cat) < timetoenergyfor(thrash_cat) } } and { enemies(tagged=1) > 2 and spell(brutal_slash) or combopoints() < 4 and spell(shred) } }
}

### actions.precombat

AddFunction feralprecombatmainactions
{
 #flask
 #food
 #augmentation
 #snapshot_stats
 #flask
 #food
 #augmentation
 #variable,name=4cp_bite,value=0
 #variable,name=filler,value=0
 #variable,name=rip_ticks,value=7
 #variable,name=thrash_ticks,value=1
 #variable,name=owlweave,value=druid.owlweave_cat
 #snapshot_stats
 #cat_form
 if buffexpires(cat_form) spell(cat_form)
 #prowl
 if buffexpires(prowl) spell(prowl)
}

AddFunction feralprecombatmainpostconditions
{
}

AddFunction feralprecombatshortcdactions
{
}

AddFunction feralprecombatshortcdpostconditions
{
 buffexpires(cat_form) and spell(cat_form) or buffexpires(prowl) and spell(prowl)
}

AddFunction feralprecombatcdactions
{
}

AddFunction feralprecombatcdpostconditions
{
 buffexpires(cat_form) and spell(cat_form) or buffexpires(prowl) and spell(prowl)
}

### actions.owlweave

AddFunction feralowlweavemainactions
{
 #starsurge,if=buff.heart_of_the_wild.up
 if buffpresent(heart_of_the_wild) spell(starsurge)
 #sunfire,if=!prev_gcd.1.sunfire&!prev_gcd.2.sunfire
 if not previousgcdspell(sunfire) and not previousgcdspell(sunfire count=2) spell(sunfire)
 #moonkin_form,if=energy<40&(dot.rip.remains>4.5|combo_points<5)&cooldown.tigers_fury.remains>=6.5&buff.clearcasting.stack<1&!buff.apex_predators_craving.up&!buff.bloodlust.up&(buff.bs_inc.remains>5|!buff.bs_inc.up)&(!cooldown.convoke_the_spirits.up|!covenant.night_fae)
 if energy() < 40 and { target.debuffremaining(rip) > 4.5 or combopoints() < 5 } and spellcooldown(tigers_fury) >= 6.5 and buffstacks(clearcasting_feral_buff) < 1 and not buffpresent(apex_predators_craving_buff) and not buffpresent(bloodlust) and { buffremaining(bs_inc_buff) > 5 or not buffpresent(bs_inc_buff) } and { not { not spellcooldown(convoke_the_spirits) > 0 } or not iscovenant("night_fae") } spell(moonkin_form)
}

AddFunction feralowlweavemainpostconditions
{
}

AddFunction feralowlweaveshortcdactions
{
}

AddFunction feralowlweaveshortcdpostconditions
{
 buffpresent(heart_of_the_wild) and spell(starsurge) or not previousgcdspell(sunfire) and not previousgcdspell(sunfire count=2) and spell(sunfire) or energy() < 40 and { target.debuffremaining(rip) > 4.5 or combopoints() < 5 } and spellcooldown(tigers_fury) >= 6.5 and buffstacks(clearcasting_feral_buff) < 1 and not buffpresent(apex_predators_craving_buff) and not buffpresent(bloodlust) and { buffremaining(bs_inc_buff) > 5 or not buffpresent(bs_inc_buff) } and { not { not spellcooldown(convoke_the_spirits) > 0 } or not iscovenant("night_fae") } and spell(moonkin_form)
}

AddFunction feralowlweavecdactions
{
 unless buffpresent(heart_of_the_wild) and spell(starsurge) or not previousgcdspell(sunfire) and not previousgcdspell(sunfire count=2) and spell(sunfire)
 {
  #heart_of_the_wild,if=energy<40&(dot.rip.remains>4.5|combo_points<5)&cooldown.tigers_fury.remains>=6.5&buff.clearcasting.stack<1&!buff.apex_predators_craving.up&!buff.bloodlust.up&(buff.bs_inc.remains>5|!buff.bs_inc.up)&(!cooldown.convoke_the_spirits.up|!covenant.night_fae)
  if energy() < 40 and { target.debuffremaining(rip) > 4.5 or combopoints() < 5 } and spellcooldown(tigers_fury) >= 6.5 and buffstacks(clearcasting_feral_buff) < 1 and not buffpresent(apex_predators_craving_buff) and not buffpresent(bloodlust) and { buffremaining(bs_inc_buff) > 5 or not buffpresent(bs_inc_buff) } and { not { not spellcooldown(convoke_the_spirits) > 0 } or not iscovenant("night_fae") } spell(heart_of_the_wild)
 }
}

AddFunction feralowlweavecdpostconditions
{
 buffpresent(heart_of_the_wild) and spell(starsurge) or not previousgcdspell(sunfire) and not previousgcdspell(sunfire count=2) and spell(sunfire) or energy() < 40 and { target.debuffremaining(rip) > 4.5 or combopoints() < 5 } and spellcooldown(tigers_fury) >= 6.5 and buffstacks(clearcasting_feral_buff) < 1 and not buffpresent(apex_predators_craving_buff) and not buffpresent(bloodlust) and { buffremaining(bs_inc_buff) > 5 or not buffpresent(bs_inc_buff) } and { not { not spellcooldown(convoke_the_spirits) > 0 } or not iscovenant("night_fae") } and spell(moonkin_form)
}

### actions.finisher

AddFunction feralfinishermainactions
{
 #savage_roar,if=buff.savage_roar.down|buff.savage_roar.remains<(combo_points*6+1)*0.3
 if buffexpires(savage_roar) or buffremaining(savage_roar) < { combopoints() * 6 + 1 } * 0.3 spell(savage_roar)
 #variable,name=best_rip,value=0,if=talent.primal_wrath.enabled
 #cycling_variable,name=best_rip,op=max,value=druid.rip.ticks_gained_on_refresh,if=talent.primal_wrath.enabled
 #primal_wrath,if=spell_targets.primal_wrath>2
 if enemies(tagged=1) > 2 and enemies(tagged=1) > 1 spell(primal_wrath)
 #rip,target_if=refreshable&druid.rip.ticks_gained_on_refresh>variable.rip_ticks&((buff.tigers_fury.up|cooldown.tigers_fury.remains>5)&(buff.bloodtalons.up|!talent.bloodtalons.enabled)&dot.rip.pmultiplier<=persistent_multiplier|!talent.sabertooth.enabled)
 if target.refreshable(rip) and target.ticksgainedonrefresh(rip) > rip_ticks() and { { buffpresent(tigers_fury) or spellcooldown(tigers_fury) > 5 } and { buffpresent(bloodtalons_buff) or not hastalent(bloodtalons_talent) } and target.debuffpersistentmultiplier(rip) <= persistentmultiplier(rip) or not hastalent(sabertooth_talent) } spell(rip)
 #ferocious_bite,max_energy=1,target_if=max:time_to_die
 if energy() >= energycost(ferocious_bite max=1) spell(ferocious_bite)
}

AddFunction feralfinishermainpostconditions
{
}

AddFunction feralfinishershortcdactions
{
}

AddFunction feralfinishershortcdpostconditions
{
 { buffexpires(savage_roar) or buffremaining(savage_roar) < { combopoints() * 6 + 1 } * 0.3 } and spell(savage_roar) or enemies(tagged=1) > 2 and enemies(tagged=1) > 1 and spell(primal_wrath) or target.refreshable(rip) and target.ticksgainedonrefresh(rip) > rip_ticks() and { { buffpresent(tigers_fury) or spellcooldown(tigers_fury) > 5 } and { buffpresent(bloodtalons_buff) or not hastalent(bloodtalons_talent) } and target.debuffpersistentmultiplier(rip) <= persistentmultiplier(rip) or not hastalent(sabertooth_talent) } and spell(rip) or energy() >= energycost(ferocious_bite max=1) and spell(ferocious_bite)
}

AddFunction feralfinishercdactions
{
}

AddFunction feralfinishercdpostconditions
{
 { buffexpires(savage_roar) or buffremaining(savage_roar) < { combopoints() * 6 + 1 } * 0.3 } and spell(savage_roar) or enemies(tagged=1) > 2 and enemies(tagged=1) > 1 and spell(primal_wrath) or target.refreshable(rip) and target.ticksgainedonrefresh(rip) > rip_ticks() and { { buffpresent(tigers_fury) or spellcooldown(tigers_fury) > 5 } and { buffpresent(bloodtalons_buff) or not hastalent(bloodtalons_talent) } and target.debuffpersistentmultiplier(rip) <= persistentmultiplier(rip) or not hastalent(sabertooth_talent) } and spell(rip) or energy() >= energycost(ferocious_bite max=1) and spell(ferocious_bite)
}

### actions.filler

AddFunction feralfillermainactions
{
 #rake,target_if=variable.filler=1&dot.rake.pmultiplier<=persistent_multiplier
 if filler() == 1 and target.debuffpersistentmultiplier(rake_debuff) <= persistentmultiplier(rake_debuff) spell(rake)
 #rake,if=variable.filler=2
 if filler() == 2 spell(rake)
 #lunar_inspiration,if=variable.filler=3
 if filler() == 3 spell(moonfire_cat)
 #swipe,if=variable.filler=4
 if filler() == 4 spell(swipe)
 #shred
 spell(shred)
}

AddFunction feralfillermainpostconditions
{
}

AddFunction feralfillershortcdactions
{
}

AddFunction feralfillershortcdpostconditions
{
 filler() == 1 and target.debuffpersistentmultiplier(rake_debuff) <= persistentmultiplier(rake_debuff) and spell(rake) or filler() == 2 and spell(rake) or filler() == 3 and spell(moonfire_cat) or filler() == 4 and spell(swipe) or spell(shred)
}

AddFunction feralfillercdactions
{
}

AddFunction feralfillercdpostconditions
{
 filler() == 1 and target.debuffpersistentmultiplier(rake_debuff) <= persistentmultiplier(rake_debuff) and spell(rake) or filler() == 2 and spell(rake) or filler() == 3 and spell(moonfire_cat) or filler() == 4 and spell(swipe) or spell(shred)
}

### actions.cooldown

AddFunction feralcooldownmainactions
{
 #berserk,if=combo_points>=3
 if combopoints() >= 3 spell(berserk)
 #incarnation,if=combo_points>=3
 if combopoints() >= 3 spell(incarnation)
 #kindred_spirits,if=buff.tigers_fury.up|(conduit.deep_allegiance.enabled)
 if buffpresent(tigers_fury) or conduit(deep_allegiance_conduit) spell(kindred_spirits)
 #adaptive_swarm,target_if=max:time_to_die*(combo_points=5&!dot.adaptive_swarm_damage.ticking)
 spell(adaptive_swarm)
}

AddFunction feralcooldownmainpostconditions
{
}

AddFunction feralcooldownshortcdactions
{
 #feral_frenzy,if=combo_points<3
 if combopoints() < 3 spell(feral_frenzy)

 unless combopoints() >= 3 and spell(berserk) or combopoints() >= 3 and spell(incarnation)
 {
  #tigers_fury,if=energy.deficit>40|buff.bs_inc.up|(talent.predator.enabled&variable.shortest_ttd<3)
  if energydeficit() > 40 or buffpresent(bs_inc_buff) or hastalent(predator_talent) and shortest_ttd() < 3 spell(tigers_fury)
 }
}

AddFunction feralcooldownshortcdpostconditions
{
 combopoints() >= 3 and spell(berserk) or combopoints() >= 3 and spell(incarnation) or { buffpresent(tigers_fury) or conduit(deep_allegiance_conduit) } and spell(kindred_spirits) or spell(adaptive_swarm)
}

AddFunction feralcooldowncdactions
{
 unless combopoints() < 3 and spell(feral_frenzy) or combopoints() >= 3 and spell(berserk) or combopoints() >= 3 and spell(incarnation) or { energydeficit() > 40 or buffpresent(bs_inc_buff) or hastalent(predator_talent) and shortest_ttd() < 3 } and spell(tigers_fury)
 {
  #shadowmeld,if=buff.tigers_fury.up&buff.bs_inc.down&combo_points<4&dot.rake.pmultiplier<1.6&energy>40
  if buffpresent(tigers_fury) and buffexpires(bs_inc_buff) and combopoints() < 4 and target.debuffpersistentmultiplier(rake_debuff) < 1.6 and energy() > 40 spell(shadowmeld)
  #berserking,if=buff.tigers_fury.up|buff.bs_inc.up
  if buffpresent(tigers_fury) or buffpresent(bs_inc_buff) spell(berserking)
  #potion,if=buff.bs_inc.up
  if buffpresent(bs_inc_buff) and { checkboxon(opt_use_consumables) and target.classification(worldboss) } item(potion_of_spectral_agility_item usable=1)
  #ravenous_frenzy,if=buff.bs_inc.up|fight_remains<21
  if buffpresent(bs_inc_buff) or fightremains() < 21 spell(ravenous_frenzy)
  #convoke_the_spirits,if=(dot.rip.remains>4&combo_points<3&dot.rake.ticking&energy.deficit>=20)|fight_remains<5
  if target.debuffremaining(rip) > 4 and combopoints() < 3 and target.debuffpresent(rake_debuff) and energydeficit() >= 20 or fightremains() < 5 spell(convoke_the_spirits)

  unless { buffpresent(tigers_fury) or conduit(deep_allegiance_conduit) } and spell(kindred_spirits) or spell(adaptive_swarm)
  {
   #use_items
   feraluseitemactions()
  }
 }
}

AddFunction feralcooldowncdpostconditions
{
 combopoints() < 3 and spell(feral_frenzy) or combopoints() >= 3 and spell(berserk) or combopoints() >= 3 and spell(incarnation) or { energydeficit() > 40 or buffpresent(bs_inc_buff) or hastalent(predator_talent) and shortest_ttd() < 3 } and spell(tigers_fury) or { buffpresent(tigers_fury) or conduit(deep_allegiance_conduit) } and spell(kindred_spirits) or spell(adaptive_swarm)
}

### actions.bloodtalons

AddFunction feralbloodtalonsmainactions
{
 #rake,target_if=(!ticking|(refreshable&persistent_multiplier>dot.rake.pmultiplier)|(active_bt_triggers=2&persistent_multiplier>dot.rake.pmultiplier)|(active_bt_triggers=2&refreshable))&buff.bt_rake.down&druid.rake.ticks_gained_on_refresh>=2
 if { not target.debuffpresent(rake_debuff) or target.refreshable(rake_debuff) and persistentmultiplier(rake_debuff) > target.debuffpersistentmultiplier(rake_debuff) or buffcount(bt_buffs) == 2 and persistentmultiplier(rake_debuff) > target.debuffpersistentmultiplier(rake_debuff) or buffcount(bt_buffs) == 2 and target.refreshable(rake_debuff) } and buffexpires(bt_rake_buff) and target.ticksgainedonrefresh(rake_debuff) >= 2 spell(rake)
 #lunar_inspiration,target_if=refreshable&buff.bt_moonfire.down
 if target.refreshable(moonfire_cat) and buffexpires(bt_moonfire_buff) spell(moonfire_cat)
 #thrash_cat,target_if=refreshable&buff.bt_thrash.down&druid.thrash_cat.ticks_gained_on_refresh>variable.thrash_ticks
 if target.refreshable(thrash_cat) and buffexpires(bt_thrash_buff) and target.ticksgainedonrefresh(thrash_cat) > thrash_ticks() spell(thrash_cat)
 #brutal_slash,if=buff.bt_brutal_slash.down
 if buffexpires(bt_brutal_slash_buff) spell(brutal_slash)
 #swipe_cat,if=buff.bt_swipe.down&spell_targets.swipe_cat>1
 if buffexpires(bt_swipe_buff) and enemies(tagged=1) > 1 spell(swipe_cat)
 #shred,if=buff.bt_shred.down
 if buffexpires(bt_shred_buff) spell(shred)
 #swipe_cat,if=buff.bt_swipe.down
 if buffexpires(bt_swipe_buff) spell(swipe_cat)
 #thrash_cat,if=buff.bt_thrash.down
 if buffexpires(bt_thrash_buff) spell(thrash_cat)
}

AddFunction feralbloodtalonsmainpostconditions
{
}

AddFunction feralbloodtalonsshortcdactions
{
}

AddFunction feralbloodtalonsshortcdpostconditions
{
 { not target.debuffpresent(rake_debuff) or target.refreshable(rake_debuff) and persistentmultiplier(rake_debuff) > target.debuffpersistentmultiplier(rake_debuff) or buffcount(bt_buffs) == 2 and persistentmultiplier(rake_debuff) > target.debuffpersistentmultiplier(rake_debuff) or buffcount(bt_buffs) == 2 and target.refreshable(rake_debuff) } and buffexpires(bt_rake_buff) and target.ticksgainedonrefresh(rake_debuff) >= 2 and spell(rake) or target.refreshable(moonfire_cat) and buffexpires(bt_moonfire_buff) and spell(moonfire_cat) or target.refreshable(thrash_cat) and buffexpires(bt_thrash_buff) and target.ticksgainedonrefresh(thrash_cat) > thrash_ticks() and spell(thrash_cat) or buffexpires(bt_brutal_slash_buff) and spell(brutal_slash) or buffexpires(bt_swipe_buff) and enemies(tagged=1) > 1 and spell(swipe_cat) or buffexpires(bt_shred_buff) and spell(shred) or buffexpires(bt_swipe_buff) and spell(swipe_cat) or buffexpires(bt_thrash_buff) and spell(thrash_cat)
}

AddFunction feralbloodtalonscdactions
{
}

AddFunction feralbloodtalonscdpostconditions
{
 { not target.debuffpresent(rake_debuff) or target.refreshable(rake_debuff) and persistentmultiplier(rake_debuff) > target.debuffpersistentmultiplier(rake_debuff) or buffcount(bt_buffs) == 2 and persistentmultiplier(rake_debuff) > target.debuffpersistentmultiplier(rake_debuff) or buffcount(bt_buffs) == 2 and target.refreshable(rake_debuff) } and buffexpires(bt_rake_buff) and target.ticksgainedonrefresh(rake_debuff) >= 2 and spell(rake) or target.refreshable(moonfire_cat) and buffexpires(bt_moonfire_buff) and spell(moonfire_cat) or target.refreshable(thrash_cat) and buffexpires(bt_thrash_buff) and target.ticksgainedonrefresh(thrash_cat) > thrash_ticks() and spell(thrash_cat) or buffexpires(bt_brutal_slash_buff) and spell(brutal_slash) or buffexpires(bt_swipe_buff) and enemies(tagged=1) > 1 and spell(swipe_cat) or buffexpires(bt_shred_buff) and spell(shred) or buffexpires(bt_swipe_buff) and spell(swipe_cat) or buffexpires(bt_thrash_buff) and spell(thrash_cat)
}

### actions.default

AddFunction feral_defaultmainactions
{
 #call_action_list,name=owlweave,if=variable.owlweave=1
 if owlweave() == 1 feralowlweavemainactions()

 unless owlweave() == 1 and feralowlweavemainpostconditions()
 {
  #prowl
  spell(prowl)
  #cat_form,if=buff.cat_form.down
  if buffexpires(cat_form) spell(cat_form)
  #variable,name=shortest_ttd,value=target.time_to_die,if=variable.shortest_ttd=0
  #cycling_variable,name=shortest_ttd,op=min,value=target.time_to_die
  #run_action_list,name=stealth,if=buff.shadowmeld.up|buff.prowl.up
  if buffpresent(shadowmeld) or buffpresent(prowl) feralstealthmainactions()

  unless { buffpresent(shadowmeld) or buffpresent(prowl) } and feralstealthmainpostconditions()
  {
   #call_action_list,name=cooldown
   feralcooldownmainactions()

   unless feralcooldownmainpostconditions()
   {
    #run_action_list,name=finisher,if=combo_points>=(5-variable.4cp_bite)
    if combopoints() >= 5 - _4cp_bite() feralfinishermainactions()

    unless combopoints() >= 5 - _4cp_bite() and feralfinishermainpostconditions()
    {
     #call_action_list,name=stealth,if=buff.bs_inc.up|buff.sudden_ambush.up
     if buffpresent(bs_inc_buff) or buffpresent(sudden_ambush_buff) feralstealthmainactions()

     unless { buffpresent(bs_inc_buff) or buffpresent(sudden_ambush_buff) } and feralstealthmainpostconditions()
     {
      #pool_resource,if=talent.bloodtalons.enabled&buff.bloodtalons.down&(energy+3.5*energy.regen+(40*buff.clearcasting.up))<(115-23*buff.incarnation_king_of_the_jungle.up)&active_bt_triggers=0
      unless hastalent(bloodtalons_talent) and buffexpires(bloodtalons_buff) and energy() + 3.5 * energyregenrate() + 40 * buffpresent(clearcasting_feral_buff) < 115 - 23 * buffpresent(incarnation_king_of_the_jungle) and buffcount(bt_buffs) == 0
      {
       #run_action_list,name=bloodtalons,if=talent.bloodtalons.enabled&buff.bloodtalons.down
       if hastalent(bloodtalons_talent) and buffexpires(bloodtalons_buff) feralbloodtalonsmainactions()

       unless hastalent(bloodtalons_talent) and buffexpires(bloodtalons_buff) and feralbloodtalonsmainpostconditions()
       {
        #ferocious_bite,target_if=max:target.time_to_die,if=buff.apex_predators_craving.up
        if buffpresent(apex_predators_craving_buff) spell(ferocious_bite)
        #pool_resource,for_next=1
        #rake,target_if=(refreshable|persistent_multiplier>dot.rake.pmultiplier)&druid.rake.ticks_gained_on_refresh>spell_targets.swipe_cat*2-2
        if { target.refreshable(rake_debuff) or persistentmultiplier(rake_debuff) > target.debuffpersistentmultiplier(rake_debuff) } and target.ticksgainedonrefresh(rake_debuff) > enemies(tagged=1) * 2 - 2 spell(rake)
        unless { target.refreshable(rake_debuff) or persistentmultiplier(rake_debuff) > target.debuffpersistentmultiplier(rake_debuff) } and target.ticksgainedonrefresh(rake_debuff) > enemies(tagged=1) * 2 - 2 and { spellusable(rake) and spellcooldown(rake) < timetoenergyfor(rake) }
        {
         #moonfire_cat,target_if=refreshable&druid.moonfire_cat.ticks_gained_on_refresh>spell_targets.swipe_cat*2-2
         if target.refreshable(moonfire_cat) and target.ticksgainedonrefresh(moonfire_cat) > enemies(tagged=1) * 2 - 2 spell(moonfire_cat)
         #pool_resource,for_next=1
         #thrash_cat,target_if=refreshable&druid.thrash_cat.ticks_gained_on_refresh>variable.thrash_ticks&!buff.bs_inc.up
         if target.refreshable(thrash_cat) and target.ticksgainedonrefresh(thrash_cat) > thrash_ticks() and not buffpresent(bs_inc_buff) spell(thrash_cat)
         unless target.refreshable(thrash_cat) and target.ticksgainedonrefresh(thrash_cat) > thrash_ticks() and not buffpresent(bs_inc_buff) and { spellusable(thrash_cat) and spellcooldown(thrash_cat) < timetoenergyfor(thrash_cat) }
         {
          #pool_resource,for_next=1
          #brutal_slash,if=(raid_event.adds.in>(1+max_charges-charges_fractional)*recharge_time)&(spell_targets.brutal_slash*action.brutal_slash.damage%action.brutal_slash.cost)>(action.shred.damage%action.shred.cost)
          if 600 > { 1 + spellmaxcharges(brutal_slash) - charges(brutal_slash count=0) } * spellchargecooldown(brutal_slash) and enemies(tagged=1) * damage(brutal_slash) / powercost(brutal_slash) > damage(shred) / powercost(shred) spell(brutal_slash)
          unless 600 > { 1 + spellmaxcharges(brutal_slash) - charges(brutal_slash count=0) } * spellchargecooldown(brutal_slash) and enemies(tagged=1) * damage(brutal_slash) / powercost(brutal_slash) > damage(shred) / powercost(shred) and { spellusable(brutal_slash) and spellcooldown(brutal_slash) < timetoenergyfor(brutal_slash) }
          {
           #swipe_cat,if=spell_targets.swipe_cat>1+buff.bs_inc.up*2
           if enemies(tagged=1) > 1 + buffpresent(bs_inc_buff) * 2 spell(swipe_cat)
           #shred,if=buff.clearcasting.up
           if buffpresent(clearcasting_feral_buff) spell(shred)
           #rake,target_if=buff.bs_inc.up&druid.rake.ticks_gained_on_refresh>2
           if buffpresent(bs_inc_buff) and target.ticksgainedonrefresh(rake_debuff) > 2 spell(rake)
           #call_action_list,name=filler
           feralfillermainactions()
          }
         }
        }
       }
      }
     }
    }
   }
  }
 }
}

AddFunction feral_defaultmainpostconditions
{
 owlweave() == 1 and feralowlweavemainpostconditions() or { buffpresent(shadowmeld) or buffpresent(prowl) } and feralstealthmainpostconditions() or feralcooldownmainpostconditions() or combopoints() >= 5 - _4cp_bite() and feralfinishermainpostconditions() or { buffpresent(bs_inc_buff) or buffpresent(sudden_ambush_buff) } and feralstealthmainpostconditions() or not { hastalent(bloodtalons_talent) and buffexpires(bloodtalons_buff) and energy() + 3.5 * energyregenrate() + 40 * buffpresent(clearcasting_feral_buff) < 115 - 23 * buffpresent(incarnation_king_of_the_jungle) and buffcount(bt_buffs) == 0 } and { hastalent(bloodtalons_talent) and buffexpires(bloodtalons_buff) and feralbloodtalonsmainpostconditions() or not { { target.refreshable(rake_debuff) or persistentmultiplier(rake_debuff) > target.debuffpersistentmultiplier(rake_debuff) } and target.ticksgainedonrefresh(rake_debuff) > enemies(tagged=1) * 2 - 2 and { spellusable(rake) and spellcooldown(rake) < timetoenergyfor(rake) } } and { not { target.refreshable(thrash_cat) and target.ticksgainedonrefresh(thrash_cat) > thrash_ticks() and not buffpresent(bs_inc_buff) and { spellusable(thrash_cat) and spellcooldown(thrash_cat) < timetoenergyfor(thrash_cat) } } and { not { 600 > { 1 + spellmaxcharges(brutal_slash) - charges(brutal_slash count=0) } * spellchargecooldown(brutal_slash) and enemies(tagged=1) * damage(brutal_slash) / powercost(brutal_slash) > damage(shred) / powercost(shred) and { spellusable(brutal_slash) and spellcooldown(brutal_slash) < timetoenergyfor(brutal_slash) } } and feralfillermainpostconditions() } } }
}

AddFunction feral_defaultshortcdactions
{
 #call_action_list,name=owlweave,if=variable.owlweave=1
 if owlweave() == 1 feralowlweaveshortcdactions()

 unless owlweave() == 1 and feralowlweaveshortcdpostconditions() or spell(prowl)
 {
  #tigers_fury,if=buff.cat_form.down
  if buffexpires(cat_form) spell(tigers_fury)

  unless buffexpires(cat_form) and spell(cat_form)
  {
   #auto_attack,if=!buff.prowl.up&!buff.shadowmeld.up
   if not buffpresent(prowl) and not buffpresent(shadowmeld) feralgetinmeleerange()
   #variable,name=shortest_ttd,value=target.time_to_die,if=variable.shortest_ttd=0
   #cycling_variable,name=shortest_ttd,op=min,value=target.time_to_die
   #run_action_list,name=stealth,if=buff.shadowmeld.up|buff.prowl.up
   if buffpresent(shadowmeld) or buffpresent(prowl) feralstealthshortcdactions()

   unless { buffpresent(shadowmeld) or buffpresent(prowl) } and feralstealthshortcdpostconditions()
   {
    #call_action_list,name=cooldown
    feralcooldownshortcdactions()

    unless feralcooldownshortcdpostconditions()
    {
     #run_action_list,name=finisher,if=combo_points>=(5-variable.4cp_bite)
     if combopoints() >= 5 - _4cp_bite() feralfinishershortcdactions()

     unless combopoints() >= 5 - _4cp_bite() and feralfinishershortcdpostconditions()
     {
      #call_action_list,name=stealth,if=buff.bs_inc.up|buff.sudden_ambush.up
      if buffpresent(bs_inc_buff) or buffpresent(sudden_ambush_buff) feralstealthshortcdactions()

      unless { buffpresent(bs_inc_buff) or buffpresent(sudden_ambush_buff) } and feralstealthshortcdpostconditions()
      {
       #pool_resource,if=talent.bloodtalons.enabled&buff.bloodtalons.down&(energy+3.5*energy.regen+(40*buff.clearcasting.up))<(115-23*buff.incarnation_king_of_the_jungle.up)&active_bt_triggers=0
       unless hastalent(bloodtalons_talent) and buffexpires(bloodtalons_buff) and energy() + 3.5 * energyregenrate() + 40 * buffpresent(clearcasting_feral_buff) < 115 - 23 * buffpresent(incarnation_king_of_the_jungle) and buffcount(bt_buffs) == 0
       {
        #run_action_list,name=bloodtalons,if=talent.bloodtalons.enabled&buff.bloodtalons.down
        if hastalent(bloodtalons_talent) and buffexpires(bloodtalons_buff) feralbloodtalonsshortcdactions()

        unless hastalent(bloodtalons_talent) and buffexpires(bloodtalons_buff) and feralbloodtalonsshortcdpostconditions() or buffpresent(apex_predators_craving_buff) and spell(ferocious_bite)
        {
         #pool_resource,for_next=1
         #rake,target_if=(refreshable|persistent_multiplier>dot.rake.pmultiplier)&druid.rake.ticks_gained_on_refresh>spell_targets.swipe_cat*2-2
         unless { target.refreshable(rake_debuff) or persistentmultiplier(rake_debuff) > target.debuffpersistentmultiplier(rake_debuff) } and target.ticksgainedonrefresh(rake_debuff) > enemies(tagged=1) * 2 - 2 and { spellusable(rake) and spellcooldown(rake) < timetoenergyfor(rake) }
         {
          unless target.refreshable(moonfire_cat) and target.ticksgainedonrefresh(moonfire_cat) > enemies(tagged=1) * 2 - 2 and spell(moonfire_cat)
          {
           #pool_resource,for_next=1
           #thrash_cat,target_if=refreshable&druid.thrash_cat.ticks_gained_on_refresh>variable.thrash_ticks&!buff.bs_inc.up
           unless target.refreshable(thrash_cat) and target.ticksgainedonrefresh(thrash_cat) > thrash_ticks() and not buffpresent(bs_inc_buff) and { spellusable(thrash_cat) and spellcooldown(thrash_cat) < timetoenergyfor(thrash_cat) }
           {
            #pool_resource,for_next=1
            #brutal_slash,if=(raid_event.adds.in>(1+max_charges-charges_fractional)*recharge_time)&(spell_targets.brutal_slash*action.brutal_slash.damage%action.brutal_slash.cost)>(action.shred.damage%action.shred.cost)
            unless 600 > { 1 + spellmaxcharges(brutal_slash) - charges(brutal_slash count=0) } * spellchargecooldown(brutal_slash) and enemies(tagged=1) * damage(brutal_slash) / powercost(brutal_slash) > damage(shred) / powercost(shred) and { spellusable(brutal_slash) and spellcooldown(brutal_slash) < timetoenergyfor(brutal_slash) }
            {
             unless enemies(tagged=1) > 1 + buffpresent(bs_inc_buff) * 2 and spell(swipe_cat) or buffpresent(clearcasting_feral_buff) and spell(shred) or buffpresent(bs_inc_buff) and target.ticksgainedonrefresh(rake_debuff) > 2 and spell(rake)
             {
              #call_action_list,name=filler
              feralfillershortcdactions()
             }
            }
           }
          }
         }
        }
       }
      }
     }
    }
   }
  }
 }
}

AddFunction feral_defaultshortcdpostconditions
{
 owlweave() == 1 and feralowlweaveshortcdpostconditions() or spell(prowl) or buffexpires(cat_form) and spell(cat_form) or { buffpresent(shadowmeld) or buffpresent(prowl) } and feralstealthshortcdpostconditions() or feralcooldownshortcdpostconditions() or combopoints() >= 5 - _4cp_bite() and feralfinishershortcdpostconditions() or { buffpresent(bs_inc_buff) or buffpresent(sudden_ambush_buff) } and feralstealthshortcdpostconditions() or not { hastalent(bloodtalons_talent) and buffexpires(bloodtalons_buff) and energy() + 3.5 * energyregenrate() + 40 * buffpresent(clearcasting_feral_buff) < 115 - 23 * buffpresent(incarnation_king_of_the_jungle) and buffcount(bt_buffs) == 0 } and { hastalent(bloodtalons_talent) and buffexpires(bloodtalons_buff) and feralbloodtalonsshortcdpostconditions() or buffpresent(apex_predators_craving_buff) and spell(ferocious_bite) or not { { target.refreshable(rake_debuff) or persistentmultiplier(rake_debuff) > target.debuffpersistentmultiplier(rake_debuff) } and target.ticksgainedonrefresh(rake_debuff) > enemies(tagged=1) * 2 - 2 and { spellusable(rake) and spellcooldown(rake) < timetoenergyfor(rake) } } and { target.refreshable(moonfire_cat) and target.ticksgainedonrefresh(moonfire_cat) > enemies(tagged=1) * 2 - 2 and spell(moonfire_cat) or not { target.refreshable(thrash_cat) and target.ticksgainedonrefresh(thrash_cat) > thrash_ticks() and not buffpresent(bs_inc_buff) and { spellusable(thrash_cat) and spellcooldown(thrash_cat) < timetoenergyfor(thrash_cat) } } and { not { 600 > { 1 + spellmaxcharges(brutal_slash) - charges(brutal_slash count=0) } * spellchargecooldown(brutal_slash) and enemies(tagged=1) * damage(brutal_slash) / powercost(brutal_slash) > damage(shred) / powercost(shred) and { spellusable(brutal_slash) and spellcooldown(brutal_slash) < timetoenergyfor(brutal_slash) } } and { enemies(tagged=1) > 1 + buffpresent(bs_inc_buff) * 2 and spell(swipe_cat) or buffpresent(clearcasting_feral_buff) and spell(shred) or buffpresent(bs_inc_buff) and target.ticksgainedonrefresh(rake_debuff) > 2 and spell(rake) or feralfillershortcdpostconditions() } } } }
}

AddFunction feral_defaultcdactions
{
 feralinterruptactions()
 #call_action_list,name=owlweave,if=variable.owlweave=1
 if owlweave() == 1 feralowlweavecdactions()

 unless owlweave() == 1 and feralowlweavecdpostconditions() or spell(prowl) or buffexpires(cat_form) and spell(tigers_fury) or buffexpires(cat_form) and spell(cat_form)
 {
  #variable,name=shortest_ttd,value=target.time_to_die,if=variable.shortest_ttd=0
  #cycling_variable,name=shortest_ttd,op=min,value=target.time_to_die
  #run_action_list,name=stealth,if=buff.shadowmeld.up|buff.prowl.up
  if buffpresent(shadowmeld) or buffpresent(prowl) feralstealthcdactions()

  unless { buffpresent(shadowmeld) or buffpresent(prowl) } and feralstealthcdpostconditions()
  {
   #call_action_list,name=cooldown
   feralcooldowncdactions()

   unless feralcooldowncdpostconditions()
   {
    #run_action_list,name=finisher,if=combo_points>=(5-variable.4cp_bite)
    if combopoints() >= 5 - _4cp_bite() feralfinishercdactions()

    unless combopoints() >= 5 - _4cp_bite() and feralfinishercdpostconditions()
    {
     #call_action_list,name=stealth,if=buff.bs_inc.up|buff.sudden_ambush.up
     if buffpresent(bs_inc_buff) or buffpresent(sudden_ambush_buff) feralstealthcdactions()

     unless { buffpresent(bs_inc_buff) or buffpresent(sudden_ambush_buff) } and feralstealthcdpostconditions()
     {
      #pool_resource,if=talent.bloodtalons.enabled&buff.bloodtalons.down&(energy+3.5*energy.regen+(40*buff.clearcasting.up))<(115-23*buff.incarnation_king_of_the_jungle.up)&active_bt_triggers=0
      unless hastalent(bloodtalons_talent) and buffexpires(bloodtalons_buff) and energy() + 3.5 * energyregenrate() + 40 * buffpresent(clearcasting_feral_buff) < 115 - 23 * buffpresent(incarnation_king_of_the_jungle) and buffcount(bt_buffs) == 0
      {
       #run_action_list,name=bloodtalons,if=talent.bloodtalons.enabled&buff.bloodtalons.down
       if hastalent(bloodtalons_talent) and buffexpires(bloodtalons_buff) feralbloodtalonscdactions()

       unless hastalent(bloodtalons_talent) and buffexpires(bloodtalons_buff) and feralbloodtalonscdpostconditions() or buffpresent(apex_predators_craving_buff) and spell(ferocious_bite)
       {
        #pool_resource,for_next=1
        #rake,target_if=(refreshable|persistent_multiplier>dot.rake.pmultiplier)&druid.rake.ticks_gained_on_refresh>spell_targets.swipe_cat*2-2
        unless { target.refreshable(rake_debuff) or persistentmultiplier(rake_debuff) > target.debuffpersistentmultiplier(rake_debuff) } and target.ticksgainedonrefresh(rake_debuff) > enemies(tagged=1) * 2 - 2 and { spellusable(rake) and spellcooldown(rake) < timetoenergyfor(rake) }
        {
         unless target.refreshable(moonfire_cat) and target.ticksgainedonrefresh(moonfire_cat) > enemies(tagged=1) * 2 - 2 and spell(moonfire_cat)
         {
          #pool_resource,for_next=1
          #thrash_cat,target_if=refreshable&druid.thrash_cat.ticks_gained_on_refresh>variable.thrash_ticks&!buff.bs_inc.up
          unless target.refreshable(thrash_cat) and target.ticksgainedonrefresh(thrash_cat) > thrash_ticks() and not buffpresent(bs_inc_buff) and { spellusable(thrash_cat) and spellcooldown(thrash_cat) < timetoenergyfor(thrash_cat) }
          {
           #pool_resource,for_next=1
           #brutal_slash,if=(raid_event.adds.in>(1+max_charges-charges_fractional)*recharge_time)&(spell_targets.brutal_slash*action.brutal_slash.damage%action.brutal_slash.cost)>(action.shred.damage%action.shred.cost)
           unless 600 > { 1 + spellmaxcharges(brutal_slash) - charges(brutal_slash count=0) } * spellchargecooldown(brutal_slash) and enemies(tagged=1) * damage(brutal_slash) / powercost(brutal_slash) > damage(shred) / powercost(shred) and { spellusable(brutal_slash) and spellcooldown(brutal_slash) < timetoenergyfor(brutal_slash) }
           {
            unless enemies(tagged=1) > 1 + buffpresent(bs_inc_buff) * 2 and spell(swipe_cat) or buffpresent(clearcasting_feral_buff) and spell(shred) or buffpresent(bs_inc_buff) and target.ticksgainedonrefresh(rake_debuff) > 2 and spell(rake)
            {
             #call_action_list,name=filler
             feralfillercdactions()
            }
           }
          }
         }
        }
       }
      }
     }
    }
   }
  }
 }
}

AddFunction feral_defaultcdpostconditions
{
 owlweave() == 1 and feralowlweavecdpostconditions() or spell(prowl) or buffexpires(cat_form) and spell(tigers_fury) or buffexpires(cat_form) and spell(cat_form) or { buffpresent(shadowmeld) or buffpresent(prowl) } and feralstealthcdpostconditions() or feralcooldowncdpostconditions() or combopoints() >= 5 - _4cp_bite() and feralfinishercdpostconditions() or { buffpresent(bs_inc_buff) or buffpresent(sudden_ambush_buff) } and feralstealthcdpostconditions() or not { hastalent(bloodtalons_talent) and buffexpires(bloodtalons_buff) and energy() + 3.5 * energyregenrate() + 40 * buffpresent(clearcasting_feral_buff) < 115 - 23 * buffpresent(incarnation_king_of_the_jungle) and buffcount(bt_buffs) == 0 } and { hastalent(bloodtalons_talent) and buffexpires(bloodtalons_buff) and feralbloodtalonscdpostconditions() or buffpresent(apex_predators_craving_buff) and spell(ferocious_bite) or not { { target.refreshable(rake_debuff) or persistentmultiplier(rake_debuff) > target.debuffpersistentmultiplier(rake_debuff) } and target.ticksgainedonrefresh(rake_debuff) > enemies(tagged=1) * 2 - 2 and { spellusable(rake) and spellcooldown(rake) < timetoenergyfor(rake) } } and { target.refreshable(moonfire_cat) and target.ticksgainedonrefresh(moonfire_cat) > enemies(tagged=1) * 2 - 2 and spell(moonfire_cat) or not { target.refreshable(thrash_cat) and target.ticksgainedonrefresh(thrash_cat) > thrash_ticks() and not buffpresent(bs_inc_buff) and { spellusable(thrash_cat) and spellcooldown(thrash_cat) < timetoenergyfor(thrash_cat) } } and { not { 600 > { 1 + spellmaxcharges(brutal_slash) - charges(brutal_slash count=0) } * spellchargecooldown(brutal_slash) and enemies(tagged=1) * damage(brutal_slash) / powercost(brutal_slash) > damage(shred) / powercost(shred) and { spellusable(brutal_slash) and spellcooldown(brutal_slash) < timetoenergyfor(brutal_slash) } } and { enemies(tagged=1) > 1 + buffpresent(bs_inc_buff) * 2 and spell(swipe_cat) or buffpresent(clearcasting_feral_buff) and spell(shred) or buffpresent(bs_inc_buff) and target.ticksgainedonrefresh(rake_debuff) > 2 and spell(rake) or feralfillercdpostconditions() } } } }
}

### Feral icons.

AddCheckBox(opt_druid_feral_aoe l(aoe) default enabled=(specialization(feral)))

AddIcon enabled=(not checkboxon(opt_druid_feral_aoe) and specialization(feral)) enemies=1 help=shortcd
{
 if not incombat() feralprecombatshortcdactions()
 feral_defaultshortcdactions()
}

AddIcon enabled=(checkboxon(opt_druid_feral_aoe) and specialization(feral)) help=shortcd
{
 if not incombat() feralprecombatshortcdactions()
 feral_defaultshortcdactions()
}

AddIcon enabled=(specialization(feral)) enemies=1 help=main
{
 if not incombat() feralprecombatmainactions()
 feral_defaultmainactions()
}

AddIcon enabled=(checkboxon(opt_druid_feral_aoe) and specialization(feral)) help=aoe
{
 if not incombat() feralprecombatmainactions()
 feral_defaultmainactions()
}

AddIcon enabled=(not checkboxon(opt_druid_feral_aoe) and specialization(feral)) enemies=1 help=cd
{
 if not incombat() feralprecombatcdactions()
 feral_defaultcdactions()
}

AddIcon enabled=(checkboxon(opt_druid_feral_aoe) and specialization(feral)) help=cd
{
 if not incombat() feralprecombatcdactions()
 feral_defaultcdactions()
}

### Required symbols
# adaptive_swarm
# apex_predators_craving_buff
# berserk
# berserking
# bloodlust
# bloodtalons_buff
# bloodtalons_talent
# brutal_slash
# bs_inc_buff
# bt_brutal_slash_buff
# bt_buffs
# bt_moonfire_buff
# bt_rake_buff
# bt_shred_buff
# bt_swipe_buff
# bt_thrash_buff
# cat_form
# clearcasting_feral_buff
# convoke_the_spirits
# deep_allegiance_conduit
# feral_frenzy
# ferocious_bite
# heart_of_the_wild
# incarnation
# incarnation_king_of_the_jungle
# kindred_spirits
# maim
# mangle
# mighty_bash
# moonfire_cat
# moonkin_form
# potion_of_spectral_agility_item
# predator_talent
# primal_wrath
# primal_wrath_talent
# prowl
# rake
# rake_debuff
# ravenous_frenzy
# rip
# sabertooth_talent
# savage_roar
# shadowmeld
# shred
# skull_bash
# starsurge
# sudden_ambush_buff
# sunfire
# swipe
# swipe_cat
# thrash_cat
# tigers_fury
# typhoon
# war_stomp
# wild_charge_bear
# wild_charge_cat
]]
        scripts:registerScript("DRUID", "feral", name, desc, code, "script")
    end
    do
        local name = "sc_t26_druid_feral_owlweave"
        local desc = "[9.0] Simulationcraft: T26_Druid_Feral_Owlweave"
        local code = [[
# Based on SimulationCraft profile "T26_Druid_Feral_Owlweave".
#	class=druid
#	spec=feral
#	talents=2313122

Include(ovale_common)
Include(ovale_druid_spells)


AddFunction shortest_ttd
{
 if 0 == 0 target.timetodie()
}

AddFunction best_rip
{
 if hastalent(primal_wrath_talent) 0
}

AddFunction owlweave
{
 checkboxon("owlweave_cat")
}

AddFunction thrash_ticks
{
 1
}

AddFunction rip_ticks
{
 7
}

AddFunction filler
{
 0
}

AddFunction _4cp_bite
{
 0
}

AddCheckBox(opt_interrupt l(interrupt) default enabled=(specialization(feral)))
AddCheckBox(opt_melee_range l(not_in_melee_range) enabled=(specialization(feral)))
AddCheckBox(opt_use_consumables l(opt_use_consumables) default enabled=(specialization(feral)))
AddCheckBox(owlweave_cat l(owlweave_cat) default enabled=(specialization(feral)))

AddFunction feralinterruptactions
{
 if checkboxon(opt_interrupt) and not target.isfriend() and target.casting()
 {
  if target.inrange(skull_bash) and target.isinterruptible() spell(skull_bash)
  if target.inrange(mighty_bash) and not target.classification(worldboss) spell(mighty_bash)
  if target.inrange(maim) and not target.classification(worldboss) spell(maim)
  if target.distance() < 5 and not target.classification(worldboss) spell(war_stomp)
  if target.distance() < 15 and not target.classification(worldboss) spell(typhoon)
 }
}

AddFunction feraluseitemactions
{
 item(trinket0slot text=13 usable=1)
 item(trinket1slot text=14 usable=1)
}

AddFunction feralgetinmeleerange
{
 if checkboxon(opt_melee_range)
 {
  if stance(druid_bear_form) and not target.inrange(mangle)
  {
   if target.inrange(wild_charge_bear) spell(wild_charge_bear)
   texture(misc_arrowlup help=(l(not_in_melee_range)))
  }
  if (stance(druid_cat_form) or stance(druid_claws_of_shirvallah)) and not target.inrange(shred)
  {
   if target.inrange(wild_charge_cat) spell(wild_charge_cat)
   texture(misc_arrowlup help=(l(not_in_melee_range)))
  }
 }
}

### actions.stealth

AddFunction feralstealthmainactions
{
 #pool_resource,for_next=1
 #rake,target_if=(dot.rake.pmultiplier<1.5|refreshable)&druid.rake.ticks_gained_on_refresh>2
 if { target.debuffpersistentmultiplier(rake_debuff) < 1.5 or target.refreshable(rake_debuff) } and target.ticksgainedonrefresh(rake_debuff) > 2 spell(rake)
 unless { target.debuffpersistentmultiplier(rake_debuff) < 1.5 or target.refreshable(rake_debuff) } and target.ticksgainedonrefresh(rake_debuff) > 2 and { spellusable(rake) and spellcooldown(rake) < timetoenergyfor(rake) }
 {
  #pool_resource,for_next=1
  #thrash_cat,target_if=refreshable&druid.thrash_cat.ticks_gained_on_refresh>variable.thrash_ticks,if=spell_targets.thrash_cat>3
  if target.refreshable(thrash_cat) and target.ticksgainedonrefresh(thrash_cat) > thrash_ticks() and enemies(tagged=1) > 3 spell(thrash_cat)
  unless target.refreshable(thrash_cat) and target.ticksgainedonrefresh(thrash_cat) > thrash_ticks() and enemies(tagged=1) > 3 and { spellusable(thrash_cat) and spellcooldown(thrash_cat) < timetoenergyfor(thrash_cat) }
  {
   #brutal_slash,if=spell_targets.brutal_slash>2
   if enemies(tagged=1) > 2 spell(brutal_slash)
   #pool_resource,for_next=1
   #shred,if=combo_points<4
   if combopoints() < 4 spell(shred)
  }
 }
}

AddFunction feralstealthmainpostconditions
{
}

AddFunction feralstealthshortcdactions
{
}

AddFunction feralstealthshortcdpostconditions
{
 { target.debuffpersistentmultiplier(rake_debuff) < 1.5 or target.refreshable(rake_debuff) } and target.ticksgainedonrefresh(rake_debuff) > 2 and spell(rake) or not { { target.debuffpersistentmultiplier(rake_debuff) < 1.5 or target.refreshable(rake_debuff) } and target.ticksgainedonrefresh(rake_debuff) > 2 and { spellusable(rake) and spellcooldown(rake) < timetoenergyfor(rake) } } and { target.refreshable(thrash_cat) and target.ticksgainedonrefresh(thrash_cat) > thrash_ticks() and enemies(tagged=1) > 3 and spell(thrash_cat) or not { target.refreshable(thrash_cat) and target.ticksgainedonrefresh(thrash_cat) > thrash_ticks() and enemies(tagged=1) > 3 and { spellusable(thrash_cat) and spellcooldown(thrash_cat) < timetoenergyfor(thrash_cat) } } and { enemies(tagged=1) > 2 and spell(brutal_slash) or combopoints() < 4 and spell(shred) } }
}

AddFunction feralstealthcdactions
{
}

AddFunction feralstealthcdpostconditions
{
 { target.debuffpersistentmultiplier(rake_debuff) < 1.5 or target.refreshable(rake_debuff) } and target.ticksgainedonrefresh(rake_debuff) > 2 and spell(rake) or not { { target.debuffpersistentmultiplier(rake_debuff) < 1.5 or target.refreshable(rake_debuff) } and target.ticksgainedonrefresh(rake_debuff) > 2 and { spellusable(rake) and spellcooldown(rake) < timetoenergyfor(rake) } } and { target.refreshable(thrash_cat) and target.ticksgainedonrefresh(thrash_cat) > thrash_ticks() and enemies(tagged=1) > 3 and spell(thrash_cat) or not { target.refreshable(thrash_cat) and target.ticksgainedonrefresh(thrash_cat) > thrash_ticks() and enemies(tagged=1) > 3 and { spellusable(thrash_cat) and spellcooldown(thrash_cat) < timetoenergyfor(thrash_cat) } } and { enemies(tagged=1) > 2 and spell(brutal_slash) or combopoints() < 4 and spell(shred) } }
}

### actions.precombat

AddFunction feralprecombatmainactions
{
 #flask
 #food
 #augmentation
 #snapshot_stats
 #flask
 #food
 #augmentation
 #variable,name=4cp_bite,value=0
 #variable,name=filler,value=0
 #variable,name=rip_ticks,value=7
 #variable,name=thrash_ticks,value=1
 #variable,name=owlweave,value=druid.owlweave_cat
 #snapshot_stats
 #cat_form
 if buffexpires(cat_form) spell(cat_form)
 #prowl
 if buffexpires(prowl) spell(prowl)
}

AddFunction feralprecombatmainpostconditions
{
}

AddFunction feralprecombatshortcdactions
{
}

AddFunction feralprecombatshortcdpostconditions
{
 buffexpires(cat_form) and spell(cat_form) or buffexpires(prowl) and spell(prowl)
}

AddFunction feralprecombatcdactions
{
}

AddFunction feralprecombatcdpostconditions
{
 buffexpires(cat_form) and spell(cat_form) or buffexpires(prowl) and spell(prowl)
}

### actions.owlweave

AddFunction feralowlweavemainactions
{
 #starsurge,if=buff.heart_of_the_wild.up
 if buffpresent(heart_of_the_wild) spell(starsurge)
 #sunfire,if=!prev_gcd.1.sunfire&!prev_gcd.2.sunfire
 if not previousgcdspell(sunfire) and not previousgcdspell(sunfire count=2) spell(sunfire)
 #moonkin_form,if=energy<40&(dot.rip.remains>4.5|combo_points<5)&cooldown.tigers_fury.remains>=6.5&buff.clearcasting.stack<1&!buff.apex_predators_craving.up&!buff.bloodlust.up&(buff.bs_inc.remains>5|!buff.bs_inc.up)&(!cooldown.convoke_the_spirits.up|!covenant.night_fae)
 if energy() < 40 and { target.debuffremaining(rip) > 4.5 or combopoints() < 5 } and spellcooldown(tigers_fury) >= 6.5 and buffstacks(clearcasting_feral_buff) < 1 and not buffpresent(apex_predators_craving_buff) and not buffpresent(bloodlust) and { buffremaining(bs_inc_buff) > 5 or not buffpresent(bs_inc_buff) } and { not { not spellcooldown(convoke_the_spirits) > 0 } or not iscovenant("night_fae") } spell(moonkin_form)
}

AddFunction feralowlweavemainpostconditions
{
}

AddFunction feralowlweaveshortcdactions
{
}

AddFunction feralowlweaveshortcdpostconditions
{
 buffpresent(heart_of_the_wild) and spell(starsurge) or not previousgcdspell(sunfire) and not previousgcdspell(sunfire count=2) and spell(sunfire) or energy() < 40 and { target.debuffremaining(rip) > 4.5 or combopoints() < 5 } and spellcooldown(tigers_fury) >= 6.5 and buffstacks(clearcasting_feral_buff) < 1 and not buffpresent(apex_predators_craving_buff) and not buffpresent(bloodlust) and { buffremaining(bs_inc_buff) > 5 or not buffpresent(bs_inc_buff) } and { not { not spellcooldown(convoke_the_spirits) > 0 } or not iscovenant("night_fae") } and spell(moonkin_form)
}

AddFunction feralowlweavecdactions
{
 unless buffpresent(heart_of_the_wild) and spell(starsurge) or not previousgcdspell(sunfire) and not previousgcdspell(sunfire count=2) and spell(sunfire)
 {
  #heart_of_the_wild,if=energy<40&(dot.rip.remains>4.5|combo_points<5)&cooldown.tigers_fury.remains>=6.5&buff.clearcasting.stack<1&!buff.apex_predators_craving.up&!buff.bloodlust.up&(buff.bs_inc.remains>5|!buff.bs_inc.up)&(!cooldown.convoke_the_spirits.up|!covenant.night_fae)
  if energy() < 40 and { target.debuffremaining(rip) > 4.5 or combopoints() < 5 } and spellcooldown(tigers_fury) >= 6.5 and buffstacks(clearcasting_feral_buff) < 1 and not buffpresent(apex_predators_craving_buff) and not buffpresent(bloodlust) and { buffremaining(bs_inc_buff) > 5 or not buffpresent(bs_inc_buff) } and { not { not spellcooldown(convoke_the_spirits) > 0 } or not iscovenant("night_fae") } spell(heart_of_the_wild)
 }
}

AddFunction feralowlweavecdpostconditions
{
 buffpresent(heart_of_the_wild) and spell(starsurge) or not previousgcdspell(sunfire) and not previousgcdspell(sunfire count=2) and spell(sunfire) or energy() < 40 and { target.debuffremaining(rip) > 4.5 or combopoints() < 5 } and spellcooldown(tigers_fury) >= 6.5 and buffstacks(clearcasting_feral_buff) < 1 and not buffpresent(apex_predators_craving_buff) and not buffpresent(bloodlust) and { buffremaining(bs_inc_buff) > 5 or not buffpresent(bs_inc_buff) } and { not { not spellcooldown(convoke_the_spirits) > 0 } or not iscovenant("night_fae") } and spell(moonkin_form)
}

### actions.finisher

AddFunction feralfinishermainactions
{
 #savage_roar,if=buff.savage_roar.down|buff.savage_roar.remains<(combo_points*6+1)*0.3
 if buffexpires(savage_roar) or buffremaining(savage_roar) < { combopoints() * 6 + 1 } * 0.3 spell(savage_roar)
 #variable,name=best_rip,value=0,if=talent.primal_wrath.enabled
 #cycling_variable,name=best_rip,op=max,value=druid.rip.ticks_gained_on_refresh,if=talent.primal_wrath.enabled
 #primal_wrath,if=spell_targets.primal_wrath>2
 if enemies(tagged=1) > 2 and enemies(tagged=1) > 1 spell(primal_wrath)
 #rip,target_if=refreshable&druid.rip.ticks_gained_on_refresh>variable.rip_ticks&((buff.tigers_fury.up|cooldown.tigers_fury.remains>5)&(buff.bloodtalons.up|!talent.bloodtalons.enabled)&dot.rip.pmultiplier<=persistent_multiplier|!talent.sabertooth.enabled)
 if target.refreshable(rip) and target.ticksgainedonrefresh(rip) > rip_ticks() and { { buffpresent(tigers_fury) or spellcooldown(tigers_fury) > 5 } and { buffpresent(bloodtalons_buff) or not hastalent(bloodtalons_talent) } and target.debuffpersistentmultiplier(rip) <= persistentmultiplier(rip) or not hastalent(sabertooth_talent) } spell(rip)
 #ferocious_bite,max_energy=1,target_if=max:time_to_die
 if energy() >= energycost(ferocious_bite max=1) spell(ferocious_bite)
}

AddFunction feralfinishermainpostconditions
{
}

AddFunction feralfinishershortcdactions
{
}

AddFunction feralfinishershortcdpostconditions
{
 { buffexpires(savage_roar) or buffremaining(savage_roar) < { combopoints() * 6 + 1 } * 0.3 } and spell(savage_roar) or enemies(tagged=1) > 2 and enemies(tagged=1) > 1 and spell(primal_wrath) or target.refreshable(rip) and target.ticksgainedonrefresh(rip) > rip_ticks() and { { buffpresent(tigers_fury) or spellcooldown(tigers_fury) > 5 } and { buffpresent(bloodtalons_buff) or not hastalent(bloodtalons_talent) } and target.debuffpersistentmultiplier(rip) <= persistentmultiplier(rip) or not hastalent(sabertooth_talent) } and spell(rip) or energy() >= energycost(ferocious_bite max=1) and spell(ferocious_bite)
}

AddFunction feralfinishercdactions
{
}

AddFunction feralfinishercdpostconditions
{
 { buffexpires(savage_roar) or buffremaining(savage_roar) < { combopoints() * 6 + 1 } * 0.3 } and spell(savage_roar) or enemies(tagged=1) > 2 and enemies(tagged=1) > 1 and spell(primal_wrath) or target.refreshable(rip) and target.ticksgainedonrefresh(rip) > rip_ticks() and { { buffpresent(tigers_fury) or spellcooldown(tigers_fury) > 5 } and { buffpresent(bloodtalons_buff) or not hastalent(bloodtalons_talent) } and target.debuffpersistentmultiplier(rip) <= persistentmultiplier(rip) or not hastalent(sabertooth_talent) } and spell(rip) or energy() >= energycost(ferocious_bite max=1) and spell(ferocious_bite)
}

### actions.filler

AddFunction feralfillermainactions
{
 #rake,target_if=variable.filler=1&dot.rake.pmultiplier<=persistent_multiplier
 if filler() == 1 and target.debuffpersistentmultiplier(rake_debuff) <= persistentmultiplier(rake_debuff) spell(rake)
 #rake,if=variable.filler=2
 if filler() == 2 spell(rake)
 #lunar_inspiration,if=variable.filler=3
 if filler() == 3 spell(moonfire_cat)
 #swipe,if=variable.filler=4
 if filler() == 4 spell(swipe)
 #shred
 spell(shred)
}

AddFunction feralfillermainpostconditions
{
}

AddFunction feralfillershortcdactions
{
}

AddFunction feralfillershortcdpostconditions
{
 filler() == 1 and target.debuffpersistentmultiplier(rake_debuff) <= persistentmultiplier(rake_debuff) and spell(rake) or filler() == 2 and spell(rake) or filler() == 3 and spell(moonfire_cat) or filler() == 4 and spell(swipe) or spell(shred)
}

AddFunction feralfillercdactions
{
}

AddFunction feralfillercdpostconditions
{
 filler() == 1 and target.debuffpersistentmultiplier(rake_debuff) <= persistentmultiplier(rake_debuff) and spell(rake) or filler() == 2 and spell(rake) or filler() == 3 and spell(moonfire_cat) or filler() == 4 and spell(swipe) or spell(shred)
}

### actions.cooldown

AddFunction feralcooldownmainactions
{
 #berserk,if=combo_points>=3
 if combopoints() >= 3 spell(berserk)
 #incarnation,if=combo_points>=3
 if combopoints() >= 3 spell(incarnation)
 #kindred_spirits,if=buff.tigers_fury.up|(conduit.deep_allegiance.enabled)
 if buffpresent(tigers_fury) or conduit(deep_allegiance_conduit) spell(kindred_spirits)
 #adaptive_swarm,target_if=max:time_to_die*(combo_points=5&!dot.adaptive_swarm_damage.ticking)
 spell(adaptive_swarm)
}

AddFunction feralcooldownmainpostconditions
{
}

AddFunction feralcooldownshortcdactions
{
 #feral_frenzy,if=combo_points<3
 if combopoints() < 3 spell(feral_frenzy)

 unless combopoints() >= 3 and spell(berserk) or combopoints() >= 3 and spell(incarnation)
 {
  #tigers_fury,if=energy.deficit>40|buff.bs_inc.up|(talent.predator.enabled&variable.shortest_ttd<3)
  if energydeficit() > 40 or buffpresent(bs_inc_buff) or hastalent(predator_talent) and shortest_ttd() < 3 spell(tigers_fury)
 }
}

AddFunction feralcooldownshortcdpostconditions
{
 combopoints() >= 3 and spell(berserk) or combopoints() >= 3 and spell(incarnation) or { buffpresent(tigers_fury) or conduit(deep_allegiance_conduit) } and spell(kindred_spirits) or spell(adaptive_swarm)
}

AddFunction feralcooldowncdactions
{
 unless combopoints() < 3 and spell(feral_frenzy) or combopoints() >= 3 and spell(berserk) or combopoints() >= 3 and spell(incarnation) or { energydeficit() > 40 or buffpresent(bs_inc_buff) or hastalent(predator_talent) and shortest_ttd() < 3 } and spell(tigers_fury)
 {
  #shadowmeld,if=buff.tigers_fury.up&buff.bs_inc.down&combo_points<4&dot.rake.pmultiplier<1.6&energy>40
  if buffpresent(tigers_fury) and buffexpires(bs_inc_buff) and combopoints() < 4 and target.debuffpersistentmultiplier(rake_debuff) < 1.6 and energy() > 40 spell(shadowmeld)
  #berserking,if=buff.tigers_fury.up|buff.bs_inc.up
  if buffpresent(tigers_fury) or buffpresent(bs_inc_buff) spell(berserking)
  #potion,if=buff.bs_inc.up
  if buffpresent(bs_inc_buff) and { checkboxon(opt_use_consumables) and target.classification(worldboss) } item(potion_of_spectral_agility_item usable=1)
  #ravenous_frenzy,if=buff.bs_inc.up|fight_remains<21
  if buffpresent(bs_inc_buff) or fightremains() < 21 spell(ravenous_frenzy)
  #convoke_the_spirits,if=(dot.rip.remains>4&combo_points<3&dot.rake.ticking&energy.deficit>=20)|fight_remains<5
  if target.debuffremaining(rip) > 4 and combopoints() < 3 and target.debuffpresent(rake_debuff) and energydeficit() >= 20 or fightremains() < 5 spell(convoke_the_spirits)

  unless { buffpresent(tigers_fury) or conduit(deep_allegiance_conduit) } and spell(kindred_spirits) or spell(adaptive_swarm)
  {
   #use_items
   feraluseitemactions()
  }
 }
}

AddFunction feralcooldowncdpostconditions
{
 combopoints() < 3 and spell(feral_frenzy) or combopoints() >= 3 and spell(berserk) or combopoints() >= 3 and spell(incarnation) or { energydeficit() > 40 or buffpresent(bs_inc_buff) or hastalent(predator_talent) and shortest_ttd() < 3 } and spell(tigers_fury) or { buffpresent(tigers_fury) or conduit(deep_allegiance_conduit) } and spell(kindred_spirits) or spell(adaptive_swarm)
}

### actions.bloodtalons

AddFunction feralbloodtalonsmainactions
{
 #rake,target_if=(!ticking|(refreshable&persistent_multiplier>dot.rake.pmultiplier)|(active_bt_triggers=2&persistent_multiplier>dot.rake.pmultiplier)|(active_bt_triggers=2&refreshable))&buff.bt_rake.down&druid.rake.ticks_gained_on_refresh>=2
 if { not target.debuffpresent(rake_debuff) or target.refreshable(rake_debuff) and persistentmultiplier(rake_debuff) > target.debuffpersistentmultiplier(rake_debuff) or buffcount(bt_buffs) == 2 and persistentmultiplier(rake_debuff) > target.debuffpersistentmultiplier(rake_debuff) or buffcount(bt_buffs) == 2 and target.refreshable(rake_debuff) } and buffexpires(bt_rake_buff) and target.ticksgainedonrefresh(rake_debuff) >= 2 spell(rake)
 #lunar_inspiration,target_if=refreshable&buff.bt_moonfire.down
 if target.refreshable(moonfire_cat) and buffexpires(bt_moonfire_buff) spell(moonfire_cat)
 #thrash_cat,target_if=refreshable&buff.bt_thrash.down&druid.thrash_cat.ticks_gained_on_refresh>variable.thrash_ticks
 if target.refreshable(thrash_cat) and buffexpires(bt_thrash_buff) and target.ticksgainedonrefresh(thrash_cat) > thrash_ticks() spell(thrash_cat)
 #brutal_slash,if=buff.bt_brutal_slash.down
 if buffexpires(bt_brutal_slash_buff) spell(brutal_slash)
 #swipe_cat,if=buff.bt_swipe.down&spell_targets.swipe_cat>1
 if buffexpires(bt_swipe_buff) and enemies(tagged=1) > 1 spell(swipe_cat)
 #shred,if=buff.bt_shred.down
 if buffexpires(bt_shred_buff) spell(shred)
 #swipe_cat,if=buff.bt_swipe.down
 if buffexpires(bt_swipe_buff) spell(swipe_cat)
 #thrash_cat,if=buff.bt_thrash.down
 if buffexpires(bt_thrash_buff) spell(thrash_cat)
}

AddFunction feralbloodtalonsmainpostconditions
{
}

AddFunction feralbloodtalonsshortcdactions
{
}

AddFunction feralbloodtalonsshortcdpostconditions
{
 { not target.debuffpresent(rake_debuff) or target.refreshable(rake_debuff) and persistentmultiplier(rake_debuff) > target.debuffpersistentmultiplier(rake_debuff) or buffcount(bt_buffs) == 2 and persistentmultiplier(rake_debuff) > target.debuffpersistentmultiplier(rake_debuff) or buffcount(bt_buffs) == 2 and target.refreshable(rake_debuff) } and buffexpires(bt_rake_buff) and target.ticksgainedonrefresh(rake_debuff) >= 2 and spell(rake) or target.refreshable(moonfire_cat) and buffexpires(bt_moonfire_buff) and spell(moonfire_cat) or target.refreshable(thrash_cat) and buffexpires(bt_thrash_buff) and target.ticksgainedonrefresh(thrash_cat) > thrash_ticks() and spell(thrash_cat) or buffexpires(bt_brutal_slash_buff) and spell(brutal_slash) or buffexpires(bt_swipe_buff) and enemies(tagged=1) > 1 and spell(swipe_cat) or buffexpires(bt_shred_buff) and spell(shred) or buffexpires(bt_swipe_buff) and spell(swipe_cat) or buffexpires(bt_thrash_buff) and spell(thrash_cat)
}

AddFunction feralbloodtalonscdactions
{
}

AddFunction feralbloodtalonscdpostconditions
{
 { not target.debuffpresent(rake_debuff) or target.refreshable(rake_debuff) and persistentmultiplier(rake_debuff) > target.debuffpersistentmultiplier(rake_debuff) or buffcount(bt_buffs) == 2 and persistentmultiplier(rake_debuff) > target.debuffpersistentmultiplier(rake_debuff) or buffcount(bt_buffs) == 2 and target.refreshable(rake_debuff) } and buffexpires(bt_rake_buff) and target.ticksgainedonrefresh(rake_debuff) >= 2 and spell(rake) or target.refreshable(moonfire_cat) and buffexpires(bt_moonfire_buff) and spell(moonfire_cat) or target.refreshable(thrash_cat) and buffexpires(bt_thrash_buff) and target.ticksgainedonrefresh(thrash_cat) > thrash_ticks() and spell(thrash_cat) or buffexpires(bt_brutal_slash_buff) and spell(brutal_slash) or buffexpires(bt_swipe_buff) and enemies(tagged=1) > 1 and spell(swipe_cat) or buffexpires(bt_shred_buff) and spell(shred) or buffexpires(bt_swipe_buff) and spell(swipe_cat) or buffexpires(bt_thrash_buff) and spell(thrash_cat)
}

### actions.default

AddFunction feral_defaultmainactions
{
 #call_action_list,name=owlweave,if=variable.owlweave=1
 if owlweave() == 1 feralowlweavemainactions()

 unless owlweave() == 1 and feralowlweavemainpostconditions()
 {
  #prowl
  spell(prowl)
  #cat_form,if=buff.cat_form.down
  if buffexpires(cat_form) spell(cat_form)
  #variable,name=shortest_ttd,value=target.time_to_die,if=variable.shortest_ttd=0
  #cycling_variable,name=shortest_ttd,op=min,value=target.time_to_die
  #run_action_list,name=stealth,if=buff.shadowmeld.up|buff.prowl.up
  if buffpresent(shadowmeld) or buffpresent(prowl) feralstealthmainactions()

  unless { buffpresent(shadowmeld) or buffpresent(prowl) } and feralstealthmainpostconditions()
  {
   #call_action_list,name=cooldown
   feralcooldownmainactions()

   unless feralcooldownmainpostconditions()
   {
    #run_action_list,name=finisher,if=combo_points>=(5-variable.4cp_bite)
    if combopoints() >= 5 - _4cp_bite() feralfinishermainactions()

    unless combopoints() >= 5 - _4cp_bite() and feralfinishermainpostconditions()
    {
     #call_action_list,name=stealth,if=buff.bs_inc.up|buff.sudden_ambush.up
     if buffpresent(bs_inc_buff) or buffpresent(sudden_ambush_buff) feralstealthmainactions()

     unless { buffpresent(bs_inc_buff) or buffpresent(sudden_ambush_buff) } and feralstealthmainpostconditions()
     {
      #pool_resource,if=talent.bloodtalons.enabled&buff.bloodtalons.down&(energy+3.5*energy.regen+(40*buff.clearcasting.up))<(115-23*buff.incarnation_king_of_the_jungle.up)&active_bt_triggers=0
      unless hastalent(bloodtalons_talent) and buffexpires(bloodtalons_buff) and energy() + 3.5 * energyregenrate() + 40 * buffpresent(clearcasting_feral_buff) < 115 - 23 * buffpresent(incarnation_king_of_the_jungle) and buffcount(bt_buffs) == 0
      {
       #run_action_list,name=bloodtalons,if=talent.bloodtalons.enabled&buff.bloodtalons.down
       if hastalent(bloodtalons_talent) and buffexpires(bloodtalons_buff) feralbloodtalonsmainactions()

       unless hastalent(bloodtalons_talent) and buffexpires(bloodtalons_buff) and feralbloodtalonsmainpostconditions()
       {
        #ferocious_bite,target_if=max:target.time_to_die,if=buff.apex_predators_craving.up
        if buffpresent(apex_predators_craving_buff) spell(ferocious_bite)
        #pool_resource,for_next=1
        #rake,target_if=(refreshable|persistent_multiplier>dot.rake.pmultiplier)&druid.rake.ticks_gained_on_refresh>spell_targets.swipe_cat*2-2
        if { target.refreshable(rake_debuff) or persistentmultiplier(rake_debuff) > target.debuffpersistentmultiplier(rake_debuff) } and target.ticksgainedonrefresh(rake_debuff) > enemies(tagged=1) * 2 - 2 spell(rake)
        unless { target.refreshable(rake_debuff) or persistentmultiplier(rake_debuff) > target.debuffpersistentmultiplier(rake_debuff) } and target.ticksgainedonrefresh(rake_debuff) > enemies(tagged=1) * 2 - 2 and { spellusable(rake) and spellcooldown(rake) < timetoenergyfor(rake) }
        {
         #moonfire_cat,target_if=refreshable&druid.moonfire_cat.ticks_gained_on_refresh>spell_targets.swipe_cat*2-2
         if target.refreshable(moonfire_cat) and target.ticksgainedonrefresh(moonfire_cat) > enemies(tagged=1) * 2 - 2 spell(moonfire_cat)
         #pool_resource,for_next=1
         #thrash_cat,target_if=refreshable&druid.thrash_cat.ticks_gained_on_refresh>variable.thrash_ticks&!buff.bs_inc.up
         if target.refreshable(thrash_cat) and target.ticksgainedonrefresh(thrash_cat) > thrash_ticks() and not buffpresent(bs_inc_buff) spell(thrash_cat)
         unless target.refreshable(thrash_cat) and target.ticksgainedonrefresh(thrash_cat) > thrash_ticks() and not buffpresent(bs_inc_buff) and { spellusable(thrash_cat) and spellcooldown(thrash_cat) < timetoenergyfor(thrash_cat) }
         {
          #pool_resource,for_next=1
          #brutal_slash,if=(raid_event.adds.in>(1+max_charges-charges_fractional)*recharge_time)&(spell_targets.brutal_slash*action.brutal_slash.damage%action.brutal_slash.cost)>(action.shred.damage%action.shred.cost)
          if 600 > { 1 + spellmaxcharges(brutal_slash) - charges(brutal_slash count=0) } * spellchargecooldown(brutal_slash) and enemies(tagged=1) * damage(brutal_slash) / powercost(brutal_slash) > damage(shred) / powercost(shred) spell(brutal_slash)
          unless 600 > { 1 + spellmaxcharges(brutal_slash) - charges(brutal_slash count=0) } * spellchargecooldown(brutal_slash) and enemies(tagged=1) * damage(brutal_slash) / powercost(brutal_slash) > damage(shred) / powercost(shred) and { spellusable(brutal_slash) and spellcooldown(brutal_slash) < timetoenergyfor(brutal_slash) }
          {
           #swipe_cat,if=spell_targets.swipe_cat>1+buff.bs_inc.up*2
           if enemies(tagged=1) > 1 + buffpresent(bs_inc_buff) * 2 spell(swipe_cat)
           #shred,if=buff.clearcasting.up
           if buffpresent(clearcasting_feral_buff) spell(shred)
           #rake,target_if=buff.bs_inc.up&druid.rake.ticks_gained_on_refresh>2
           if buffpresent(bs_inc_buff) and target.ticksgainedonrefresh(rake_debuff) > 2 spell(rake)
           #call_action_list,name=filler
           feralfillermainactions()
          }
         }
        }
       }
      }
     }
    }
   }
  }
 }
}

AddFunction feral_defaultmainpostconditions
{
 owlweave() == 1 and feralowlweavemainpostconditions() or { buffpresent(shadowmeld) or buffpresent(prowl) } and feralstealthmainpostconditions() or feralcooldownmainpostconditions() or combopoints() >= 5 - _4cp_bite() and feralfinishermainpostconditions() or { buffpresent(bs_inc_buff) or buffpresent(sudden_ambush_buff) } and feralstealthmainpostconditions() or not { hastalent(bloodtalons_talent) and buffexpires(bloodtalons_buff) and energy() + 3.5 * energyregenrate() + 40 * buffpresent(clearcasting_feral_buff) < 115 - 23 * buffpresent(incarnation_king_of_the_jungle) and buffcount(bt_buffs) == 0 } and { hastalent(bloodtalons_talent) and buffexpires(bloodtalons_buff) and feralbloodtalonsmainpostconditions() or not { { target.refreshable(rake_debuff) or persistentmultiplier(rake_debuff) > target.debuffpersistentmultiplier(rake_debuff) } and target.ticksgainedonrefresh(rake_debuff) > enemies(tagged=1) * 2 - 2 and { spellusable(rake) and spellcooldown(rake) < timetoenergyfor(rake) } } and { not { target.refreshable(thrash_cat) and target.ticksgainedonrefresh(thrash_cat) > thrash_ticks() and not buffpresent(bs_inc_buff) and { spellusable(thrash_cat) and spellcooldown(thrash_cat) < timetoenergyfor(thrash_cat) } } and { not { 600 > { 1 + spellmaxcharges(brutal_slash) - charges(brutal_slash count=0) } * spellchargecooldown(brutal_slash) and enemies(tagged=1) * damage(brutal_slash) / powercost(brutal_slash) > damage(shred) / powercost(shred) and { spellusable(brutal_slash) and spellcooldown(brutal_slash) < timetoenergyfor(brutal_slash) } } and feralfillermainpostconditions() } } }
}

AddFunction feral_defaultshortcdactions
{
 #call_action_list,name=owlweave,if=variable.owlweave=1
 if owlweave() == 1 feralowlweaveshortcdactions()

 unless owlweave() == 1 and feralowlweaveshortcdpostconditions() or spell(prowl)
 {
  #tigers_fury,if=buff.cat_form.down
  if buffexpires(cat_form) spell(tigers_fury)

  unless buffexpires(cat_form) and spell(cat_form)
  {
   #auto_attack,if=!buff.prowl.up&!buff.shadowmeld.up
   if not buffpresent(prowl) and not buffpresent(shadowmeld) feralgetinmeleerange()
   #variable,name=shortest_ttd,value=target.time_to_die,if=variable.shortest_ttd=0
   #cycling_variable,name=shortest_ttd,op=min,value=target.time_to_die
   #run_action_list,name=stealth,if=buff.shadowmeld.up|buff.prowl.up
   if buffpresent(shadowmeld) or buffpresent(prowl) feralstealthshortcdactions()

   unless { buffpresent(shadowmeld) or buffpresent(prowl) } and feralstealthshortcdpostconditions()
   {
    #call_action_list,name=cooldown
    feralcooldownshortcdactions()

    unless feralcooldownshortcdpostconditions()
    {
     #run_action_list,name=finisher,if=combo_points>=(5-variable.4cp_bite)
     if combopoints() >= 5 - _4cp_bite() feralfinishershortcdactions()

     unless combopoints() >= 5 - _4cp_bite() and feralfinishershortcdpostconditions()
     {
      #call_action_list,name=stealth,if=buff.bs_inc.up|buff.sudden_ambush.up
      if buffpresent(bs_inc_buff) or buffpresent(sudden_ambush_buff) feralstealthshortcdactions()

      unless { buffpresent(bs_inc_buff) or buffpresent(sudden_ambush_buff) } and feralstealthshortcdpostconditions()
      {
       #pool_resource,if=talent.bloodtalons.enabled&buff.bloodtalons.down&(energy+3.5*energy.regen+(40*buff.clearcasting.up))<(115-23*buff.incarnation_king_of_the_jungle.up)&active_bt_triggers=0
       unless hastalent(bloodtalons_talent) and buffexpires(bloodtalons_buff) and energy() + 3.5 * energyregenrate() + 40 * buffpresent(clearcasting_feral_buff) < 115 - 23 * buffpresent(incarnation_king_of_the_jungle) and buffcount(bt_buffs) == 0
       {
        #run_action_list,name=bloodtalons,if=talent.bloodtalons.enabled&buff.bloodtalons.down
        if hastalent(bloodtalons_talent) and buffexpires(bloodtalons_buff) feralbloodtalonsshortcdactions()

        unless hastalent(bloodtalons_talent) and buffexpires(bloodtalons_buff) and feralbloodtalonsshortcdpostconditions() or buffpresent(apex_predators_craving_buff) and spell(ferocious_bite)
        {
         #pool_resource,for_next=1
         #rake,target_if=(refreshable|persistent_multiplier>dot.rake.pmultiplier)&druid.rake.ticks_gained_on_refresh>spell_targets.swipe_cat*2-2
         unless { target.refreshable(rake_debuff) or persistentmultiplier(rake_debuff) > target.debuffpersistentmultiplier(rake_debuff) } and target.ticksgainedonrefresh(rake_debuff) > enemies(tagged=1) * 2 - 2 and { spellusable(rake) and spellcooldown(rake) < timetoenergyfor(rake) }
         {
          unless target.refreshable(moonfire_cat) and target.ticksgainedonrefresh(moonfire_cat) > enemies(tagged=1) * 2 - 2 and spell(moonfire_cat)
          {
           #pool_resource,for_next=1
           #thrash_cat,target_if=refreshable&druid.thrash_cat.ticks_gained_on_refresh>variable.thrash_ticks&!buff.bs_inc.up
           unless target.refreshable(thrash_cat) and target.ticksgainedonrefresh(thrash_cat) > thrash_ticks() and not buffpresent(bs_inc_buff) and { spellusable(thrash_cat) and spellcooldown(thrash_cat) < timetoenergyfor(thrash_cat) }
           {
            #pool_resource,for_next=1
            #brutal_slash,if=(raid_event.adds.in>(1+max_charges-charges_fractional)*recharge_time)&(spell_targets.brutal_slash*action.brutal_slash.damage%action.brutal_slash.cost)>(action.shred.damage%action.shred.cost)
            unless 600 > { 1 + spellmaxcharges(brutal_slash) - charges(brutal_slash count=0) } * spellchargecooldown(brutal_slash) and enemies(tagged=1) * damage(brutal_slash) / powercost(brutal_slash) > damage(shred) / powercost(shred) and { spellusable(brutal_slash) and spellcooldown(brutal_slash) < timetoenergyfor(brutal_slash) }
            {
             unless enemies(tagged=1) > 1 + buffpresent(bs_inc_buff) * 2 and spell(swipe_cat) or buffpresent(clearcasting_feral_buff) and spell(shred) or buffpresent(bs_inc_buff) and target.ticksgainedonrefresh(rake_debuff) > 2 and spell(rake)
             {
              #call_action_list,name=filler
              feralfillershortcdactions()
             }
            }
           }
          }
         }
        }
       }
      }
     }
    }
   }
  }
 }
}

AddFunction feral_defaultshortcdpostconditions
{
 owlweave() == 1 and feralowlweaveshortcdpostconditions() or spell(prowl) or buffexpires(cat_form) and spell(cat_form) or { buffpresent(shadowmeld) or buffpresent(prowl) } and feralstealthshortcdpostconditions() or feralcooldownshortcdpostconditions() or combopoints() >= 5 - _4cp_bite() and feralfinishershortcdpostconditions() or { buffpresent(bs_inc_buff) or buffpresent(sudden_ambush_buff) } and feralstealthshortcdpostconditions() or not { hastalent(bloodtalons_talent) and buffexpires(bloodtalons_buff) and energy() + 3.5 * energyregenrate() + 40 * buffpresent(clearcasting_feral_buff) < 115 - 23 * buffpresent(incarnation_king_of_the_jungle) and buffcount(bt_buffs) == 0 } and { hastalent(bloodtalons_talent) and buffexpires(bloodtalons_buff) and feralbloodtalonsshortcdpostconditions() or buffpresent(apex_predators_craving_buff) and spell(ferocious_bite) or not { { target.refreshable(rake_debuff) or persistentmultiplier(rake_debuff) > target.debuffpersistentmultiplier(rake_debuff) } and target.ticksgainedonrefresh(rake_debuff) > enemies(tagged=1) * 2 - 2 and { spellusable(rake) and spellcooldown(rake) < timetoenergyfor(rake) } } and { target.refreshable(moonfire_cat) and target.ticksgainedonrefresh(moonfire_cat) > enemies(tagged=1) * 2 - 2 and spell(moonfire_cat) or not { target.refreshable(thrash_cat) and target.ticksgainedonrefresh(thrash_cat) > thrash_ticks() and not buffpresent(bs_inc_buff) and { spellusable(thrash_cat) and spellcooldown(thrash_cat) < timetoenergyfor(thrash_cat) } } and { not { 600 > { 1 + spellmaxcharges(brutal_slash) - charges(brutal_slash count=0) } * spellchargecooldown(brutal_slash) and enemies(tagged=1) * damage(brutal_slash) / powercost(brutal_slash) > damage(shred) / powercost(shred) and { spellusable(brutal_slash) and spellcooldown(brutal_slash) < timetoenergyfor(brutal_slash) } } and { enemies(tagged=1) > 1 + buffpresent(bs_inc_buff) * 2 and spell(swipe_cat) or buffpresent(clearcasting_feral_buff) and spell(shred) or buffpresent(bs_inc_buff) and target.ticksgainedonrefresh(rake_debuff) > 2 and spell(rake) or feralfillershortcdpostconditions() } } } }
}

AddFunction feral_defaultcdactions
{
 feralinterruptactions()
 #call_action_list,name=owlweave,if=variable.owlweave=1
 if owlweave() == 1 feralowlweavecdactions()

 unless owlweave() == 1 and feralowlweavecdpostconditions() or spell(prowl) or buffexpires(cat_form) and spell(tigers_fury) or buffexpires(cat_form) and spell(cat_form)
 {
  #variable,name=shortest_ttd,value=target.time_to_die,if=variable.shortest_ttd=0
  #cycling_variable,name=shortest_ttd,op=min,value=target.time_to_die
  #run_action_list,name=stealth,if=buff.shadowmeld.up|buff.prowl.up
  if buffpresent(shadowmeld) or buffpresent(prowl) feralstealthcdactions()

  unless { buffpresent(shadowmeld) or buffpresent(prowl) } and feralstealthcdpostconditions()
  {
   #call_action_list,name=cooldown
   feralcooldowncdactions()

   unless feralcooldowncdpostconditions()
   {
    #run_action_list,name=finisher,if=combo_points>=(5-variable.4cp_bite)
    if combopoints() >= 5 - _4cp_bite() feralfinishercdactions()

    unless combopoints() >= 5 - _4cp_bite() and feralfinishercdpostconditions()
    {
     #call_action_list,name=stealth,if=buff.bs_inc.up|buff.sudden_ambush.up
     if buffpresent(bs_inc_buff) or buffpresent(sudden_ambush_buff) feralstealthcdactions()

     unless { buffpresent(bs_inc_buff) or buffpresent(sudden_ambush_buff) } and feralstealthcdpostconditions()
     {
      #pool_resource,if=talent.bloodtalons.enabled&buff.bloodtalons.down&(energy+3.5*energy.regen+(40*buff.clearcasting.up))<(115-23*buff.incarnation_king_of_the_jungle.up)&active_bt_triggers=0
      unless hastalent(bloodtalons_talent) and buffexpires(bloodtalons_buff) and energy() + 3.5 * energyregenrate() + 40 * buffpresent(clearcasting_feral_buff) < 115 - 23 * buffpresent(incarnation_king_of_the_jungle) and buffcount(bt_buffs) == 0
      {
       #run_action_list,name=bloodtalons,if=talent.bloodtalons.enabled&buff.bloodtalons.down
       if hastalent(bloodtalons_talent) and buffexpires(bloodtalons_buff) feralbloodtalonscdactions()

       unless hastalent(bloodtalons_talent) and buffexpires(bloodtalons_buff) and feralbloodtalonscdpostconditions() or buffpresent(apex_predators_craving_buff) and spell(ferocious_bite)
       {
        #pool_resource,for_next=1
        #rake,target_if=(refreshable|persistent_multiplier>dot.rake.pmultiplier)&druid.rake.ticks_gained_on_refresh>spell_targets.swipe_cat*2-2
        unless { target.refreshable(rake_debuff) or persistentmultiplier(rake_debuff) > target.debuffpersistentmultiplier(rake_debuff) } and target.ticksgainedonrefresh(rake_debuff) > enemies(tagged=1) * 2 - 2 and { spellusable(rake) and spellcooldown(rake) < timetoenergyfor(rake) }
        {
         unless target.refreshable(moonfire_cat) and target.ticksgainedonrefresh(moonfire_cat) > enemies(tagged=1) * 2 - 2 and spell(moonfire_cat)
         {
          #pool_resource,for_next=1
          #thrash_cat,target_if=refreshable&druid.thrash_cat.ticks_gained_on_refresh>variable.thrash_ticks&!buff.bs_inc.up
          unless target.refreshable(thrash_cat) and target.ticksgainedonrefresh(thrash_cat) > thrash_ticks() and not buffpresent(bs_inc_buff) and { spellusable(thrash_cat) and spellcooldown(thrash_cat) < timetoenergyfor(thrash_cat) }
          {
           #pool_resource,for_next=1
           #brutal_slash,if=(raid_event.adds.in>(1+max_charges-charges_fractional)*recharge_time)&(spell_targets.brutal_slash*action.brutal_slash.damage%action.brutal_slash.cost)>(action.shred.damage%action.shred.cost)
           unless 600 > { 1 + spellmaxcharges(brutal_slash) - charges(brutal_slash count=0) } * spellchargecooldown(brutal_slash) and enemies(tagged=1) * damage(brutal_slash) / powercost(brutal_slash) > damage(shred) / powercost(shred) and { spellusable(brutal_slash) and spellcooldown(brutal_slash) < timetoenergyfor(brutal_slash) }
           {
            unless enemies(tagged=1) > 1 + buffpresent(bs_inc_buff) * 2 and spell(swipe_cat) or buffpresent(clearcasting_feral_buff) and spell(shred) or buffpresent(bs_inc_buff) and target.ticksgainedonrefresh(rake_debuff) > 2 and spell(rake)
            {
             #call_action_list,name=filler
             feralfillercdactions()
            }
           }
          }
         }
        }
       }
      }
     }
    }
   }
  }
 }
}

AddFunction feral_defaultcdpostconditions
{
 owlweave() == 1 and feralowlweavecdpostconditions() or spell(prowl) or buffexpires(cat_form) and spell(tigers_fury) or buffexpires(cat_form) and spell(cat_form) or { buffpresent(shadowmeld) or buffpresent(prowl) } and feralstealthcdpostconditions() or feralcooldowncdpostconditions() or combopoints() >= 5 - _4cp_bite() and feralfinishercdpostconditions() or { buffpresent(bs_inc_buff) or buffpresent(sudden_ambush_buff) } and feralstealthcdpostconditions() or not { hastalent(bloodtalons_talent) and buffexpires(bloodtalons_buff) and energy() + 3.5 * energyregenrate() + 40 * buffpresent(clearcasting_feral_buff) < 115 - 23 * buffpresent(incarnation_king_of_the_jungle) and buffcount(bt_buffs) == 0 } and { hastalent(bloodtalons_talent) and buffexpires(bloodtalons_buff) and feralbloodtalonscdpostconditions() or buffpresent(apex_predators_craving_buff) and spell(ferocious_bite) or not { { target.refreshable(rake_debuff) or persistentmultiplier(rake_debuff) > target.debuffpersistentmultiplier(rake_debuff) } and target.ticksgainedonrefresh(rake_debuff) > enemies(tagged=1) * 2 - 2 and { spellusable(rake) and spellcooldown(rake) < timetoenergyfor(rake) } } and { target.refreshable(moonfire_cat) and target.ticksgainedonrefresh(moonfire_cat) > enemies(tagged=1) * 2 - 2 and spell(moonfire_cat) or not { target.refreshable(thrash_cat) and target.ticksgainedonrefresh(thrash_cat) > thrash_ticks() and not buffpresent(bs_inc_buff) and { spellusable(thrash_cat) and spellcooldown(thrash_cat) < timetoenergyfor(thrash_cat) } } and { not { 600 > { 1 + spellmaxcharges(brutal_slash) - charges(brutal_slash count=0) } * spellchargecooldown(brutal_slash) and enemies(tagged=1) * damage(brutal_slash) / powercost(brutal_slash) > damage(shred) / powercost(shred) and { spellusable(brutal_slash) and spellcooldown(brutal_slash) < timetoenergyfor(brutal_slash) } } and { enemies(tagged=1) > 1 + buffpresent(bs_inc_buff) * 2 and spell(swipe_cat) or buffpresent(clearcasting_feral_buff) and spell(shred) or buffpresent(bs_inc_buff) and target.ticksgainedonrefresh(rake_debuff) > 2 and spell(rake) or feralfillercdpostconditions() } } } }
}

### Feral icons.

AddCheckBox(opt_druid_feral_aoe l(aoe) default enabled=(specialization(feral)))

AddIcon enabled=(not checkboxon(opt_druid_feral_aoe) and specialization(feral)) enemies=1 help=shortcd
{
 if not incombat() feralprecombatshortcdactions()
 feral_defaultshortcdactions()
}

AddIcon enabled=(checkboxon(opt_druid_feral_aoe) and specialization(feral)) help=shortcd
{
 if not incombat() feralprecombatshortcdactions()
 feral_defaultshortcdactions()
}

AddIcon enabled=(specialization(feral)) enemies=1 help=main
{
 if not incombat() feralprecombatmainactions()
 feral_defaultmainactions()
}

AddIcon enabled=(checkboxon(opt_druid_feral_aoe) and specialization(feral)) help=aoe
{
 if not incombat() feralprecombatmainactions()
 feral_defaultmainactions()
}

AddIcon enabled=(not checkboxon(opt_druid_feral_aoe) and specialization(feral)) enemies=1 help=cd
{
 if not incombat() feralprecombatcdactions()
 feral_defaultcdactions()
}

AddIcon enabled=(checkboxon(opt_druid_feral_aoe) and specialization(feral)) help=cd
{
 if not incombat() feralprecombatcdactions()
 feral_defaultcdactions()
}

### Required symbols
# adaptive_swarm
# apex_predators_craving_buff
# berserk
# berserking
# bloodlust
# bloodtalons_buff
# bloodtalons_talent
# brutal_slash
# bs_inc_buff
# bt_brutal_slash_buff
# bt_buffs
# bt_moonfire_buff
# bt_rake_buff
# bt_shred_buff
# bt_swipe_buff
# bt_thrash_buff
# cat_form
# clearcasting_feral_buff
# convoke_the_spirits
# deep_allegiance_conduit
# feral_frenzy
# ferocious_bite
# heart_of_the_wild
# incarnation
# incarnation_king_of_the_jungle
# kindred_spirits
# maim
# mangle
# mighty_bash
# moonfire_cat
# moonkin_form
# potion_of_spectral_agility_item
# predator_talent
# primal_wrath
# primal_wrath_talent
# prowl
# rake
# rake_debuff
# ravenous_frenzy
# rip
# sabertooth_talent
# savage_roar
# shadowmeld
# shred
# skull_bash
# starsurge
# sudden_ambush_buff
# sunfire
# swipe
# swipe_cat
# thrash_cat
# tigers_fury
# typhoon
# war_stomp
# wild_charge_bear
# wild_charge_cat
]]
        scripts:registerScript("DRUID", "feral", name, desc, code, "script")
    end
    do
        local name = "sc_t26_druid_guardian"
        local desc = "[9.0] Simulationcraft: T26_Druid_Guardian"
        local code = [[
# Based on SimulationCraft profile "T26_Druid_Guardian".
#	class=druid
#	spec=guardian
#	talents=1013221

Include(ovale_common)
Include(ovale_druid_spells)

AddCheckBox(opt_interrupt l(interrupt) default enabled=(specialization(guardian)))
AddCheckBox(opt_melee_range l(not_in_melee_range) enabled=(specialization(guardian)))
AddCheckBox(opt_use_consumables l(opt_use_consumables) default enabled=(specialization(guardian)))
AddCheckBox(owlweave_bear l(owlweave_bear) default enabled=(specialization(guardian)))
AddCheckBox(catweave_bear l(catweave_bear) default enabled=(specialization(guardian)))

AddFunction guardianinterruptactions
{
 if checkboxon(opt_interrupt) and not target.isfriend() and target.casting()
 {
  if target.inrange(skull_bash) and target.isinterruptible() spell(skull_bash)
  if target.inrange(mighty_bash) and not target.classification(worldboss) spell(mighty_bash)
  if target.distance() < 10 and not target.classification(worldboss) spell(incapacitating_roar)
  if target.distance() < 5 and not target.classification(worldboss) spell(war_stomp)
  if target.distance() < 15 and not target.classification(worldboss) spell(typhoon)
 }
}

AddFunction guardianuseitemactions
{
 item(trinket0slot text=13 usable=1)
 item(trinket1slot text=14 usable=1)
}

AddFunction guardiangetinmeleerange
{
 if checkboxon(opt_melee_range)
 {
  if stance(druid_bear_form) and not target.inrange(mangle)
  {
   if target.inrange(wild_charge_bear) spell(wild_charge_bear)
   texture(misc_arrowlup help=(l(not_in_melee_range)))
  }
  if (stance(druid_cat_form) or stance(druid_claws_of_shirvallah)) and not target.inrange(shred)
  {
   if target.inrange(wild_charge_cat) spell(wild_charge_cat)
   texture(misc_arrowlup help=(l(not_in_melee_range)))
  }
 }
}

### actions.precombat

AddFunction guardianprecombatmainactions
{
 #flask
 #food
 #augmentation
 #snapshot_stats
 #cat_form,if=(druid.catweave_bear)|(covenant.night_fae&talent.feral_affinity.enabled)
 if { checkboxon("catweave_bear") or iscovenant("night_fae") and hastalent(feral_affinity_talent_guardian) } and buffexpires(cat_form) spell(cat_form)
 #prowl,if=druid.catweave_bear
 if checkboxon("catweave_bear") and buffexpires(prowl) spell(prowl)
 #moonkin_form,if=(druid.owlweave_bear)|(covenant.night_fae&talent.balance_affinity.enabled)
 if { checkboxon("owlweave_bear") or iscovenant("night_fae") and hastalent(balance_affinity_talent) } and buffexpires(moonkin_form) spell(moonkin_form)
 #bear_form,if=((!druid.owlweave_bear&!druid.catweave_bear)&(!covenant.night_fae))|((!druid.owlweave_bear&!druid.catweave_bear)&(covenant.night_fae&talent.restoration_affinity.enabled))
 if { not checkboxon("owlweave_bear") and not checkboxon("catweave_bear") and not iscovenant("night_fae") or not checkboxon("owlweave_bear") and not checkboxon("catweave_bear") and iscovenant("night_fae") and hastalent(restoration_affinity_talent) } and buffexpires(bear_form) spell(bear_form)
 #wrath,if=druid.owlweave_bear&!covenant.night_fae
 if checkboxon("owlweave_bear") and not iscovenant("night_fae") spell(wrath)
 #starfire,if=druid.owlweave_bear&covenant.night_fae
 if checkboxon("owlweave_bear") and iscovenant("night_fae") spell(starfire)
}

AddFunction guardianprecombatmainpostconditions
{
}

AddFunction guardianprecombatshortcdactions
{
}

AddFunction guardianprecombatshortcdpostconditions
{
 { checkboxon("catweave_bear") or iscovenant("night_fae") and hastalent(feral_affinity_talent_guardian) } and buffexpires(cat_form) and spell(cat_form) or checkboxon("catweave_bear") and buffexpires(prowl) and spell(prowl) or { checkboxon("owlweave_bear") or iscovenant("night_fae") and hastalent(balance_affinity_talent) } and buffexpires(moonkin_form) and spell(moonkin_form) or { not checkboxon("owlweave_bear") and not checkboxon("catweave_bear") and not iscovenant("night_fae") or not checkboxon("owlweave_bear") and not checkboxon("catweave_bear") and iscovenant("night_fae") and hastalent(restoration_affinity_talent) } and buffexpires(bear_form) and spell(bear_form) or checkboxon("owlweave_bear") and not iscovenant("night_fae") and spell(wrath) or checkboxon("owlweave_bear") and iscovenant("night_fae") and spell(starfire)
}

AddFunction guardianprecombatcdactions
{
 unless { checkboxon("catweave_bear") or iscovenant("night_fae") and hastalent(feral_affinity_talent_guardian) } and buffexpires(cat_form) and spell(cat_form) or checkboxon("catweave_bear") and buffexpires(prowl) and spell(prowl) or { checkboxon("owlweave_bear") or iscovenant("night_fae") and hastalent(balance_affinity_talent) } and buffexpires(moonkin_form) and spell(moonkin_form) or { not checkboxon("owlweave_bear") and not checkboxon("catweave_bear") and not iscovenant("night_fae") or not checkboxon("owlweave_bear") and not checkboxon("catweave_bear") and iscovenant("night_fae") and hastalent(restoration_affinity_talent) } and buffexpires(bear_form) and spell(bear_form)
 {
  #heart_of_the_Wild,if=talent.heart_of_the_wild.enabled&(druid.catweave_bear|druid.owlweave_bear|talent.balance_affinity.enabled)
  if hastalent(heart_of_the_wild_talent) and { checkboxon("catweave_bear") or checkboxon("owlweave_bear") or hastalent(balance_affinity_talent) } spell(heart_of_the_wild)
 }
}

AddFunction guardianprecombatcdpostconditions
{
 { checkboxon("catweave_bear") or iscovenant("night_fae") and hastalent(feral_affinity_talent_guardian) } and buffexpires(cat_form) and spell(cat_form) or checkboxon("catweave_bear") and buffexpires(prowl) and spell(prowl) or { checkboxon("owlweave_bear") or iscovenant("night_fae") and hastalent(balance_affinity_talent) } and buffexpires(moonkin_form) and spell(moonkin_form) or { not checkboxon("owlweave_bear") and not checkboxon("catweave_bear") and not iscovenant("night_fae") or not checkboxon("owlweave_bear") and not checkboxon("catweave_bear") and iscovenant("night_fae") and hastalent(restoration_affinity_talent) } and buffexpires(bear_form) and spell(bear_form) or checkboxon("owlweave_bear") and not iscovenant("night_fae") and spell(wrath) or checkboxon("owlweave_bear") and iscovenant("night_fae") and spell(starfire)
}

### actions.owlweave

AddFunction guardianowlweavemainactions
{
 #moonkin_form,if=!buff.moonkin_form.up
 if not buffpresent(moonkin_form) spell(moonkin_form)
 #starsurge
 spell(starsurge)
 #adaptive_swarm,if=(!dot.adaptive_swarm_damage.ticking&!action.adaptive_swarm_damage.in_flight&(!dot.adaptive_swarm_heal.ticking|dot.adaptive_swarm_heal.remains>3)|dot.adaptive_swarm_damage.stack<3&dot.adaptive_swarm_damage.remains<5&dot.adaptive_swarm_damage.ticking)
 if not target.debuffpresent(adaptive_swarm_damage) and not inflighttotarget(adaptive_swarm_damage) and { not target.debuffpresent(adaptive_swarm) or target.debuffremaining(adaptive_swarm) > 3 } or target.debuffstacks(adaptive_swarm_damage) < 3 and target.debuffremaining(adaptive_swarm_damage) < 5 and target.debuffpresent(adaptive_swarm_damage) spell(adaptive_swarm)
 #sunfire,target_if=refreshable
 if target.refreshable(sunfire_debuff) spell(sunfire)
 #moonfire,target_if=refreshable|buff.galactic_guardian.up
 if target.refreshable(moonfire_debuff) or buffpresent(galactic_guardian_buff) spell(moonfire)
 #starfire,if=covenant.night_fae&eclipse.any_next
 if iscovenant("night_fae") and counter(lunar) + counter(solar) == 1 spell(starfire)
 #wrath,if=!covenant.night_fae&eclipse.any_next
 if not iscovenant("night_fae") and counter(lunar) + counter(solar) == 1 spell(wrath)
 #starfire,if=(eclipse.in_lunar|eclipse.solar_next)|(eclipse.in_lunar&buff.starsurge_empowerment_lunar.up)
 if buffpresent(eclipse_lunar_buff) or counter(solar) == 1 or buffpresent(eclipse_lunar_buff) and buffpresent(starsurge_empowerment_lunar_buff) spell(starfire)
 #wrath
 spell(wrath)
}

AddFunction guardianowlweavemainpostconditions
{
}

AddFunction guardianowlweaveshortcdactions
{
 unless not buffpresent(moonkin_form) and spell(moonkin_form) or spell(starsurge)
 {
  #empower_bond,if=druid.owlweave_bear
  if checkboxon("owlweave_bear") spell(empower_bond)
 }
}

AddFunction guardianowlweaveshortcdpostconditions
{
 not buffpresent(moonkin_form) and spell(moonkin_form) or spell(starsurge) or { not target.debuffpresent(adaptive_swarm_damage) and not inflighttotarget(adaptive_swarm_damage) and { not target.debuffpresent(adaptive_swarm) or target.debuffremaining(adaptive_swarm) > 3 } or target.debuffstacks(adaptive_swarm_damage) < 3 and target.debuffremaining(adaptive_swarm_damage) < 5 and target.debuffpresent(adaptive_swarm_damage) } and spell(adaptive_swarm) or target.refreshable(sunfire_debuff) and spell(sunfire) or { target.refreshable(moonfire_debuff) or buffpresent(galactic_guardian_buff) } and spell(moonfire) or iscovenant("night_fae") and counter(lunar) + counter(solar) == 1 and spell(starfire) or not iscovenant("night_fae") and counter(lunar) + counter(solar) == 1 and spell(wrath) or { buffpresent(eclipse_lunar_buff) or counter(solar) == 1 or buffpresent(eclipse_lunar_buff) and buffpresent(starsurge_empowerment_lunar_buff) } and spell(starfire) or spell(wrath)
}

AddFunction guardianowlweavecdactions
{
 unless not buffpresent(moonkin_form) and spell(moonkin_form)
 {
  #heart_of_the_wild,if=talent.heart_of_the_wild.enabled&!buff.heart_of_the_wild.up
  if hastalent(heart_of_the_wild_talent) and not buffpresent(heart_of_the_wild) spell(heart_of_the_wild)

  unless spell(starsurge)
  {
   #convoke_the_spirits,if=soulbind.first_strike.enabled
   if enabledsoulbind(first_strike_soulbind) spell(convoke_the_spirits)

   unless checkboxon("owlweave_bear") and spell(empower_bond) or { not target.debuffpresent(adaptive_swarm_damage) and not inflighttotarget(adaptive_swarm_damage) and { not target.debuffpresent(adaptive_swarm) or target.debuffremaining(adaptive_swarm) > 3 } or target.debuffstacks(adaptive_swarm_damage) < 3 and target.debuffremaining(adaptive_swarm_damage) < 5 and target.debuffpresent(adaptive_swarm_damage) } and spell(adaptive_swarm) or target.refreshable(sunfire_debuff) and spell(sunfire) or { target.refreshable(moonfire_debuff) or buffpresent(galactic_guardian_buff) } and spell(moonfire) or iscovenant("night_fae") and counter(lunar) + counter(solar) == 1 and spell(starfire) or not iscovenant("night_fae") and counter(lunar) + counter(solar) == 1 and spell(wrath)
   {
    #convoke_the_spirits,if=(buff.eclipse_lunar.up|buff.eclipse_solar.up)
    if buffpresent(eclipse_lunar_buff) or buffpresent(eclipse_solar_buff) spell(convoke_the_spirits)
   }
  }
 }
}

AddFunction guardianowlweavecdpostconditions
{
 not buffpresent(moonkin_form) and spell(moonkin_form) or spell(starsurge) or checkboxon("owlweave_bear") and spell(empower_bond) or { not target.debuffpresent(adaptive_swarm_damage) and not inflighttotarget(adaptive_swarm_damage) and { not target.debuffpresent(adaptive_swarm) or target.debuffremaining(adaptive_swarm) > 3 } or target.debuffstacks(adaptive_swarm_damage) < 3 and target.debuffremaining(adaptive_swarm_damage) < 5 and target.debuffpresent(adaptive_swarm_damage) } and spell(adaptive_swarm) or target.refreshable(sunfire_debuff) and spell(sunfire) or { target.refreshable(moonfire_debuff) or buffpresent(galactic_guardian_buff) } and spell(moonfire) or iscovenant("night_fae") and counter(lunar) + counter(solar) == 1 and spell(starfire) or not iscovenant("night_fae") and counter(lunar) + counter(solar) == 1 and spell(wrath) or { buffpresent(eclipse_lunar_buff) or counter(solar) == 1 or buffpresent(eclipse_lunar_buff) and buffpresent(starsurge_empowerment_lunar_buff) } and spell(starfire) or spell(wrath)
}

### actions.oconvoke

AddFunction guardianoconvokemainactions
{
 #moonkin_form
 spell(moonkin_form)
}

AddFunction guardianoconvokemainpostconditions
{
}

AddFunction guardianoconvokeshortcdactions
{
}

AddFunction guardianoconvokeshortcdpostconditions
{
 spell(moonkin_form)
}

AddFunction guardianoconvokecdactions
{
 unless spell(moonkin_form)
 {
  #convoke_the_spirits
  spell(convoke_the_spirits)
 }
}

AddFunction guardianoconvokecdpostconditions
{
 spell(moonkin_form)
}

### actions.lycarao

AddFunction guardianlycaraomainactions
{
 #moonkin_form
 spell(moonkin_form)
}

AddFunction guardianlycaraomainpostconditions
{
}

AddFunction guardianlycaraoshortcdactions
{
}

AddFunction guardianlycaraoshortcdpostconditions
{
 spell(moonkin_form)
}

AddFunction guardianlycaraocdactions
{
}

AddFunction guardianlycaraocdpostconditions
{
 spell(moonkin_form)
}

### actions.lycarac

AddFunction guardianlycaracmainactions
{
 #cat_form
 spell(cat_form)
}

AddFunction guardianlycaracmainpostconditions
{
}

AddFunction guardianlycaracshortcdactions
{
}

AddFunction guardianlycaracshortcdpostconditions
{
 spell(cat_form)
}

AddFunction guardianlycaraccdactions
{
}

AddFunction guardianlycaraccdpostconditions
{
 spell(cat_form)
}

### actions.cconvoke

AddFunction guardiancconvokemainactions
{
 #cat_form
 spell(cat_form)
}

AddFunction guardiancconvokemainpostconditions
{
}

AddFunction guardiancconvokeshortcdactions
{
}

AddFunction guardiancconvokeshortcdpostconditions
{
 spell(cat_form)
}

AddFunction guardiancconvokecdactions
{
 unless spell(cat_form)
 {
  #convoke_the_spirits
  spell(convoke_the_spirits)
 }
}

AddFunction guardiancconvokecdpostconditions
{
 spell(cat_form)
}

### actions.catweave

AddFunction guardiancatweavemainactions
{
 #cat_form,if=!buff.cat_form.up
 if not buffpresent(cat_form) spell(cat_form)
 #rake,if=buff.prowl.up
 if buffpresent(prowl) spell(rake)
 #rip,if=dot.rip.refreshable&combo_points>=4
 if target.debuffrefreshable(rip) and combopoints() >= 4 spell(rip)
 #ferocious_bite,if=combo_points>=4
 if combopoints() >= 4 spell(ferocious_bite)
 #adaptive_swarm,if=(!dot.adaptive_swarm_damage.ticking&!action.adaptive_swarm_damage.in_flight&(!dot.adaptive_swarm_heal.ticking|dot.adaptive_swarm_heal.remains>3)|dot.adaptive_swarm_damage.stack<3&dot.adaptive_swarm_damage.remains<5&dot.adaptive_swarm_damage.ticking)
 if not target.debuffpresent(adaptive_swarm_damage) and not inflighttotarget(adaptive_swarm_damage) and { not target.debuffpresent(adaptive_swarm) or target.debuffremaining(adaptive_swarm) > 3 } or target.debuffstacks(adaptive_swarm_damage) < 3 and target.debuffremaining(adaptive_swarm_damage) < 5 and target.debuffpresent(adaptive_swarm_damage) spell(adaptive_swarm)
 #rake,if=dot.rake.refreshable&combo_points<4
 if target.debuffrefreshable(rake_debuff) and combopoints() < 4 spell(rake)
 #shred
 spell(shred)
}

AddFunction guardiancatweavemainpostconditions
{
}

AddFunction guardiancatweaveshortcdactions
{
 unless not buffpresent(cat_form) and spell(cat_form) or buffpresent(prowl) and spell(rake)
 {
  #empower_bond,if=druid.catweave_bear
  if checkboxon("catweave_bear") spell(empower_bond)
 }
}

AddFunction guardiancatweaveshortcdpostconditions
{
 not buffpresent(cat_form) and spell(cat_form) or buffpresent(prowl) and spell(rake) or target.debuffrefreshable(rip) and combopoints() >= 4 and spell(rip) or combopoints() >= 4 and spell(ferocious_bite) or { not target.debuffpresent(adaptive_swarm_damage) and not inflighttotarget(adaptive_swarm_damage) and { not target.debuffpresent(adaptive_swarm) or target.debuffremaining(adaptive_swarm) > 3 } or target.debuffstacks(adaptive_swarm_damage) < 3 and target.debuffremaining(adaptive_swarm_damage) < 5 and target.debuffpresent(adaptive_swarm_damage) } and spell(adaptive_swarm) or target.debuffrefreshable(rake_debuff) and combopoints() < 4 and spell(rake) or spell(shred)
}

AddFunction guardiancatweavecdactions
{
 unless not buffpresent(cat_form) and spell(cat_form) or buffpresent(prowl) and spell(rake)
 {
  #heart_of_the_wild,if=talent.heart_of_the_wild.enabled&!buff.heart_of_the_wild.up
  if hastalent(heart_of_the_wild_talent) and not buffpresent(heart_of_the_wild) spell(heart_of_the_wild)

  unless checkboxon("catweave_bear") and spell(empower_bond)
  {
   #convoke_the_spirits,if=druid.catweave_bear
   if checkboxon("catweave_bear") spell(convoke_the_spirits)
  }
 }
}

AddFunction guardiancatweavecdpostconditions
{
 not buffpresent(cat_form) and spell(cat_form) or buffpresent(prowl) and spell(rake) or checkboxon("catweave_bear") and spell(empower_bond) or target.debuffrefreshable(rip) and combopoints() >= 4 and spell(rip) or combopoints() >= 4 and spell(ferocious_bite) or { not target.debuffpresent(adaptive_swarm_damage) and not inflighttotarget(adaptive_swarm_damage) and { not target.debuffpresent(adaptive_swarm) or target.debuffremaining(adaptive_swarm) > 3 } or target.debuffstacks(adaptive_swarm_damage) < 3 and target.debuffremaining(adaptive_swarm_damage) < 5 and target.debuffpresent(adaptive_swarm_damage) } and spell(adaptive_swarm) or target.debuffrefreshable(rake_debuff) and combopoints() < 4 and spell(rake) or spell(shred)
}

### actions.bear

AddFunction guardianbearmainactions
{
 #bear_form,if=!buff.bear_form.up
 if not buffpresent(bear_form) spell(bear_form)
 #incarnation,if=(buff.ravenous_frenzy.up|!covenant.venthyr)
 if buffpresent(ravenous_frenzy) or not iscovenant("venthyr") spell(incarnation)
 #adaptive_swarm,if=(!dot.adaptive_swarm_damage.ticking&!action.adaptive_swarm_damage.in_flight&(!dot.adaptive_swarm_heal.ticking|dot.adaptive_swarm_heal.remains>3)|dot.adaptive_swarm_damage.stack<3&dot.adaptive_swarm_damage.remains<5&dot.adaptive_swarm_damage.ticking)
 if not target.debuffpresent(adaptive_swarm_damage) and not inflighttotarget(adaptive_swarm_damage) and { not target.debuffpresent(adaptive_swarm) or target.debuffremaining(adaptive_swarm) > 3 } or target.debuffstacks(adaptive_swarm_damage) < 3 and target.debuffremaining(adaptive_swarm_damage) < 5 and target.debuffpresent(adaptive_swarm_damage) spell(adaptive_swarm)
 #thrash_bear,target_if=refreshable|dot.thrash_bear.stack<3|(dot.thrash_bear.stack<4&runeforge.luffainfused_embrace.equipped)|active_enemies>=4
 if target.refreshable(thrash_bear_debuff) or target.debuffstacks(thrash_bear_debuff) < 3 or target.debuffstacks(thrash_bear_debuff) < 4 and equippedruneforge(luffainfused_embrace_runeforge) or enemies() >= 4 spell(thrash_bear)
 #moonfire,if=((buff.galactic_guardian.up)&active_enemies<2)|((buff.galactic_guardian.up)&!dot.moonfire.ticking&active_enemies>1&target.time_to_die>12)
 if buffpresent(galactic_guardian_buff) and enemies() < 2 or buffpresent(galactic_guardian_buff) and not target.debuffpresent(moonfire_debuff) and enemies() > 1 and target.timetodie() > 12 spell(moonfire)
 #moonfire,if=(dot.moonfire.remains<=3&(buff.galactic_guardian.up)&active_enemies>5&target.time_to_die>12)
 if target.debuffremaining(moonfire_debuff) <= 3 and buffpresent(galactic_guardian_buff) and enemies() > 5 and target.timetodie() > 12 spell(moonfire)
 #moonfire,if=(refreshable&active_enemies<2&target.time_to_die>12)|(!dot.moonfire.ticking&active_enemies>1&target.time_to_die>12)
 if target.refreshable(moonfire_debuff) and enemies() < 2 and target.timetodie() > 12 or not target.debuffpresent(moonfire_debuff) and enemies() > 1 and target.timetodie() > 12 spell(moonfire)
 #swipe,if=buff.incarnation_guardian_of_ursoc.down&buff.berserk_bear.down&active_enemies>=4
 if buffexpires(incarnation_guardian_of_ursoc) and buffexpires(berserk_bear) and enemies() >= 4 spell(swipe)
 #maul,if=buff.incarnation.up&active_enemies<2
 if buffpresent(incarnation_buff) and enemies() < 2 spell(maul)
 #maul,if=(buff.savage_combatant.stack>=1)&(buff.tooth_and_claw.up)&buff.incarnation.up&active_enemies=2
 if buffstacks(savage_combatant_buff) >= 1 and buffpresent(tooth_and_claw_buff) and buffpresent(incarnation_buff) and enemies() == 2 spell(maul)
 #mangle,if=buff.incarnation.up&active_enemies<=3
 if buffpresent(incarnation_buff) and enemies() <= 3 spell(mangle)
 #maul,if=(((buff.tooth_and_claw.stack>=2)|(buff.tooth_and_claw.up&buff.tooth_and_claw.remains<1.5)|(buff.savage_combatant.stack>=3))&active_enemies<3)
 if { buffstacks(tooth_and_claw_buff) >= 2 or buffpresent(tooth_and_claw_buff) and buffremaining(tooth_and_claw_buff) < 1.5 or buffstacks(savage_combatant_buff) >= 3 } and enemies() < 3 spell(maul)
 #thrash_bear,if=active_enemies>1
 if enemies() > 1 spell(thrash_bear)
 #mangle,if=((rage<90)&active_enemies<3)|((rage<85)&active_enemies<3&talent.soul_of_the_forest.enabled)
 if rage() < 90 and enemies() < 3 or rage() < 85 and enemies() < 3 and hastalent(soul_of_the_forest_talent_guardian) spell(mangle)
 #thrash_bear
 spell(thrash_bear)
 #maul,if=active_enemies<3
 if enemies() < 3 spell(maul)
 #swipe_bear
 spell(swipe)
 #ironfur,if=rage.deficit<40&buff.ironfur.remains<0.5
 if ragedeficit() < 40 and buffremaining(ironfur) < 0.5 spell(ironfur)
}

AddFunction guardianbearmainpostconditions
{
}

AddFunction guardianbearshortcdactions
{
 unless not buffpresent(bear_form) and spell(bear_form) or { buffpresent(ravenous_frenzy) or not iscovenant("venthyr") } and spell(incarnation)
 {
  #empower_bond,if=(!druid.catweave_bear&!druid.owlweave_bear)|active_enemies>=2
  if not checkboxon("catweave_bear") and not checkboxon("owlweave_bear") or enemies() >= 2 spell(empower_bond)
  #barkskin,if=talent.brambles.enabled
  if hastalent(brambles_talent) spell(barkskin)

  unless { not target.debuffpresent(adaptive_swarm_damage) and not inflighttotarget(adaptive_swarm_damage) and { not target.debuffpresent(adaptive_swarm) or target.debuffremaining(adaptive_swarm) > 3 } or target.debuffstacks(adaptive_swarm_damage) < 3 and target.debuffremaining(adaptive_swarm_damage) < 5 and target.debuffpresent(adaptive_swarm_damage) } and spell(adaptive_swarm) or { target.refreshable(thrash_bear_debuff) or target.debuffstacks(thrash_bear_debuff) < 3 or target.debuffstacks(thrash_bear_debuff) < 4 and equippedruneforge(luffainfused_embrace_runeforge) or enemies() >= 4 } and spell(thrash_bear) or { buffpresent(galactic_guardian_buff) and enemies() < 2 or buffpresent(galactic_guardian_buff) and not target.debuffpresent(moonfire_debuff) and enemies() > 1 and target.timetodie() > 12 } and spell(moonfire) or target.debuffremaining(moonfire_debuff) <= 3 and buffpresent(galactic_guardian_buff) and enemies() > 5 and target.timetodie() > 12 and spell(moonfire) or { target.refreshable(moonfire_debuff) and enemies() < 2 and target.timetodie() > 12 or not target.debuffpresent(moonfire_debuff) and enemies() > 1 and target.timetodie() > 12 } and spell(moonfire) or buffexpires(incarnation_guardian_of_ursoc) and buffexpires(berserk_bear) and enemies() >= 4 and spell(swipe) or buffpresent(incarnation_buff) and enemies() < 2 and spell(maul) or buffstacks(savage_combatant_buff) >= 1 and buffpresent(tooth_and_claw_buff) and buffpresent(incarnation_buff) and enemies() == 2 and spell(maul) or buffpresent(incarnation_buff) and enemies() <= 3 and spell(mangle) or { buffstacks(tooth_and_claw_buff) >= 2 or buffpresent(tooth_and_claw_buff) and buffremaining(tooth_and_claw_buff) < 1.5 or buffstacks(savage_combatant_buff) >= 3 } and enemies() < 3 and spell(maul) or enemies() > 1 and spell(thrash_bear) or { rage() < 90 and enemies() < 3 or rage() < 85 and enemies() < 3 and hastalent(soul_of_the_forest_talent_guardian) } and spell(mangle)
  {
   #pulverize,target_if=dot.thrash_bear.stack>2
   if target.debuffstacks(thrash_bear_debuff) > 2 spell(pulverize)
  }
 }
}

AddFunction guardianbearshortcdpostconditions
{
 not buffpresent(bear_form) and spell(bear_form) or { buffpresent(ravenous_frenzy) or not iscovenant("venthyr") } and spell(incarnation) or { not target.debuffpresent(adaptive_swarm_damage) and not inflighttotarget(adaptive_swarm_damage) and { not target.debuffpresent(adaptive_swarm) or target.debuffremaining(adaptive_swarm) > 3 } or target.debuffstacks(adaptive_swarm_damage) < 3 and target.debuffremaining(adaptive_swarm_damage) < 5 and target.debuffpresent(adaptive_swarm_damage) } and spell(adaptive_swarm) or { target.refreshable(thrash_bear_debuff) or target.debuffstacks(thrash_bear_debuff) < 3 or target.debuffstacks(thrash_bear_debuff) < 4 and equippedruneforge(luffainfused_embrace_runeforge) or enemies() >= 4 } and spell(thrash_bear) or { buffpresent(galactic_guardian_buff) and enemies() < 2 or buffpresent(galactic_guardian_buff) and not target.debuffpresent(moonfire_debuff) and enemies() > 1 and target.timetodie() > 12 } and spell(moonfire) or target.debuffremaining(moonfire_debuff) <= 3 and buffpresent(galactic_guardian_buff) and enemies() > 5 and target.timetodie() > 12 and spell(moonfire) or { target.refreshable(moonfire_debuff) and enemies() < 2 and target.timetodie() > 12 or not target.debuffpresent(moonfire_debuff) and enemies() > 1 and target.timetodie() > 12 } and spell(moonfire) or buffexpires(incarnation_guardian_of_ursoc) and buffexpires(berserk_bear) and enemies() >= 4 and spell(swipe) or buffpresent(incarnation_buff) and enemies() < 2 and spell(maul) or buffstacks(savage_combatant_buff) >= 1 and buffpresent(tooth_and_claw_buff) and buffpresent(incarnation_buff) and enemies() == 2 and spell(maul) or buffpresent(incarnation_buff) and enemies() <= 3 and spell(mangle) or { buffstacks(tooth_and_claw_buff) >= 2 or buffpresent(tooth_and_claw_buff) and buffremaining(tooth_and_claw_buff) < 1.5 or buffstacks(savage_combatant_buff) >= 3 } and enemies() < 3 and spell(maul) or enemies() > 1 and spell(thrash_bear) or { rage() < 90 and enemies() < 3 or rage() < 85 and enemies() < 3 and hastalent(soul_of_the_forest_talent_guardian) } and spell(mangle) or spell(thrash_bear) or enemies() < 3 and spell(maul) or spell(swipe) or ragedeficit() < 40 and buffremaining(ironfur) < 0.5 and spell(ironfur)
}

AddFunction guardianbearcdactions
{
 unless not buffpresent(bear_form) and spell(bear_form)
 {
  #ravenous_frenzy
  spell(ravenous_frenzy)
  #convoke_the_spirits,if=!druid.catweave_bear&!druid.owlweave_bear
  if not checkboxon("catweave_bear") and not checkboxon("owlweave_bear") spell(convoke_the_spirits)
  #berserk_bear,if=(buff.ravenous_frenzy.up|!covenant.venthyr)
  if buffpresent(ravenous_frenzy) or not iscovenant("venthyr") spell(berserk_bear)
 }
}

AddFunction guardianbearcdpostconditions
{
 not buffpresent(bear_form) and spell(bear_form) or { buffpresent(ravenous_frenzy) or not iscovenant("venthyr") } and spell(incarnation) or { not checkboxon("catweave_bear") and not checkboxon("owlweave_bear") or enemies() >= 2 } and spell(empower_bond) or hastalent(brambles_talent) and spell(barkskin) or { not target.debuffpresent(adaptive_swarm_damage) and not inflighttotarget(adaptive_swarm_damage) and { not target.debuffpresent(adaptive_swarm) or target.debuffremaining(adaptive_swarm) > 3 } or target.debuffstacks(adaptive_swarm_damage) < 3 and target.debuffremaining(adaptive_swarm_damage) < 5 and target.debuffpresent(adaptive_swarm_damage) } and spell(adaptive_swarm) or { target.refreshable(thrash_bear_debuff) or target.debuffstacks(thrash_bear_debuff) < 3 or target.debuffstacks(thrash_bear_debuff) < 4 and equippedruneforge(luffainfused_embrace_runeforge) or enemies() >= 4 } and spell(thrash_bear) or { buffpresent(galactic_guardian_buff) and enemies() < 2 or buffpresent(galactic_guardian_buff) and not target.debuffpresent(moonfire_debuff) and enemies() > 1 and target.timetodie() > 12 } and spell(moonfire) or target.debuffremaining(moonfire_debuff) <= 3 and buffpresent(galactic_guardian_buff) and enemies() > 5 and target.timetodie() > 12 and spell(moonfire) or { target.refreshable(moonfire_debuff) and enemies() < 2 and target.timetodie() > 12 or not target.debuffpresent(moonfire_debuff) and enemies() > 1 and target.timetodie() > 12 } and spell(moonfire) or buffexpires(incarnation_guardian_of_ursoc) and buffexpires(berserk_bear) and enemies() >= 4 and spell(swipe) or buffpresent(incarnation_buff) and enemies() < 2 and spell(maul) or buffstacks(savage_combatant_buff) >= 1 and buffpresent(tooth_and_claw_buff) and buffpresent(incarnation_buff) and enemies() == 2 and spell(maul) or buffpresent(incarnation_buff) and enemies() <= 3 and spell(mangle) or { buffstacks(tooth_and_claw_buff) >= 2 or buffpresent(tooth_and_claw_buff) and buffremaining(tooth_and_claw_buff) < 1.5 or buffstacks(savage_combatant_buff) >= 3 } and enemies() < 3 and spell(maul) or enemies() > 1 and spell(thrash_bear) or { rage() < 90 and enemies() < 3 or rage() < 85 and enemies() < 3 and hastalent(soul_of_the_forest_talent_guardian) } and spell(mangle) or target.debuffstacks(thrash_bear_debuff) > 2 and spell(pulverize) or spell(thrash_bear) or enemies() < 3 and spell(maul) or spell(swipe) or ragedeficit() < 40 and buffremaining(ironfur) < 0.5 and spell(ironfur)
}

### actions.default

AddFunction guardian_defaultmainactions
{
 #run_action_list,name=catweave,if=druid.catweave_bear&((cooldown.thrash_bear.remains>0&cooldown.mangle.remains>0&dot.moonfire.remains>=gcd+0.5&rage<40&buff.incarnation_guardian_of_ursoc.down&buff.berserk_bear.down&buff.galactic_guardian.down)|(buff.cat_form.up&energy>25)|(runeforge.oath_of_the_elder_druid.equipped&!buff.oath_of_the_elder_druid.up&(buff.cat_form.up&energy>20))|(covenant.kyrian&cooldown.empower_bond.remains<=1&active_enemies<2))
 if checkboxon("catweave_bear") and { spellcooldown(thrash_bear) > 0 and spellcooldown(mangle) > 0 and target.debuffremaining(moonfire_debuff) >= gcd() + 0.5 and rage() < 40 and buffexpires(incarnation_guardian_of_ursoc) and buffexpires(berserk_bear) and buffexpires(galactic_guardian_buff) or buffpresent(cat_form) and energy() > 25 or equippedruneforge(oath_of_the_elder_druid_runeforge) and not buffpresent(oath_of_the_elder_druid_buff) and buffpresent(cat_form) and energy() > 20 or iscovenant("kyrian") and spellcooldown(empower_bond) <= 1 and enemies() < 2 } guardiancatweavemainactions()

 unless checkboxon("catweave_bear") and { spellcooldown(thrash_bear) > 0 and spellcooldown(mangle) > 0 and target.debuffremaining(moonfire_debuff) >= gcd() + 0.5 and rage() < 40 and buffexpires(incarnation_guardian_of_ursoc) and buffexpires(berserk_bear) and buffexpires(galactic_guardian_buff) or buffpresent(cat_form) and energy() > 25 or equippedruneforge(oath_of_the_elder_druid_runeforge) and not buffpresent(oath_of_the_elder_druid_buff) and buffpresent(cat_form) and energy() > 20 or iscovenant("kyrian") and spellcooldown(empower_bond) <= 1 and enemies() < 2 } and guardiancatweavemainpostconditions()
 {
  #run_action_list,name=owlweave,if=druid.owlweave_bear&((cooldown.thrash_bear.remains>0&cooldown.mangle.remains>0&rage<15&buff.incarnation.down&buff.berserk_bear.down&buff.galactic_guardian.down)|(buff.moonkin_form.up&dot.sunfire.refreshable)|(buff.moonkin_form.up&buff.heart_of_the_wild.up)|(runeforge.oath_of_the_elder_druid.equipped&!buff.oath_of_the_elder_druid.up)|(covenant.night_fae&cooldown.convoke_the_spirits.remains<=1)|(covenant.kyrian&cooldown.empower_bond.remains<=1&active_enemies<2))
  if checkboxon("owlweave_bear") and { spellcooldown(thrash_bear) > 0 and spellcooldown(mangle) > 0 and rage() < 15 and buffexpires(incarnation_buff) and buffexpires(berserk_bear) and buffexpires(galactic_guardian_buff) or buffpresent(moonkin_form) and target.debuffrefreshable(sunfire_debuff) or buffpresent(moonkin_form) and buffpresent(heart_of_the_wild) or equippedruneforge(oath_of_the_elder_druid_runeforge) and not buffpresent(oath_of_the_elder_druid_buff) or iscovenant("night_fae") and spellcooldown(convoke_the_spirits) <= 1 or iscovenant("kyrian") and spellcooldown(empower_bond) <= 1 and enemies() < 2 } guardianowlweavemainactions()

  unless checkboxon("owlweave_bear") and { spellcooldown(thrash_bear) > 0 and spellcooldown(mangle) > 0 and rage() < 15 and buffexpires(incarnation_buff) and buffexpires(berserk_bear) and buffexpires(galactic_guardian_buff) or buffpresent(moonkin_form) and target.debuffrefreshable(sunfire_debuff) or buffpresent(moonkin_form) and buffpresent(heart_of_the_wild) or equippedruneforge(oath_of_the_elder_druid_runeforge) and not buffpresent(oath_of_the_elder_druid_buff) or iscovenant("night_fae") and spellcooldown(convoke_the_spirits) <= 1 or iscovenant("kyrian") and spellcooldown(empower_bond) <= 1 and enemies() < 2 } and guardianowlweavemainpostconditions()
  {
   #run_action_list,name=lycarao,if=((runeforge.lycaras_fleeting_glimpse.equipped)&(talent.balance_affinity.enabled)&(buff.lycaras_fleeting_glimpse.up)&(buff.lycaras_fleeting_glimpse.remains<=2))
   if equippedruneforge(lycaras_fleeting_glimpse_runeforge) and hastalent(balance_affinity_talent) and buffpresent(lycaras_fleeting_glimpse_buff) and buffremaining(lycaras_fleeting_glimpse_buff) <= 2 guardianlycaraomainactions()

   unless equippedruneforge(lycaras_fleeting_glimpse_runeforge) and hastalent(balance_affinity_talent) and buffpresent(lycaras_fleeting_glimpse_buff) and buffremaining(lycaras_fleeting_glimpse_buff) <= 2 and guardianlycaraomainpostconditions()
   {
    #run_action_list,name=lycarac,if=((runeforge.lycaras_fleeting_glimpse.equipped)&(talent.feral_affinity.enabled)&(buff.lycaras_fleeting_glimpse.up)&(buff.lycaras_fleeting_glimpse.remains<=2))
    if equippedruneforge(lycaras_fleeting_glimpse_runeforge) and hastalent(feral_affinity_talent_guardian) and buffpresent(lycaras_fleeting_glimpse_buff) and buffremaining(lycaras_fleeting_glimpse_buff) <= 2 guardianlycaracmainactions()

    unless equippedruneforge(lycaras_fleeting_glimpse_runeforge) and hastalent(feral_affinity_talent_guardian) and buffpresent(lycaras_fleeting_glimpse_buff) and buffremaining(lycaras_fleeting_glimpse_buff) <= 2 and guardianlycaracmainpostconditions()
    {
     #run_action_list,name=oconvoke,if=((talent.balance_affinity.enabled)&(!druid.catweave_bear)&(!druid.owlweave_bear)&(covenant.night_fae&cooldown.convoke_the_spirits.remains<=1))
     if hastalent(balance_affinity_talent) and not checkboxon("catweave_bear") and not checkboxon("owlweave_bear") and iscovenant("night_fae") and spellcooldown(convoke_the_spirits) <= 1 guardianoconvokemainactions()

     unless hastalent(balance_affinity_talent) and not checkboxon("catweave_bear") and not checkboxon("owlweave_bear") and iscovenant("night_fae") and spellcooldown(convoke_the_spirits) <= 1 and guardianoconvokemainpostconditions()
     {
      #run_action_list,name=cconvoke,if=((talent.feral_affinity.enabled)&(!druid.catweave_bear)&(!druid.owlweave_bear)&(covenant.night_fae&cooldown.convoke_the_spirits.remains<=1))
      if hastalent(feral_affinity_talent_guardian) and not checkboxon("catweave_bear") and not checkboxon("owlweave_bear") and iscovenant("night_fae") and spellcooldown(convoke_the_spirits) <= 1 guardiancconvokemainactions()

      unless hastalent(feral_affinity_talent_guardian) and not checkboxon("catweave_bear") and not checkboxon("owlweave_bear") and iscovenant("night_fae") and spellcooldown(convoke_the_spirits) <= 1 and guardiancconvokemainpostconditions()
      {
       #run_action_list,name=bear
       guardianbearmainactions()
      }
     }
    }
   }
  }
 }
}

AddFunction guardian_defaultmainpostconditions
{
 checkboxon("catweave_bear") and { spellcooldown(thrash_bear) > 0 and spellcooldown(mangle) > 0 and target.debuffremaining(moonfire_debuff) >= gcd() + 0.5 and rage() < 40 and buffexpires(incarnation_guardian_of_ursoc) and buffexpires(berserk_bear) and buffexpires(galactic_guardian_buff) or buffpresent(cat_form) and energy() > 25 or equippedruneforge(oath_of_the_elder_druid_runeforge) and not buffpresent(oath_of_the_elder_druid_buff) and buffpresent(cat_form) and energy() > 20 or iscovenant("kyrian") and spellcooldown(empower_bond) <= 1 and enemies() < 2 } and guardiancatweavemainpostconditions() or checkboxon("owlweave_bear") and { spellcooldown(thrash_bear) > 0 and spellcooldown(mangle) > 0 and rage() < 15 and buffexpires(incarnation_buff) and buffexpires(berserk_bear) and buffexpires(galactic_guardian_buff) or buffpresent(moonkin_form) and target.debuffrefreshable(sunfire_debuff) or buffpresent(moonkin_form) and buffpresent(heart_of_the_wild) or equippedruneforge(oath_of_the_elder_druid_runeforge) and not buffpresent(oath_of_the_elder_druid_buff) or iscovenant("night_fae") and spellcooldown(convoke_the_spirits) <= 1 or iscovenant("kyrian") and spellcooldown(empower_bond) <= 1 and enemies() < 2 } and guardianowlweavemainpostconditions() or equippedruneforge(lycaras_fleeting_glimpse_runeforge) and hastalent(balance_affinity_talent) and buffpresent(lycaras_fleeting_glimpse_buff) and buffremaining(lycaras_fleeting_glimpse_buff) <= 2 and guardianlycaraomainpostconditions() or equippedruneforge(lycaras_fleeting_glimpse_runeforge) and hastalent(feral_affinity_talent_guardian) and buffpresent(lycaras_fleeting_glimpse_buff) and buffremaining(lycaras_fleeting_glimpse_buff) <= 2 and guardianlycaracmainpostconditions() or hastalent(balance_affinity_talent) and not checkboxon("catweave_bear") and not checkboxon("owlweave_bear") and iscovenant("night_fae") and spellcooldown(convoke_the_spirits) <= 1 and guardianoconvokemainpostconditions() or hastalent(feral_affinity_talent_guardian) and not checkboxon("catweave_bear") and not checkboxon("owlweave_bear") and iscovenant("night_fae") and spellcooldown(convoke_the_spirits) <= 1 and guardiancconvokemainpostconditions() or guardianbearmainpostconditions()
}

AddFunction guardian_defaultshortcdactions
{
 #auto_attack,if=!buff.prowl.up
 if not buffpresent(prowl) guardiangetinmeleerange()
 #run_action_list,name=catweave,if=druid.catweave_bear&((cooldown.thrash_bear.remains>0&cooldown.mangle.remains>0&dot.moonfire.remains>=gcd+0.5&rage<40&buff.incarnation_guardian_of_ursoc.down&buff.berserk_bear.down&buff.galactic_guardian.down)|(buff.cat_form.up&energy>25)|(runeforge.oath_of_the_elder_druid.equipped&!buff.oath_of_the_elder_druid.up&(buff.cat_form.up&energy>20))|(covenant.kyrian&cooldown.empower_bond.remains<=1&active_enemies<2))
 if checkboxon("catweave_bear") and { spellcooldown(thrash_bear) > 0 and spellcooldown(mangle) > 0 and target.debuffremaining(moonfire_debuff) >= gcd() + 0.5 and rage() < 40 and buffexpires(incarnation_guardian_of_ursoc) and buffexpires(berserk_bear) and buffexpires(galactic_guardian_buff) or buffpresent(cat_form) and energy() > 25 or equippedruneforge(oath_of_the_elder_druid_runeforge) and not buffpresent(oath_of_the_elder_druid_buff) and buffpresent(cat_form) and energy() > 20 or iscovenant("kyrian") and spellcooldown(empower_bond) <= 1 and enemies() < 2 } guardiancatweaveshortcdactions()

 unless checkboxon("catweave_bear") and { spellcooldown(thrash_bear) > 0 and spellcooldown(mangle) > 0 and target.debuffremaining(moonfire_debuff) >= gcd() + 0.5 and rage() < 40 and buffexpires(incarnation_guardian_of_ursoc) and buffexpires(berserk_bear) and buffexpires(galactic_guardian_buff) or buffpresent(cat_form) and energy() > 25 or equippedruneforge(oath_of_the_elder_druid_runeforge) and not buffpresent(oath_of_the_elder_druid_buff) and buffpresent(cat_form) and energy() > 20 or iscovenant("kyrian") and spellcooldown(empower_bond) <= 1 and enemies() < 2 } and guardiancatweaveshortcdpostconditions()
 {
  #run_action_list,name=owlweave,if=druid.owlweave_bear&((cooldown.thrash_bear.remains>0&cooldown.mangle.remains>0&rage<15&buff.incarnation.down&buff.berserk_bear.down&buff.galactic_guardian.down)|(buff.moonkin_form.up&dot.sunfire.refreshable)|(buff.moonkin_form.up&buff.heart_of_the_wild.up)|(runeforge.oath_of_the_elder_druid.equipped&!buff.oath_of_the_elder_druid.up)|(covenant.night_fae&cooldown.convoke_the_spirits.remains<=1)|(covenant.kyrian&cooldown.empower_bond.remains<=1&active_enemies<2))
  if checkboxon("owlweave_bear") and { spellcooldown(thrash_bear) > 0 and spellcooldown(mangle) > 0 and rage() < 15 and buffexpires(incarnation_buff) and buffexpires(berserk_bear) and buffexpires(galactic_guardian_buff) or buffpresent(moonkin_form) and target.debuffrefreshable(sunfire_debuff) or buffpresent(moonkin_form) and buffpresent(heart_of_the_wild) or equippedruneforge(oath_of_the_elder_druid_runeforge) and not buffpresent(oath_of_the_elder_druid_buff) or iscovenant("night_fae") and spellcooldown(convoke_the_spirits) <= 1 or iscovenant("kyrian") and spellcooldown(empower_bond) <= 1 and enemies() < 2 } guardianowlweaveshortcdactions()

  unless checkboxon("owlweave_bear") and { spellcooldown(thrash_bear) > 0 and spellcooldown(mangle) > 0 and rage() < 15 and buffexpires(incarnation_buff) and buffexpires(berserk_bear) and buffexpires(galactic_guardian_buff) or buffpresent(moonkin_form) and target.debuffrefreshable(sunfire_debuff) or buffpresent(moonkin_form) and buffpresent(heart_of_the_wild) or equippedruneforge(oath_of_the_elder_druid_runeforge) and not buffpresent(oath_of_the_elder_druid_buff) or iscovenant("night_fae") and spellcooldown(convoke_the_spirits) <= 1 or iscovenant("kyrian") and spellcooldown(empower_bond) <= 1 and enemies() < 2 } and guardianowlweaveshortcdpostconditions()
  {
   #run_action_list,name=lycarao,if=((runeforge.lycaras_fleeting_glimpse.equipped)&(talent.balance_affinity.enabled)&(buff.lycaras_fleeting_glimpse.up)&(buff.lycaras_fleeting_glimpse.remains<=2))
   if equippedruneforge(lycaras_fleeting_glimpse_runeforge) and hastalent(balance_affinity_talent) and buffpresent(lycaras_fleeting_glimpse_buff) and buffremaining(lycaras_fleeting_glimpse_buff) <= 2 guardianlycaraoshortcdactions()

   unless equippedruneforge(lycaras_fleeting_glimpse_runeforge) and hastalent(balance_affinity_talent) and buffpresent(lycaras_fleeting_glimpse_buff) and buffremaining(lycaras_fleeting_glimpse_buff) <= 2 and guardianlycaraoshortcdpostconditions()
   {
    #run_action_list,name=lycarac,if=((runeforge.lycaras_fleeting_glimpse.equipped)&(talent.feral_affinity.enabled)&(buff.lycaras_fleeting_glimpse.up)&(buff.lycaras_fleeting_glimpse.remains<=2))
    if equippedruneforge(lycaras_fleeting_glimpse_runeforge) and hastalent(feral_affinity_talent_guardian) and buffpresent(lycaras_fleeting_glimpse_buff) and buffremaining(lycaras_fleeting_glimpse_buff) <= 2 guardianlycaracshortcdactions()

    unless equippedruneforge(lycaras_fleeting_glimpse_runeforge) and hastalent(feral_affinity_talent_guardian) and buffpresent(lycaras_fleeting_glimpse_buff) and buffremaining(lycaras_fleeting_glimpse_buff) <= 2 and guardianlycaracshortcdpostconditions()
    {
     #run_action_list,name=oconvoke,if=((talent.balance_affinity.enabled)&(!druid.catweave_bear)&(!druid.owlweave_bear)&(covenant.night_fae&cooldown.convoke_the_spirits.remains<=1))
     if hastalent(balance_affinity_talent) and not checkboxon("catweave_bear") and not checkboxon("owlweave_bear") and iscovenant("night_fae") and spellcooldown(convoke_the_spirits) <= 1 guardianoconvokeshortcdactions()

     unless hastalent(balance_affinity_talent) and not checkboxon("catweave_bear") and not checkboxon("owlweave_bear") and iscovenant("night_fae") and spellcooldown(convoke_the_spirits) <= 1 and guardianoconvokeshortcdpostconditions()
     {
      #run_action_list,name=cconvoke,if=((talent.feral_affinity.enabled)&(!druid.catweave_bear)&(!druid.owlweave_bear)&(covenant.night_fae&cooldown.convoke_the_spirits.remains<=1))
      if hastalent(feral_affinity_talent_guardian) and not checkboxon("catweave_bear") and not checkboxon("owlweave_bear") and iscovenant("night_fae") and spellcooldown(convoke_the_spirits) <= 1 guardiancconvokeshortcdactions()

      unless hastalent(feral_affinity_talent_guardian) and not checkboxon("catweave_bear") and not checkboxon("owlweave_bear") and iscovenant("night_fae") and spellcooldown(convoke_the_spirits) <= 1 and guardiancconvokeshortcdpostconditions()
      {
       #run_action_list,name=bear
       guardianbearshortcdactions()
      }
     }
    }
   }
  }
 }
}

AddFunction guardian_defaultshortcdpostconditions
{
 checkboxon("catweave_bear") and { spellcooldown(thrash_bear) > 0 and spellcooldown(mangle) > 0 and target.debuffremaining(moonfire_debuff) >= gcd() + 0.5 and rage() < 40 and buffexpires(incarnation_guardian_of_ursoc) and buffexpires(berserk_bear) and buffexpires(galactic_guardian_buff) or buffpresent(cat_form) and energy() > 25 or equippedruneforge(oath_of_the_elder_druid_runeforge) and not buffpresent(oath_of_the_elder_druid_buff) and buffpresent(cat_form) and energy() > 20 or iscovenant("kyrian") and spellcooldown(empower_bond) <= 1 and enemies() < 2 } and guardiancatweaveshortcdpostconditions() or checkboxon("owlweave_bear") and { spellcooldown(thrash_bear) > 0 and spellcooldown(mangle) > 0 and rage() < 15 and buffexpires(incarnation_buff) and buffexpires(berserk_bear) and buffexpires(galactic_guardian_buff) or buffpresent(moonkin_form) and target.debuffrefreshable(sunfire_debuff) or buffpresent(moonkin_form) and buffpresent(heart_of_the_wild) or equippedruneforge(oath_of_the_elder_druid_runeforge) and not buffpresent(oath_of_the_elder_druid_buff) or iscovenant("night_fae") and spellcooldown(convoke_the_spirits) <= 1 or iscovenant("kyrian") and spellcooldown(empower_bond) <= 1 and enemies() < 2 } and guardianowlweaveshortcdpostconditions() or equippedruneforge(lycaras_fleeting_glimpse_runeforge) and hastalent(balance_affinity_talent) and buffpresent(lycaras_fleeting_glimpse_buff) and buffremaining(lycaras_fleeting_glimpse_buff) <= 2 and guardianlycaraoshortcdpostconditions() or equippedruneforge(lycaras_fleeting_glimpse_runeforge) and hastalent(feral_affinity_talent_guardian) and buffpresent(lycaras_fleeting_glimpse_buff) and buffremaining(lycaras_fleeting_glimpse_buff) <= 2 and guardianlycaracshortcdpostconditions() or hastalent(balance_affinity_talent) and not checkboxon("catweave_bear") and not checkboxon("owlweave_bear") and iscovenant("night_fae") and spellcooldown(convoke_the_spirits) <= 1 and guardianoconvokeshortcdpostconditions() or hastalent(feral_affinity_talent_guardian) and not checkboxon("catweave_bear") and not checkboxon("owlweave_bear") and iscovenant("night_fae") and spellcooldown(convoke_the_spirits) <= 1 and guardiancconvokeshortcdpostconditions() or guardianbearshortcdpostconditions()
}

AddFunction guardian_defaultcdactions
{
 guardianinterruptactions()
 #use_items,if=!buff.prowl.up
 if not buffpresent(prowl) guardianuseitemactions()
 #potion,if=(((talent.heart_of_the_wild.enabled&buff.heart_of_the_wild.up)&(druid.catweave_bear|druid.owlweave_bear)&!buff.prowl.up)|((buff.berserk_bear.up|buff.incarnation_guardian_of_ursoc.up)&(!druid.catweave_bear&!druid.owlweave_bear)))
 if { hastalent(heart_of_the_wild_talent) and buffpresent(heart_of_the_wild) and { checkboxon("catweave_bear") or checkboxon("owlweave_bear") } and not buffpresent(prowl) or { buffpresent(berserk_bear) or buffpresent(incarnation_guardian_of_ursoc) } and not checkboxon("catweave_bear") and not checkboxon("owlweave_bear") } and { checkboxon(opt_use_consumables) and target.classification(worldboss) } item(potion_of_spectral_agility_item usable=1)
 #run_action_list,name=catweave,if=druid.catweave_bear&((cooldown.thrash_bear.remains>0&cooldown.mangle.remains>0&dot.moonfire.remains>=gcd+0.5&rage<40&buff.incarnation_guardian_of_ursoc.down&buff.berserk_bear.down&buff.galactic_guardian.down)|(buff.cat_form.up&energy>25)|(runeforge.oath_of_the_elder_druid.equipped&!buff.oath_of_the_elder_druid.up&(buff.cat_form.up&energy>20))|(covenant.kyrian&cooldown.empower_bond.remains<=1&active_enemies<2))
 if checkboxon("catweave_bear") and { spellcooldown(thrash_bear) > 0 and spellcooldown(mangle) > 0 and target.debuffremaining(moonfire_debuff) >= gcd() + 0.5 and rage() < 40 and buffexpires(incarnation_guardian_of_ursoc) and buffexpires(berserk_bear) and buffexpires(galactic_guardian_buff) or buffpresent(cat_form) and energy() > 25 or equippedruneforge(oath_of_the_elder_druid_runeforge) and not buffpresent(oath_of_the_elder_druid_buff) and buffpresent(cat_form) and energy() > 20 or iscovenant("kyrian") and spellcooldown(empower_bond) <= 1 and enemies() < 2 } guardiancatweavecdactions()

 unless checkboxon("catweave_bear") and { spellcooldown(thrash_bear) > 0 and spellcooldown(mangle) > 0 and target.debuffremaining(moonfire_debuff) >= gcd() + 0.5 and rage() < 40 and buffexpires(incarnation_guardian_of_ursoc) and buffexpires(berserk_bear) and buffexpires(galactic_guardian_buff) or buffpresent(cat_form) and energy() > 25 or equippedruneforge(oath_of_the_elder_druid_runeforge) and not buffpresent(oath_of_the_elder_druid_buff) and buffpresent(cat_form) and energy() > 20 or iscovenant("kyrian") and spellcooldown(empower_bond) <= 1 and enemies() < 2 } and guardiancatweavecdpostconditions()
 {
  #run_action_list,name=owlweave,if=druid.owlweave_bear&((cooldown.thrash_bear.remains>0&cooldown.mangle.remains>0&rage<15&buff.incarnation.down&buff.berserk_bear.down&buff.galactic_guardian.down)|(buff.moonkin_form.up&dot.sunfire.refreshable)|(buff.moonkin_form.up&buff.heart_of_the_wild.up)|(runeforge.oath_of_the_elder_druid.equipped&!buff.oath_of_the_elder_druid.up)|(covenant.night_fae&cooldown.convoke_the_spirits.remains<=1)|(covenant.kyrian&cooldown.empower_bond.remains<=1&active_enemies<2))
  if checkboxon("owlweave_bear") and { spellcooldown(thrash_bear) > 0 and spellcooldown(mangle) > 0 and rage() < 15 and buffexpires(incarnation_buff) and buffexpires(berserk_bear) and buffexpires(galactic_guardian_buff) or buffpresent(moonkin_form) and target.debuffrefreshable(sunfire_debuff) or buffpresent(moonkin_form) and buffpresent(heart_of_the_wild) or equippedruneforge(oath_of_the_elder_druid_runeforge) and not buffpresent(oath_of_the_elder_druid_buff) or iscovenant("night_fae") and spellcooldown(convoke_the_spirits) <= 1 or iscovenant("kyrian") and spellcooldown(empower_bond) <= 1 and enemies() < 2 } guardianowlweavecdactions()

  unless checkboxon("owlweave_bear") and { spellcooldown(thrash_bear) > 0 and spellcooldown(mangle) > 0 and rage() < 15 and buffexpires(incarnation_buff) and buffexpires(berserk_bear) and buffexpires(galactic_guardian_buff) or buffpresent(moonkin_form) and target.debuffrefreshable(sunfire_debuff) or buffpresent(moonkin_form) and buffpresent(heart_of_the_wild) or equippedruneforge(oath_of_the_elder_druid_runeforge) and not buffpresent(oath_of_the_elder_druid_buff) or iscovenant("night_fae") and spellcooldown(convoke_the_spirits) <= 1 or iscovenant("kyrian") and spellcooldown(empower_bond) <= 1 and enemies() < 2 } and guardianowlweavecdpostconditions()
  {
   #run_action_list,name=lycarao,if=((runeforge.lycaras_fleeting_glimpse.equipped)&(talent.balance_affinity.enabled)&(buff.lycaras_fleeting_glimpse.up)&(buff.lycaras_fleeting_glimpse.remains<=2))
   if equippedruneforge(lycaras_fleeting_glimpse_runeforge) and hastalent(balance_affinity_talent) and buffpresent(lycaras_fleeting_glimpse_buff) and buffremaining(lycaras_fleeting_glimpse_buff) <= 2 guardianlycaraocdactions()

   unless equippedruneforge(lycaras_fleeting_glimpse_runeforge) and hastalent(balance_affinity_talent) and buffpresent(lycaras_fleeting_glimpse_buff) and buffremaining(lycaras_fleeting_glimpse_buff) <= 2 and guardianlycaraocdpostconditions()
   {
    #run_action_list,name=lycarac,if=((runeforge.lycaras_fleeting_glimpse.equipped)&(talent.feral_affinity.enabled)&(buff.lycaras_fleeting_glimpse.up)&(buff.lycaras_fleeting_glimpse.remains<=2))
    if equippedruneforge(lycaras_fleeting_glimpse_runeforge) and hastalent(feral_affinity_talent_guardian) and buffpresent(lycaras_fleeting_glimpse_buff) and buffremaining(lycaras_fleeting_glimpse_buff) <= 2 guardianlycaraccdactions()

    unless equippedruneforge(lycaras_fleeting_glimpse_runeforge) and hastalent(feral_affinity_talent_guardian) and buffpresent(lycaras_fleeting_glimpse_buff) and buffremaining(lycaras_fleeting_glimpse_buff) <= 2 and guardianlycaraccdpostconditions()
    {
     #run_action_list,name=oconvoke,if=((talent.balance_affinity.enabled)&(!druid.catweave_bear)&(!druid.owlweave_bear)&(covenant.night_fae&cooldown.convoke_the_spirits.remains<=1))
     if hastalent(balance_affinity_talent) and not checkboxon("catweave_bear") and not checkboxon("owlweave_bear") and iscovenant("night_fae") and spellcooldown(convoke_the_spirits) <= 1 guardianoconvokecdactions()

     unless hastalent(balance_affinity_talent) and not checkboxon("catweave_bear") and not checkboxon("owlweave_bear") and iscovenant("night_fae") and spellcooldown(convoke_the_spirits) <= 1 and guardianoconvokecdpostconditions()
     {
      #run_action_list,name=cconvoke,if=((talent.feral_affinity.enabled)&(!druid.catweave_bear)&(!druid.owlweave_bear)&(covenant.night_fae&cooldown.convoke_the_spirits.remains<=1))
      if hastalent(feral_affinity_talent_guardian) and not checkboxon("catweave_bear") and not checkboxon("owlweave_bear") and iscovenant("night_fae") and spellcooldown(convoke_the_spirits) <= 1 guardiancconvokecdactions()

      unless hastalent(feral_affinity_talent_guardian) and not checkboxon("catweave_bear") and not checkboxon("owlweave_bear") and iscovenant("night_fae") and spellcooldown(convoke_the_spirits) <= 1 and guardiancconvokecdpostconditions()
      {
       #run_action_list,name=bear
       guardianbearcdactions()
      }
     }
    }
   }
  }
 }
}

AddFunction guardian_defaultcdpostconditions
{
 checkboxon("catweave_bear") and { spellcooldown(thrash_bear) > 0 and spellcooldown(mangle) > 0 and target.debuffremaining(moonfire_debuff) >= gcd() + 0.5 and rage() < 40 and buffexpires(incarnation_guardian_of_ursoc) and buffexpires(berserk_bear) and buffexpires(galactic_guardian_buff) or buffpresent(cat_form) and energy() > 25 or equippedruneforge(oath_of_the_elder_druid_runeforge) and not buffpresent(oath_of_the_elder_druid_buff) and buffpresent(cat_form) and energy() > 20 or iscovenant("kyrian") and spellcooldown(empower_bond) <= 1 and enemies() < 2 } and guardiancatweavecdpostconditions() or checkboxon("owlweave_bear") and { spellcooldown(thrash_bear) > 0 and spellcooldown(mangle) > 0 and rage() < 15 and buffexpires(incarnation_buff) and buffexpires(berserk_bear) and buffexpires(galactic_guardian_buff) or buffpresent(moonkin_form) and target.debuffrefreshable(sunfire_debuff) or buffpresent(moonkin_form) and buffpresent(heart_of_the_wild) or equippedruneforge(oath_of_the_elder_druid_runeforge) and not buffpresent(oath_of_the_elder_druid_buff) or iscovenant("night_fae") and spellcooldown(convoke_the_spirits) <= 1 or iscovenant("kyrian") and spellcooldown(empower_bond) <= 1 and enemies() < 2 } and guardianowlweavecdpostconditions() or equippedruneforge(lycaras_fleeting_glimpse_runeforge) and hastalent(balance_affinity_talent) and buffpresent(lycaras_fleeting_glimpse_buff) and buffremaining(lycaras_fleeting_glimpse_buff) <= 2 and guardianlycaraocdpostconditions() or equippedruneforge(lycaras_fleeting_glimpse_runeforge) and hastalent(feral_affinity_talent_guardian) and buffpresent(lycaras_fleeting_glimpse_buff) and buffremaining(lycaras_fleeting_glimpse_buff) <= 2 and guardianlycaraccdpostconditions() or hastalent(balance_affinity_talent) and not checkboxon("catweave_bear") and not checkboxon("owlweave_bear") and iscovenant("night_fae") and spellcooldown(convoke_the_spirits) <= 1 and guardianoconvokecdpostconditions() or hastalent(feral_affinity_talent_guardian) and not checkboxon("catweave_bear") and not checkboxon("owlweave_bear") and iscovenant("night_fae") and spellcooldown(convoke_the_spirits) <= 1 and guardiancconvokecdpostconditions() or guardianbearcdpostconditions()
}

### Guardian icons.

AddCheckBox(opt_druid_guardian_aoe l(aoe) default enabled=(specialization(guardian)))

AddIcon enabled=(not checkboxon(opt_druid_guardian_aoe) and specialization(guardian)) enemies=1 help=shortcd
{
 if not incombat() guardianprecombatshortcdactions()
 guardian_defaultshortcdactions()
}

AddIcon enabled=(checkboxon(opt_druid_guardian_aoe) and specialization(guardian)) help=shortcd
{
 if not incombat() guardianprecombatshortcdactions()
 guardian_defaultshortcdactions()
}

AddIcon enabled=(specialization(guardian)) enemies=1 help=main
{
 if not incombat() guardianprecombatmainactions()
 guardian_defaultmainactions()
}

AddIcon enabled=(checkboxon(opt_druid_guardian_aoe) and specialization(guardian)) help=aoe
{
 if not incombat() guardianprecombatmainactions()
 guardian_defaultmainactions()
}

AddIcon enabled=(not checkboxon(opt_druid_guardian_aoe) and specialization(guardian)) enemies=1 help=cd
{
 if not incombat() guardianprecombatcdactions()
 guardian_defaultcdactions()
}

AddIcon enabled=(checkboxon(opt_druid_guardian_aoe) and specialization(guardian)) help=cd
{
 if not incombat() guardianprecombatcdactions()
 guardian_defaultcdactions()
}

### Required symbols
# adaptive_swarm
# adaptive_swarm_damage
# balance_affinity_talent
# barkskin
# bear_form
# berserk_bear
# brambles_talent
# cat_form
# convoke_the_spirits
# eclipse_lunar_buff
# eclipse_solar_buff
# empower_bond
# feral_affinity_talent_guardian
# ferocious_bite
# first_strike_soulbind
# galactic_guardian_buff
# heart_of_the_wild
# heart_of_the_wild_talent
# incapacitating_roar
# incarnation
# incarnation_buff
# incarnation_guardian_of_ursoc
# ironfur
# luffainfused_embrace_runeforge
# lycaras_fleeting_glimpse_buff
# lycaras_fleeting_glimpse_runeforge
# mangle
# maul
# mighty_bash
# moonfire
# moonfire_debuff
# moonkin_form
# oath_of_the_elder_druid_buff
# oath_of_the_elder_druid_runeforge
# potion_of_spectral_agility_item
# prowl
# pulverize
# rake
# rake_debuff
# ravenous_frenzy
# restoration_affinity_talent
# rip
# savage_combatant_buff
# shred
# skull_bash
# soul_of_the_forest_talent_guardian
# starfire
# starsurge
# starsurge_empowerment_lunar_buff
# sunfire
# sunfire_debuff
# swipe
# thrash_bear
# thrash_bear_debuff
# tooth_and_claw_buff
# typhoon
# war_stomp
# wild_charge_bear
# wild_charge_cat
# wrath
]]
        scripts:registerScript("DRUID", "guardian", name, desc, code, "script")
    end
end
